// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ArrayDataResultSet.java

package oracle.jdbc.driver;

import java.io.*;
import java.math.BigDecimal;
import java.net.URL;
import java.sql.*;
import java.util.Calendar;
import java.util.Map;
import oracle.sql.*;

// Referenced classes of package oracle.jdbc.driver:
//            BaseResultSet, PhysicalConnection, OracleConnection, DatabaseError, 
//            DBConversion

public class ArrayDataResultSet extends BaseResultSet
{

    public ArrayDataResultSet(OracleConnection oracleconnection, Datum adatum[], Map map1)
        throws SQLException
    {
        connection = (PhysicalConnection)oracleconnection;
        data = adatum;
        map = map1;
        currentIndex = 0;
        lastIndex = data != null ? data.length : 0;
        fetchSize = OracleConnection.DEFAULT_ROW_PREFETCH;
    }

    public ArrayDataResultSet(OracleConnection oracleconnection, Datum adatum[], long l, int i, Map map1)
        throws SQLException
    {
        connection = (PhysicalConnection)oracleconnection;
        data = adatum;
        map = map1;
        currentIndex = (int)l - 1;
        int j = data != null ? data.length : 0;
        lastIndex = currentIndex + Math.min(j - currentIndex, i);
        fetchSize = OracleConnection.DEFAULT_ROW_PREFETCH;
    }

    public ArrayDataResultSet(OracleConnection oracleconnection, ARRAY array1, long l, int i, Map map1)
        throws SQLException
    {
        connection = (PhysicalConnection)oracleconnection;
        array = array1;
        map = map1;
        currentIndex = (int)l - 1;
        int j = array != null ? array1.length() : 0;
        lastIndex = currentIndex + (i != -1 ? Math.min(j - currentIndex, i) : j - currentIndex);
        fetchSize = OracleConnection.DEFAULT_ROW_PREFETCH;
    }

    public boolean next()
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(10, "next");
        currentIndex++;
        return currentIndex <= lastIndex;
    }

    public synchronized void close()
        throws SQLException
    {
        closed = true;
    }

    public synchronized boolean wasNull()
        throws SQLException
    {
        if(wasNull == null)
            DatabaseError.throwSqlException(24, null);
        return wasNull.booleanValue();
    }

    public synchronized String getString(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.stringValue();
        else
            return null;
    }

    public synchronized ResultSet getCursor(int i)
        throws SQLException
    {
        DatabaseError.throwSqlException(4, "getCursor");
        return null;
    }

    public synchronized Datum getOracleObject(int i)
        throws SQLException
    {
        if(currentIndex <= 0)
            DatabaseError.throwSqlException(14, null);
        if(i == 1)
        {
            wasNull = BOOLEAN_FALSE;
            return new NUMBER(currentIndex);
        }
        if(i == 2)
        {
            if(data != null)
            {
                wasNull = data[currentIndex - 1] != null ? BOOLEAN_FALSE : BOOLEAN_TRUE;
                return data[currentIndex - 1];
            }
            if(array != null)
            {
                Datum adatum[] = array.getOracleArray(currentIndex, 1);
                if(adatum != null && adatum.length >= 1)
                {
                    wasNull = adatum[0] != null ? BOOLEAN_FALSE : BOOLEAN_TRUE;
                    return adatum[0];
                }
            }
            DatabaseError.throwSqlException(1, "Out of sync");
        }
        DatabaseError.throwSqlException(3, null);
        return null;
    }

    public synchronized ROWID getROWID(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof ROWID)
                return (ROWID)datum;
            DatabaseError.throwSqlException(4, "getROWID");
        }
        return null;
    }

    public synchronized NUMBER getNUMBER(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof NUMBER)
                return (NUMBER)datum;
            DatabaseError.throwSqlException(4, "getNUMBER");
        }
        return null;
    }

    public synchronized DATE getDATE(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof DATE)
                return (DATE)datum;
            DatabaseError.throwSqlException(4, "getDATE");
        }
        return null;
    }

    public synchronized ARRAY getARRAY(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof ARRAY)
                return (ARRAY)datum;
            DatabaseError.throwSqlException(4, "getARRAY");
        }
        return null;
    }

    public synchronized STRUCT getSTRUCT(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof STRUCT)
                return (STRUCT)datum;
            DatabaseError.throwSqlException(4, "getSTRUCT");
        }
        return null;
    }

    public synchronized OPAQUE getOPAQUE(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof OPAQUE)
                return (OPAQUE)datum;
            DatabaseError.throwSqlException(4, "getOPAQUE");
        }
        return null;
    }

    public synchronized REF getREF(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof REF)
                return (REF)datum;
            DatabaseError.throwSqlException(4, "getREF");
        }
        return null;
    }

    public synchronized CHAR getCHAR(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof CHAR)
                return (CHAR)datum;
            DatabaseError.throwSqlException(4, "getCHAR");
        }
        return null;
    }

    public synchronized RAW getRAW(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof RAW)
                return (RAW)datum;
            DatabaseError.throwSqlException(4, "getRAW");
        }
        return null;
    }

    public synchronized BLOB getBLOB(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof BLOB)
                return (BLOB)datum;
            DatabaseError.throwSqlException(4, "getBLOB");
        }
        return null;
    }

    public synchronized CLOB getCLOB(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof CLOB)
                return (CLOB)datum;
            DatabaseError.throwSqlException(4, "getCLOB");
        }
        return null;
    }

    public synchronized BFILE getBFILE(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof BFILE)
                return (BFILE)datum;
            DatabaseError.throwSqlException(4, "getBFILE");
        }
        return null;
    }

    public synchronized BFILE getBfile(int i)
        throws SQLException
    {
        return getBFILE(i);
    }

    public synchronized boolean getBoolean(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.booleanValue();
        else
            return false;
    }

    public synchronized byte getByte(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.byteValue();
        else
            return 0;
    }

    public synchronized short getShort(int i)
        throws SQLException
    {
        long l = getLong(i);
        if(l > 0x10001L || l < 0xfffffffffffefffeL)
            DatabaseError.throwSqlException(26, "getShort");
        return (short)(int)l;
    }

    public synchronized int getInt(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.intValue();
        else
            return 0;
    }

    public synchronized long getLong(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.longValue();
        else
            return 0L;
    }

    public synchronized float getFloat(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.floatValue();
        else
            return 0.0F;
    }

    public synchronized double getDouble(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.doubleValue();
        else
            return 0.0D;
    }

    public synchronized BigDecimal getBigDecimal(int i, int j)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.bigDecimalValue();
        else
            return null;
    }

    public synchronized byte[] getBytes(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof RAW)
                return ((RAW)datum).shareBytes();
            DatabaseError.throwSqlException(4, "getBytes");
        }
        return null;
    }

    public synchronized Date getDate(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.dateValue();
        else
            return null;
    }

    public synchronized Time getTime(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.timeValue();
        else
            return null;
    }

    public synchronized Timestamp getTimestamp(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.timestampValue();
        else
            return null;
    }

    public synchronized InputStream getAsciiStream(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            datum.asciiStreamValue();
        return null;
    }

    public synchronized InputStream getUnicodeStream(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            DBConversion dbconversion = connection.conversion;
            byte abyte0[] = datum.shareBytes();
            if(datum instanceof RAW)
            {
                PhysicalConnection _tmp = connection;
                return dbconversion.ConvertStream(new ByteArrayInputStream(abyte0), 3);
            }
            if(datum instanceof CHAR)
            {
                PhysicalConnection _tmp1 = connection;
                return dbconversion.ConvertStream(new ByteArrayInputStream(abyte0), 1);
            }
            DatabaseError.throwSqlException(4, "getUnicodeStream");
        }
        return null;
    }

    public synchronized InputStream getBinaryStream(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.binaryStreamValue();
        else
            return null;
    }

    public synchronized Object getObject(int i)
        throws SQLException
    {
        return getObject(i, map);
    }

    /**
     * @deprecated Method getCustomDatum is deprecated
     */

    public synchronized CustomDatum getCustomDatum(int i, CustomDatumFactory customdatumfactory)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        return customdatumfactory.create(datum, 0);
    }

    public synchronized ORAData getORAData(int i, ORADataFactory oradatafactory)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        return oradatafactory.create(datum, 0);
    }

    public synchronized ResultSetMetaData getMetaData()
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(10, "getMetaData");
        DatabaseError.throwSqlException(23, "getMetaData");
        return null;
    }

    public synchronized int findColumn(String s)
        throws SQLException
    {
        if(s.equalsIgnoreCase("index"))
            return 1;
        if(s.equalsIgnoreCase("value"))
        {
            return 2;
        } else
        {
            DatabaseError.throwSqlException(6, "get_column_index");
            return 0;
        }
    }

    public synchronized Statement getStatement()
        throws SQLException
    {
        return null;
    }

    public synchronized Object getObject(int i, Map map1)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof STRUCT)
                return ((STRUCT)datum).toJdbc(map1);
            else
                return datum.toJdbc();
        } else
        {
            return null;
        }
    }

    public synchronized Ref getRef(int i)
        throws SQLException
    {
        return getREF(i);
    }

    public synchronized Blob getBlob(int i)
        throws SQLException
    {
        return getBLOB(i);
    }

    public synchronized Clob getClob(int i)
        throws SQLException
    {
        return getCLOB(i);
    }

    public synchronized Array getArray(int i)
        throws SQLException
    {
        return getARRAY(i);
    }

    public synchronized Reader getCharacterStream(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.characterStreamValue();
        else
            return null;
    }

    public synchronized BigDecimal getBigDecimal(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.bigDecimalValue();
        else
            return null;
    }

    public synchronized Date getDate(int i, Calendar calendar)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            DATE date = null;
            if(datum instanceof DATE)
                date = (DATE)datum;
            else
                date = new DATE(datum.stringValue());
            if(date != null)
                return date.dateValue(calendar);
        }
        return null;
    }

    public synchronized Time getTime(int i, Calendar calendar)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            DATE date = null;
            if(datum instanceof DATE)
                date = (DATE)datum;
            else
                date = new DATE(datum.stringValue());
            if(date != null)
                return date.timeValue(calendar);
        }
        return null;
    }

    public synchronized Timestamp getTimestamp(int i, Calendar calendar)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            DATE date = null;
            if(datum instanceof DATE)
                date = (DATE)datum;
            else
                date = new DATE(datum.stringValue());
            if(date != null)
                return date.timestampValue(calendar);
        }
        return null;
    }

    public synchronized URL getURL(int i)
        throws SQLException
    {
        throw new SQLException("Conversion to java.net.URL not supported.");
    }

    public boolean isBeforeFirst()
        throws SQLException
    {
        return currentIndex < 1;
    }

    public boolean isAfterLast()
        throws SQLException
    {
        return currentIndex > lastIndex;
    }

    public boolean isFirst()
        throws SQLException
    {
        return currentIndex == 1;
    }

    public boolean isLast()
        throws SQLException
    {
        return currentIndex == lastIndex;
    }

    public int getRow()
        throws SQLException
    {
        return currentIndex;
    }

    public void setFetchSize(int i)
        throws SQLException
    {
        if(i < 0)
            DatabaseError.throwSqlException(68);
        else
        if(i == 0)
            fetchSize = OracleConnection.DEFAULT_ROW_PREFETCH;
        else
            fetchSize = i;
    }

    public int getFetchSize()
        throws SQLException
    {
        return fetchSize;
    }

    Datum data[];
    Map map;
    private int currentIndex;
    private int lastIndex;
    boolean closed;
    PhysicalConnection connection;
    private Boolean wasNull;
    private static Boolean BOOLEAN_TRUE = new Boolean(true);
    private static Boolean BOOLEAN_FALSE = new Boolean(false);
    private int fetchSize;
    ARRAY array;
    private static final String _Copyright_2004_Oracle_All_Rights_Reserved_ = null;
    public static final boolean TRACE = false;
    public static final boolean PRIVATE_TRACE = false;
    public static final String BUILD_DATE = "Sat_Feb__2_11:39:35_PST_2008";

}
