// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleBlobOutputStream.java

package oracle.jdbc.driver;

import java.io.IOException;
import java.io.OutputStream;
import java.sql.SQLException;
import oracle.sql.BLOB;

// Referenced classes of package oracle.jdbc.driver:
//            PhysicalConnection, DatabaseError

public class OracleBlobOutputStream extends OutputStream
{

    public OracleBlobOutputStream(BLOB blob1)
        throws SQLException
    {
        this(blob1, ((PhysicalConnection)blob1.getJavaSqlConnection()).getDefaultStreamChunkSize());
    }

    public OracleBlobOutputStream(BLOB blob1, int i)
        throws SQLException
    {
        this(blob1, i, 1L);
    }

    public OracleBlobOutputStream(BLOB blob1, int i, long l)
        throws SQLException
    {
        if(blob1 == null || i <= 0 || l < 1L)
        {
            throw new IllegalArgumentException("Illegal Arguments");
        } else
        {
            blob = blob1;
            lobOffset = l;
            buf = new byte[i];
            count = 0;
            bufSize = i;
            isClosed = false;
            return;
        }
    }

    public void write(int i)
        throws IOException
    {
        ensureOpen();
        if(count >= buf.length)
            flushBuffer();
        buf[count++] = (byte)i;
    }

    public void write(byte abyte0[], int i, int j)
        throws IOException
    {
        ensureOpen();
        int k = i;
        int l = k + Math.min(j, abyte0.length - i);
        do
        {
            if(k >= l)
                break;
            int i1 = Math.min(bufSize - count, l - k);
            System.arraycopy(abyte0, k, buf, count, i1);
            k += i1;
            count += i1;
            if(count >= bufSize)
                flushBuffer();
        } while(true);
    }

    public void flush()
        throws IOException
    {
        ensureOpen();
        flushBuffer();
    }

    public void close()
        throws IOException
    {
        flushBuffer();
        isClosed = true;
    }

    private void flushBuffer()
        throws IOException
    {
        try
        {
            if(count > 0)
            {
                if(count < buf.length)
                {
                    byte abyte0[] = new byte[count];
                    System.arraycopy(buf, 0, abyte0, 0, count);
                    lobOffset += blob.putBytes(lobOffset, abyte0);
                } else
                {
                    lobOffset += blob.putBytes(lobOffset, buf);
                }
                count = 0;
            }
        }
        catch(SQLException sqlexception)
        {
            DatabaseError.SQLToIOException(sqlexception);
        }
    }

    void ensureOpen()
        throws IOException
    {
        try
        {
            if(isClosed)
                DatabaseError.throwSqlException(57, null);
        }
        catch(SQLException sqlexception)
        {
            DatabaseError.SQLToIOException(sqlexception);
        }
    }

    long lobOffset;
    BLOB blob;
    byte buf[];
    int count;
    int bufSize;
    boolean isClosed;
    private static final String _Copyright_2004_Oracle_All_Rights_Reserved_ = null;
    public static final boolean TRACE = false;
    public static final boolean PRIVATE_TRACE = false;
    public static final String BUILD_DATE = "Sat_Feb__2_11:39:36_PST_2008";

}
