// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleClobWriter.java

package oracle.jdbc.driver;

import java.io.IOException;
import java.io.Writer;
import java.sql.SQLException;
import oracle.sql.CLOB;

// Referenced classes of package oracle.jdbc.driver:
//            PhysicalConnection, DatabaseError, DBConversion

public class OracleClobWriter extends Writer
{

    public OracleClobWriter(CLOB clob1)
        throws SQLException
    {
        this(clob1, ((PhysicalConnection)clob1.getInternalConnection()).getDefaultStreamChunkSize() / 3, 1L);
    }

    public OracleClobWriter(CLOB clob1, int i)
        throws SQLException
    {
        this(clob1, i, 1L);
    }

    public OracleClobWriter(CLOB clob1, int i, long l)
        throws SQLException
    {
        if(clob1 == null || i <= 0 || clob1.getJavaSqlConnection() == null || l < 1L)
        {
            throw new IllegalArgumentException("Illegal Arguments");
        } else
        {
            dbConversion = ((PhysicalConnection)clob1.getInternalConnection()).conversion;
            clob = clob1;
            lobOffset = l;
            charBuf = new char[i];
            nativeBuf = new byte[i * 3];
            pos = count = 0;
            chunkSize = i;
            isClosed = false;
            return;
        }
    }

    public void write(char ac[], int i, int j)
        throws IOException
    {
        synchronized(lock)
        {
            ensureOpen();
            int k = i;
            int l = k + Math.min(j, ac.length - i);
            do
            {
                if(k >= l)
                    break;
                int i1 = Math.min(chunkSize - count, l - k);
                System.arraycopy(ac, k, charBuf, count, i1);
                k += i1;
                count += i1;
                if(count >= chunkSize)
                    flushBuffer();
            } while(true);
        }
    }

    public void flush()
        throws IOException
    {
        synchronized(lock)
        {
            ensureOpen();
            flushBuffer();
        }
    }

    public void close()
        throws IOException
    {
        synchronized(lock)
        {
            flushBuffer();
            isClosed = true;
        }
    }

    private void flushBuffer()
        throws IOException
    {
        synchronized(lock)
        {
            try
            {
                if(count > 0)
                {
                    clob.setString(lobOffset, new String(charBuf, 0, count));
                    lobOffset += count;
                    count = 0;
                }
            }
            catch(SQLException sqlexception)
            {
                DatabaseError.SQLToIOException(sqlexception);
            }
        }
    }

    void ensureOpen()
        throws IOException
    {
        try
        {
            if(isClosed)
                DatabaseError.throwSqlException(57, null);
        }
        catch(SQLException sqlexception)
        {
            DatabaseError.SQLToIOException(sqlexception);
        }
    }

    DBConversion dbConversion;
    CLOB clob;
    long lobOffset;
    char charBuf[];
    byte nativeBuf[];
    int pos;
    int count;
    int chunkSize;
    boolean isClosed;
    private static final String _Copyright_2004_Oracle_All_Rights_Reserved_ = null;
    public static final boolean TRACE = false;
    public static final boolean PRIVATE_TRACE = false;
    public static final String BUILD_DATE = "Sat_Feb__2_11:39:36_PST_2008";

}
