// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleDriver.java

package oracle.jdbc.driver;

import java.security.AccessController;
import java.security.PrivilegedAction;
import java.sql.*;
import java.util.*;
import oracle.jdbc.OracleDatabaseMetaData;
import oracle.security.pki.OracleSecretStore;
import oracle.security.pki.OracleWallet;

// Referenced classes of package oracle.jdbc.driver:
//            OracleDriverExtension, PhysicalConnection, OracleSql, DatabaseError

public class OracleDriver
    implements Driver
{

    public OracleDriver()
    {
        driverExtensions = new OracleDriverExtension[4];
    }

    public Connection connect(String s, Properties properties)
        throws SQLException
    {
        if(s.regionMatches(0, "jdbc:default:connection", 0, 23))
        {
            String s1 = "jdbc:oracle:kprb";
            int j = s.length();
            if(j > 23)
                s = s1.concat(s.substring(23, s.length()));
            else
                s = s1.concat(":");
            s1 = null;
        }
        int i = oracleDriverExtensionTypeFromURL(s);
        if(i == -2)
            return null;
        if(i == -3)
            DatabaseError.throwSqlException(67);
        OracleDriverExtension oracledriverextension = null;
        oracledriverextension = driverExtensions[i];
        if(oracledriverextension == null)
            try
            {
                synchronized(this)
                {
                    if(oracledriverextension == null)
                    {
                        oracledriverextension = (OracleDriverExtension)Class.forName(driverExtensionClassNames[i]).newInstance();
                        driverExtensions[i] = oracledriverextension;
                    } else
                    {
                        oracledriverextension = driverExtensions[i];
                    }
                }
            }
            catch(Exception exception)
            {
                throw new SQLException(exception.toString());
            }
        walletLocation = properties.getProperty("oracle.net.wallet_location");
        if(walletLocation == null)
            walletLocation = getSystemProperty("oracle.net.wallet_location", null);
        Hashtable hashtable = parseUrl(s);
        if(hashtable == null)
            return null;
        String s2 = properties.getProperty("user");
        String s3 = properties.getProperty("password");
        String s4 = properties.getProperty("database");
        if(s4 == null)
            s4 = properties.getProperty("server");
        if(s2 == null)
            s2 = (String)hashtable.get("user");
        s2 = parseLoginOption(s2, properties);
        if(s3 == null)
            s3 = (String)hashtable.get("password");
        if(s4 == null)
            s4 = (String)hashtable.get("database");
        String s5 = (String)hashtable.get("protocol");
        properties.put("protocol", s5);
        if(s5 == null)
        {
            DatabaseError.throwSqlException(40, "Protocol is not specified in URL");
            return null;
        }
        if(s5.equals("oci8") || s5.equals("oci"))
            s4 = translateConnStr(s4);
        String s6 = properties.getProperty("oracle.jdbc.TcpNoDelay");
        if(s6 == null)
            s6 = getSystemProperty("oracle.jdbc.TcpNoDelay", null);
        if(s6 != null && s6.equalsIgnoreCase("true"))
            properties.put("TCP.NODELAY", "YES");
        String s7 = properties.getProperty("oracle.jdbc.ReadTimeout");
        if(s7 != null)
            properties.put("oracle.net.READ_TIMEOUT", s7);
        int k = DriverManager.getLoginTimeout();
        if(k != 0 && properties.get("oracle.net.CONNECT_TIMEOUT") == null)
            properties.put("oracle.net.CONNECT_TIMEOUT", "" + k * 1000);
        String s8 = properties.getProperty("prefetch");
        if(s8 == null)
            s8 = properties.getProperty("rowPrefetch");
        if(s8 == null)
            s8 = properties.getProperty("defaultRowPrefetch");
        if(s8 != null && Integer.parseInt(s8) <= 0)
            s8 = null;
        String s9 = properties.getProperty("batch");
        if(s9 == null)
            s9 = properties.getProperty("executeBatch");
        if(s9 == null)
            s9 = properties.getProperty("defaultExecuteBatch");
        if(s9 != null && Integer.parseInt(s9) <= 0)
            s9 = null;
        String s10 = properties.getProperty("defaultNChar");
        if(s10 == null)
            s10 = getSystemProperty("oracle.jdbc.defaultNChar", null);
        String s11 = properties.getProperty("useFetchSizeWithLongColumn");
        if(s11 == null)
            s11 = getSystemProperty("oracle.jdbc.useFetchSizeWithLongColumn", null);
        String s12 = properties.getProperty("remarks");
        if(s12 == null)
            s12 = properties.getProperty("remarksReporting");
        String s13 = properties.getProperty("synonyms");
        if(s13 == null)
            s13 = properties.getProperty("includeSynonyms");
        String s14 = properties.getProperty("restrictGetTables");
        String s15 = properties.getProperty("fixedString");
        String s16 = properties.getProperty("AccumulateBatchResult");
        if(s16 == null)
            s16 = "true";
        String s17 = properties.getProperty("disableDefineColumnType");
        if(s17 == null)
            s17 = "false";
        String s18 = properties.getProperty("oracle.jdbc.convertNcharLiterals");
        if(s18 == null)
            s18 = getSystemProperty("oracle.jdbc.convertNcharLiterals", "false");
        Enumeration enumeration = DriverManager.getDrivers();
        Object obj;
        do
        {
            if(!enumeration.hasMoreElements())
                break;
            obj = (Driver)enumeration.nextElement();
        } while(!(obj instanceof OracleDriver));
        do
        {
            if(!enumeration.hasMoreElements())
                break;
            obj = (Driver)enumeration.nextElement();
            if(obj instanceof OracleDriver)
                DriverManager.deregisterDriver(((Driver) (obj)));
        } while(true);
        obj = (PhysicalConnection)oracledriverextension.getConnection(s, s2, s3, s4, properties);
        if(s8 != null)
            ((PhysicalConnection) (obj)).setDefaultRowPrefetch(Integer.parseInt(s8));
        if(s9 != null)
            ((PhysicalConnection) (obj)).setDefaultExecuteBatch(Integer.parseInt(s9));
        if(s12 != null)
            ((PhysicalConnection) (obj)).setRemarksReporting(s12.equalsIgnoreCase("true"));
        if(s13 != null)
            ((PhysicalConnection) (obj)).setIncludeSynonyms(s13.equalsIgnoreCase("true"));
        if(s14 != null)
            ((PhysicalConnection) (obj)).setRestrictGetTables(s14.equalsIgnoreCase("true"));
        if(s15 != null)
            ((PhysicalConnection) (obj)).setDefaultFixedString(s15.equalsIgnoreCase("true"));
        if(s10 != null)
            ((PhysicalConnection) (obj)).setDefaultNChar(s10.equalsIgnoreCase("true"));
        if(s11 != null)
            obj.useFetchSizeWithLongColumn = s11.equalsIgnoreCase("true");
        if(s16 != null)
            ((PhysicalConnection) (obj)).setAccumulateBatchResult(s16.equalsIgnoreCase("true"));
        String s20 = getSystemProperty("oracle.jdbc.J2EE13Compliant", null);
        String s19;
        if(s20 == null)
        {
            s19 = properties.getProperty("oracle.jdbc.J2EE13Compliant");
            if(s19 == null)
                s19 = "false";
        } else
        {
            s19 = s20;
        }
        ((PhysicalConnection) (obj)).setJ2EE13Compliant(s19.equalsIgnoreCase("true"));
        obj.disableDefineColumnType = s17.equalsIgnoreCase("true");
        obj.convertNcharLiterals = s18.equalsIgnoreCase("true");
        hashtable = null;
        obj.protocolId = i;
        return ((Connection) (obj));
    }

    public Connection defaultConnection()
        throws SQLException
    {
        if(defaultConn == null || defaultConn.isClosed())
            synchronized(oracle.jdbc.driver.OracleDriver.class)
            {
                if(defaultConn == null || defaultConn.isClosed())
                    defaultConn = DriverManager.getConnection("jdbc:oracle:kprb:");
            }
        return defaultConn;
    }

    private int oracleDriverExtensionTypeFromURL(String s)
    {
        int i = s.indexOf(':') + 1;
        if(i == 0)
            return -2;
        int j = s.indexOf(':', i);
        if(j == -1)
            return -2;
        if(!s.regionMatches(true, i, "oracle", 0, j - i))
            return -2;
        j++;
        int k = s.indexOf(':', j);
        if(k == -1)
            return -3;
        String s1 = s.substring(j, k);
        if(s1.equals("thin"))
            return 0;
        return !s1.equals("oci8") && !s1.equals("oci") ? -3 : 2;
    }

    public boolean acceptsURL(String s)
    {
        if(s.startsWith("jdbc:oracle:"))
            return oracleDriverExtensionTypeFromURL(s) > -2;
        else
            return false;
    }

    public DriverPropertyInfo[] getPropertyInfo(String s, Properties properties)
        throws SQLException
    {
        return new DriverPropertyInfo[0];
    }

    public int getMajorVersion()
    {
        return OracleDatabaseMetaData.getDriverMajorVersionInfo();
    }

    public int getMinorVersion()
    {
        return OracleDatabaseMetaData.getDriverMinorVersionInfo();
    }

    public boolean jdbcCompliant()
    {
        return true;
    }

    public String processSqlEscapes(String s)
        throws SQLException
    {
        OracleSql oraclesql = new OracleSql(null);
        oraclesql.initialize(s);
        return oraclesql.parse(s);
    }

    private String parseLoginOption(String s, Properties properties)
    {
        boolean flag = false;
        String s1 = null;
        Object obj = null;
        if(s == null)
            return null;
        int k = s.length();
        if(k == 0)
            return null;
        int i = s.indexOf('[');
        if(i > 0)
        {
            int j = s.indexOf(']');
            String s2 = s.substring(i + 1, j);
            s2 = s2.trim();
            if(s2.length() > 0)
                properties.put("PROXY_CLIENT_NAME", s2);
            s = s.substring(0, i) + s.substring(j + 1, k);
        }
        String s3 = s.toLowerCase();
        i = s3.lastIndexOf(" as ");
        if(i == -1 || i < s3.lastIndexOf("\""))
            return s;
        s1 = s.substring(0, i);
        for(i += 4; i < k && s3.charAt(i) == ' '; i++);
        if(i == k)
            return s;
        String s4 = s3.substring(i).trim();
        if(s4.length() > 0)
            properties.put("internal_logon", s4);
        return s1;
    }

    private Hashtable parseUrl(String s)
        throws SQLException
    {
        Hashtable hashtable = new Hashtable(5);
        int i = s.indexOf(':', s.indexOf(':') + 1) + 1;
        int j = s.length();
        if(i == j)
            return hashtable;
        int k = s.indexOf(':', i);
        if(k == -1)
            return hashtable;
        hashtable.put("protocol", s.substring(i, k));
        int l = k + 1;
        int i1 = s.indexOf('/', l);
        int j1 = s.indexOf('@', l);
        if(j1 > l && l > i && i1 == -1)
            return null;
        if(j1 == -1)
            j1 = j;
        if(i1 == -1)
            i1 = j1;
        if(i1 < j1 && i1 != l && j1 != l)
        {
            hashtable.put("user", s.substring(l, i1));
            hashtable.put("password", s.substring(i1 + 1, j1));
        }
        if(i1 <= j1 && (i1 == l || j1 == l) && j1 < j)
        {
            String s1 = s.substring(j1 + 1);
            String as[] = getSecretStoreCredentials(s1);
            if(as[0] != null || as[1] != null)
            {
                hashtable.put("user", as[0]);
                hashtable.put("password", as[1]);
            }
        }
        if(j1 < j)
            hashtable.put("database", s.substring(j1 + 1));
        return hashtable;
    }

    private String[] getSecretStoreCredentials(String s)
        throws SQLException
    {
        String as[];
label0:
        {
            as = new String[2];
            as[0] = null;
            as[1] = null;
            if(walletLocation == null)
                break label0;
            try
            {
                OracleWallet oraclewallet = new OracleWallet();
                if(!oraclewallet.exists(walletLocation))
                    break label0;
                oraclewallet.open(walletLocation, null);
                OracleSecretStore oraclesecretstore = oraclewallet.getSecretStore();
                if(oraclesecretstore.containsAlias("oracle.security.client.default_username"))
                    as[0] = new String(oraclesecretstore.getSecret("oracle.security.client.default_username"));
                if(oraclesecretstore.containsAlias("oracle.security.client.default_password"))
                    as[1] = new String(oraclesecretstore.getSecret("oracle.security.client.default_password"));
                Enumeration enumeration = oraclewallet.getSecretStore().internalAliases();
                String s1 = null;
                do
                {
                    if(!enumeration.hasMoreElements())
                        break label0;
                    s1 = (String)enumeration.nextElement();
                } while(!s1.startsWith("oracle.security.client.connect_string") || !s.equalsIgnoreCase(new String(oraclesecretstore.getSecret(s1))));
                String s2 = s1.substring("oracle.security.client.connect_string".length());
                as[0] = new String(oraclesecretstore.getSecret("oracle.security.client.username" + s2));
                as[1] = new String(oraclesecretstore.getSecret("oracle.security.client.password" + s2));
            }
            catch(NoClassDefFoundError noclassdeffounderror)
            {
                DatabaseError.throwSqlException(167);
            }
            catch(Exception exception)
            {
                if(exception instanceof RuntimeException)
                    throw (RuntimeException)exception;
                DatabaseError.throwSqlException(168);
            }
        }
        return as;
    }

    public static String getCompileTime()
    {
        return "Sat_Feb__2_11:39:36_PST_2008";
    }

    private String translateConnStr(String s)
        throws SQLException
    {
        int i = 0;
        int j = 0;
        if(s == null)
            return s;
        if((i = s.indexOf(':')) == -1 || (j = s.indexOf(':', i + 1)) == -1)
            return s;
        if(s.indexOf(':', j + 1) != -1)
            DatabaseError.throwSqlException(67, s);
        String s2 = s.substring(0, i);
        String s3 = s.substring(i + 1, j);
        String s4 = s.substring(j + 1, s.length());
        String s1 = "(DESCRIPTION=(ADDRESS=(PROTOCOL=tcp)(HOST=" + s2 + ")(PORT=" + s3 + "))(CONNECT_DATA=(SID=" + s4 + ")))";
        return s1;
    }

    protected static String getSystemPropertyUserName()
    {
        return getSystemProperty("user.name", null);
    }

    protected static String getSystemPropertyV8Compatible()
    {
        return getSystemProperty("oracle.jdbc.V8Compatible", null);
    }

    protected static String getSystemPropertyPollInterval()
    {
        return getSystemProperty("oracle.jdbc.TimeoutPollInterval", "1000");
    }

    public static String getSystemPropertyFastConnectionFailover(String s)
    {
        return getSystemProperty("oracle.jdbc.FastConnectionFailover", s);
    }

    public static String getSystemPropertyJserverVersion()
    {
        return getSystemProperty("oracle.jserver.version", null);
    }

    private static String getSystemProperty(String s)
    {
        return getSystemProperty(s, null);
    }

    private static String getSystemProperty(String s, String s1)
    {
        if(s != null)
        {
            final String fstr = s;
            final String fdefaultValue = s1;
            final String rets[] = {
                s1
            };
            AccessController.doPrivileged(new PrivilegedAction() {

                public Object run()
                {
                    rets[0] = System.getProperty(fstr, fdefaultValue);
                    return null;
                }

            }
);
            return rets[0];
        } else
        {
            return s1;
        }
    }

    public static final char slash_character = 47;
    public static final char at_sign_character = 64;
    public static final char left_square_bracket_character = 91;
    public static final char right_square_bracket_character = 93;
    public static final String oracle_string = "oracle";
    public static final String protocol_string = "protocol";
    public static final String user_string = "user";
    public static final String password_string = "password";
    public static final String database_string = "database";
    public static final String server_string = "server";
    /**
     * @deprecated Field access_string is deprecated
     */
    public static final String access_string = "access";
    /**
     * @deprecated Field protocolFullName_string is deprecated
     */
    public static final String protocolFullName_string = "protocolFullName";
    public static final String logon_as_internal_str = "internal_logon";
    public static final String proxy_client_name = "PROXY_CLIENT_NAME";
    /**
     * @deprecated Field prefetch_string is deprecated
     */
    public static final String prefetch_string = "prefetch";
    /**
     * @deprecated Field row_prefetch_string is deprecated
     */
    public static final String row_prefetch_string = "rowPrefetch";
    public static final String default_row_prefetch_string = "defaultRowPrefetch";
    /**
     * @deprecated Field batch_string is deprecated
     */
    public static final String batch_string = "batch";
    /**
     * @deprecated Field execute_batch_string is deprecated
     */
    public static final String execute_batch_string = "executeBatch";
    public static final String default_execute_batch_string = "defaultExecuteBatch";
    public static final String process_escapes_string = "processEscapes";
    public static final String dms_parent_name_string = "DMSName";
    public static final String dms_parent_type_string = "DMSType";
    public static final String accumulate_batch_result = "AccumulateBatchResult";
    public static final String j2ee_compliance = "oracle.jdbc.J2EE13Compliant";
    public static final String v8compatible_string = "oracle.jdbc.V8Compatible";
    public static final String permit_timestamp_date_mismatch_string = "oracle.jdbc.internal.permitBindDateDefineTimestampMismatch";
    public static final String StreamChunkSize_string = "oracle.jdbc.StreamChunkSize";
    public static final String SetFloatAndDoubleUseBinary_string = "SetFloatAndDoubleUseBinary";
    /**
     * @deprecated Field xa_trans_loose is deprecated
     */
    public static final String xa_trans_loose = "oracle.jdbc.XATransLoose";
    public static final String tcp_no_delay = "oracle.jdbc.TcpNoDelay";
    public static final String read_timeout = "oracle.jdbc.ReadTimeout";
    public static final String defaultnchar_string = "oracle.jdbc.defaultNChar";
    public static final String defaultncharprop_string = "defaultNChar";
    public static final String useFetchSizeWithLongColumn_prop_string = "useFetchSizeWithLongColumn";
    public static final String useFetchSizeWithLongColumn_string = "oracle.jdbc.useFetchSizeWithLongColumn";
    /**
     * @deprecated Field remarks_string is deprecated
     */
    public static final String remarks_string = "remarks";
    public static final String report_remarks_string = "remarksReporting";
    /**
     * @deprecated Field synonyms_string is deprecated
     */
    public static final String synonyms_string = "synonyms";
    public static final String include_synonyms_string = "includeSynonyms";
    public static final String restrict_getTables_string = "restrictGetTables";
    public static final String fixed_string_string = "fixedString";
    public static final String dll_string = "oracle.jdbc.ocinativelibrary";
    public static final String nls_lang_backdoor = "oracle.jdbc.ociNlsLangBackwardCompatible";
    public static final String disable_defineColumnType_string = "disableDefineColumnType";
    public static final String convert_nchar_literals_string = "oracle.jdbc.convertNcharLiterals";
    /**
     * @deprecated Field dataSizeUnitsPropertyName is deprecated
     */
    public static final String dataSizeUnitsPropertyName = "";
    /**
     * @deprecated Field dataSizeBytes is deprecated
     */
    public static final String dataSizeBytes = "";
    /**
     * @deprecated Field dataSizeChars is deprecated
     */
    public static final String dataSizeChars = "";
    public static final String dms_stmt_metrics_string = "oracle.jdbc.DMSStatementMetrics";
    public static final String dms_stmt_caching_metrics_string = "oracle.jdbc.DMSStatementCachingMetrics";
    public static final String set_new_password_string = "OCINewPassword";
    public static final String retain_v9_bind_behavior_string = "oracle.jdbc.RetainV9LongBindBehavior";
    public static final String no_caching_buffers = "oracle.jdbc.FreeMemoryOnEnterImplicitCache";
    public static final String secret_store_connect = "oracle.security.client.connect_string";
    public static final String secret_store_username = "oracle.security.client.username";
    public static final String secret_store_password = "oracle.security.client.password";
    public static final String secret_store_default_username = "oracle.security.client.default_username";
    public static final String secret_store_default_password = "oracle.security.client.default_password";
    public static final String wallet_location_string = "oracle.net.wallet_location";
    private static String walletLocation = null;
    static final int EXTENSION_TYPE_ORACLE_ERROR = -3;
    static final int EXTENSION_TYPE_GEN_ERROR = -2;
    static final int EXTENSION_TYPE_TYPE4_CLIENT = 0;
    static final int EXTENSION_TYPE_TYPE4_SERVER = 1;
    static final int EXTENSION_TYPE_TYPE2_CLIENT = 2;
    static final int EXTENSION_TYPE_TYPE2_SERVER = 3;
    private static final int NUMBER_OF_EXTENSION_TYPES = 4;
    private OracleDriverExtension driverExtensions[];
    private static final String DRIVER_PACKAGE_STRING = "driver";
    private static final String driverExtensionClassNames[] = {
        "oracle.jdbc.driver.T4CDriverExtension", "oracle.jdbc.driver.T4CDriverExtension", "oracle.jdbc.driver.T2CDriverExtension", "oracle.jdbc.driver.T2SDriverExtension"
    };
    private static Properties driverAccess;
    protected static Connection defaultConn = null;
    private static OracleDriver defaultDriver;
    private static final String _Copyright_2004_Oracle_All_Rights_Reserved_ = null;
    public static final boolean TRACE = false;
    public static final boolean PRIVATE_TRACE = false;
    public static final String BUILD_DATE = "Sat_Feb__2_11:39:36_PST_2008";

    static 
    {
        defaultDriver = null;
        Timestamp timestamp = Timestamp.valueOf("2000-01-01 00:00:00.0");
        try
        {
            if(defaultDriver == null)
            {
                defaultDriver = new OracleDriver();
                DriverManager.registerDriver(defaultDriver);
            }
        }
        catch(RuntimeException runtimeexception) { }
        catch(SQLException sqlexception) { }
    }
}
