// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleResultSetImpl.java

package oracle.jdbc.driver;

import java.io.*;
import java.math.BigDecimal;
import java.net.URL;
import java.sql.*;
import java.util.Calendar;
import java.util.Map;
import oracle.sql.*;

// Referenced classes of package oracle.jdbc.driver:
//            BaseResultSet, OracleResultSetMetaData, OracleStatement, DatabaseError, 
//            PhysicalConnection, OracleInputStream, Accessor

class OracleResultSetImpl extends BaseResultSet
{

    OracleResultSetImpl(PhysicalConnection physicalconnection, OracleStatement oraclestatement)
        throws SQLException
    {
        connection = physicalconnection;
        statement = oraclestatement;
        close_statement_on_close = false;
        closed = false;
        explicitly_closed = false;
        m_emptyRset = false;
    }

    public synchronized void close()
        throws SQLException
    {
        internal_close(false);
        if(close_statement_on_close)
            try
            {
                statement.close();
            }
            catch(SQLException sqlexception) { }
        explicitly_closed = true;
    }

    public synchronized boolean wasNull()
        throws SQLException
    {
        return statement.wasNullValue();
    }

    public synchronized ResultSetMetaData getMetaData()
        throws SQLException
    {
        if(explicitly_closed)
            DatabaseError.throwSqlException(10, "getMetaData");
        if(statement.closed)
            DatabaseError.throwSqlException(9, "getMetaData");
        if(!statement.isOpen)
            DatabaseError.throwSqlException(144, "getMetaData");
        return new OracleResultSetMetaData(connection, statement);
    }

    public synchronized Statement getStatement()
        throws SQLException
    {
        return statement;
    }

    public synchronized boolean next()
        throws SQLException
    {
        boolean flag = true;
        PhysicalConnection physicalconnection = statement.connection;
        if(explicitly_closed)
            DatabaseError.throwSqlException(10, "next");
        if(physicalconnection == null || physicalconnection.lifecycle != 1)
            DatabaseError.throwSqlException(8, "next");
        if(statement.closed)
            DatabaseError.throwSqlException(9, "next");
        if(statement.sqlKind == 1 || statement.sqlKind == 4)
            DatabaseError.throwSqlException(166, "next");
        if(closed)
            return false;
        statement.currentRow++;
        statement.totalRowsVisited++;
        if(statement.maxRows != 0 && statement.totalRowsVisited > statement.maxRows)
        {
            internal_close(false);
            return false;
        }
        if(statement.currentRow >= statement.validRows)
            flag = close_or_fetch_from_next(false);
        if(flag && physicalconnection.useFetchSizeWithLongColumn)
            statement.reopenStreams();
        return flag;
    }

    private boolean close_or_fetch_from_next(boolean flag)
        throws SQLException
    {
        if(flag)
        {
            internal_close(false);
            return false;
        }
        if(statement.gotLastBatch)
        {
            internal_close(false);
            return false;
        }
        statement.check_row_prefetch_changed();
        PhysicalConnection physicalconnection = statement.connection;
        if(physicalconnection.protocolId == 3)
        {
            sqlWarning = null;
        } else
        {
            if(statement.streamList != null)
                for(; statement.nextStream != null; statement.nextStream = statement.nextStream.nextStream)
                    try
                    {
                        statement.nextStream.close();
                    }
                    catch(IOException ioexception)
                    {
                        DatabaseError.throwSqlException(ioexception);
                    }

            clearWarnings();
            physicalconnection.registerHeartbeat();
            physicalconnection.needLine();
        }
        synchronized(physicalconnection)
        {
            statement.fetch();
        }
        if(statement.validRows == 0)
        {
            internal_close(false);
            return false;
        } else
        {
            statement.currentRow = 0;
            statement.checkValidRowsStatus();
            return true;
        }
    }

    public boolean isBeforeFirst()
        throws SQLException
    {
        return !isEmptyResultSet() && statement.currentRow == -1 && !closed;
    }

    public boolean isAfterLast()
        throws SQLException
    {
        return !isEmptyResultSet() && closed;
    }

    public boolean isFirst()
        throws SQLException
    {
        return getRow() == 1;
    }

    public boolean isLast()
        throws SQLException
    {
        DatabaseError.throwSqlException(75, "isLast");
        return false;
    }

    public int getRow()
        throws SQLException
    {
        return statement.totalRowsVisited;
    }

    public synchronized String getString(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getString(j);
    }

    public synchronized boolean getBoolean(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getBoolean(j);
    }

    public synchronized byte getByte(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getByte(j);
    }

    public synchronized short getShort(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getShort(j);
    }

    public synchronized int getInt(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getInt(j);
    }

    public synchronized long getLong(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getLong(j);
    }

    public synchronized float getFloat(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getFloat(j);
    }

    public synchronized double getDouble(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getDouble(j);
    }

    public synchronized BigDecimal getBigDecimal(int i, int j)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int k = statement.currentRow;
        if(k < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getBigDecimal(statement.currentRow, j);
    }

    synchronized byte[] privateGetBytes(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].privateGetBytes(j);
    }

    public synchronized byte[] getBytes(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getBytes(j);
    }

    public synchronized Date getDate(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getDate(j);
    }

    public synchronized Time getTime(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getTime(j);
    }

    public synchronized Timestamp getTimestamp(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getTimestamp(j);
    }

    public synchronized InputStream getAsciiStream(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getAsciiStream(j);
    }

    public synchronized InputStream getUnicodeStream(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getUnicodeStream(j);
    }

    public synchronized InputStream getBinaryStream(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getBinaryStream(j);
    }

    public synchronized Object getObject(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getObject(j);
    }

    public synchronized ResultSet getCursor(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getCursor(j);
    }

    public synchronized Datum getOracleObject(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getOracleObject(j);
    }

    public synchronized ROWID getROWID(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getROWID(j);
    }

    public synchronized NUMBER getNUMBER(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getNUMBER(j);
    }

    public synchronized DATE getDATE(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getDATE(j);
    }

    public synchronized ARRAY getARRAY(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getARRAY(j);
    }

    public synchronized STRUCT getSTRUCT(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getSTRUCT(j);
    }

    public synchronized OPAQUE getOPAQUE(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getOPAQUE(j);
    }

    public synchronized REF getREF(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getREF(j);
    }

    public synchronized CHAR getCHAR(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getCHAR(j);
    }

    public synchronized RAW getRAW(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getRAW(j);
    }

    public synchronized BLOB getBLOB(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getBLOB(j);
    }

    public synchronized CLOB getCLOB(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getCLOB(j);
    }

    public synchronized BFILE getBFILE(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getBFILE(j);
    }

    public synchronized BFILE getBfile(int i)
        throws SQLException
    {
        return getBFILE(i);
    }

    public synchronized CustomDatum getCustomDatum(int i, CustomDatumFactory customdatumfactory)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getCustomDatum(statement.currentRow, customdatumfactory);
    }

    public synchronized ORAData getORAData(int i, ORADataFactory oradatafactory)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getORAData(statement.currentRow, oradatafactory);
    }

    public synchronized Object getObject(int i, Map map)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getObject(statement.currentRow, map);
    }

    public synchronized Ref getRef(int i)
        throws SQLException
    {
        return getREF(i);
    }

    public synchronized Blob getBlob(int i)
        throws SQLException
    {
        return getBLOB(i);
    }

    public synchronized Clob getClob(int i)
        throws SQLException
    {
        return getCLOB(i);
    }

    public synchronized Array getArray(int i)
        throws SQLException
    {
        return getARRAY(i);
    }

    public synchronized Reader getCharacterStream(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getCharacterStream(j);
    }

    public BigDecimal getBigDecimal(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getBigDecimal(j);
    }

    public Date getDate(int i, Calendar calendar)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getDate(statement.currentRow, calendar);
    }

    public Time getTime(int i, Calendar calendar)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getTime(statement.currentRow, calendar);
    }

    public Timestamp getTimestamp(int i, Calendar calendar)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getTimestamp(statement.currentRow, calendar);
    }

    public INTERVALYM getINTERVALYM(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getINTERVALYM(j);
    }

    public INTERVALDS getINTERVALDS(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getINTERVALDS(j);
    }

    public TIMESTAMP getTIMESTAMP(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getTIMESTAMP(j);
    }

    public TIMESTAMPTZ getTIMESTAMPTZ(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getTIMESTAMPTZ(j);
    }

    public TIMESTAMPLTZ getTIMESTAMPLTZ(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getTIMESTAMPLTZ(j);
    }

    public synchronized URL getURL(int i)
        throws SQLException
    {
        if(i <= 0 || i > statement.numberOfDefinePositions)
            DatabaseError.throwSqlException(3);
        if(closed)
            DatabaseError.throwSqlException(11);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        if(statement.streamList != null)
            statement.closeUsedStreams(i);
        return statement.accessors[i - 1].getURL(j);
    }

    public void setFetchSize(int i)
        throws SQLException
    {
        statement.setPrefetchInternal(i, false, false);
    }

    public int getFetchSize()
        throws SQLException
    {
        return statement.getPrefetchInternal(false);
    }

    void internal_close(boolean flag)
        throws SQLException
    {
        if(closed)
            return;
        closed = true;
        if(statement.gotLastBatch && statement.validRows == 0)
            m_emptyRset = true;
        PhysicalConnection physicalconnection = statement.connection;
        try
        {
            physicalconnection.registerHeartbeat();
            physicalconnection.needLine();
            synchronized(physicalconnection)
            {
                statement.closeQuery();
            }
        }
        catch(SQLException sqlexception) { }
        statement.endOfResultSet(flag);
    }

    public synchronized int findColumn(String s)
        throws SQLException
    {
        return statement.getColumnIndex(s);
    }

    boolean isEmptyResultSet()
    {
        return m_emptyRset || !m_emptyRset && statement.gotLastBatch && statement.validRows == 0;
    }

    int getValidRows()
    {
        return statement.validRows;
    }

    PhysicalConnection connection;
    OracleStatement statement;
    boolean closed;
    boolean explicitly_closed;
    boolean m_emptyRset;
    private static final String _Copyright_2004_Oracle_All_Rights_Reserved_ = null;
    public static final boolean TRACE = false;
    public static final boolean PRIVATE_TRACE = false;
    public static final String BUILD_DATE = "Sat_Feb__2_11:39:36_PST_2008";

}
