// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleReturnResultSet.java

package oracle.jdbc.driver;

import java.io.InputStream;
import java.io.Reader;
import java.math.BigDecimal;
import java.net.URL;
import java.sql.*;
import java.util.Calendar;
import java.util.Map;
import oracle.sql.*;

// Referenced classes of package oracle.jdbc.driver:
//            BaseResultSet, Accessor, OracleStatement, DatabaseError, 
//            AutoKeyInfo

class OracleReturnResultSet extends BaseResultSet
{

    OracleReturnResultSet(OracleStatement oraclestatement)
        throws SQLException
    {
        statement = oraclestatement;
        closed = false;
        returnAccessors = new Accessor[oraclestatement.numReturnParams];
        int i = 0;
        for(int j = 0; j < oraclestatement.numberOfBindPositions; j++)
        {
            Accessor accessor = oraclestatement.returnParamAccessors[j];
            if(accessor != null)
                returnAccessors[i++] = accessor;
        }

    }

    public synchronized boolean next()
        throws SQLException
    {
        if(closed)
            return false;
        if(!statement.returnParamsFetched)
        {
            statement.fetchDmlReturnParams();
            statement.setupReturnParamAccessors();
        }
        statement.currentRow++;
        statement.totalRowsVisited++;
        return statement.currentRow < statement.rowsDmlReturned;
    }

    public synchronized void close()
        throws SQLException
    {
        closed = true;
        statement.returnResultSet = null;
        statement.numReturnParams = 0;
        statement.totalRowsVisited = 0;
        statement.currentRow = -1;
        statement.returnParamsFetched = false;
        statement.rowsDmlReturned = 0;
        statement.returnParamBytes = null;
        statement.returnParamChars = null;
        statement.returnParamIndicators = null;
    }

    public synchronized boolean wasNull()
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(statement.currentRow == -1 || statement.lastIndex == 0)
            DatabaseError.throwSqlException(24);
        return returnAccessors[statement.lastIndex - 1].isNull(statement.currentRow);
    }

    public synchronized ResultSetMetaData getMetaData()
        throws SQLException
    {
        if(!statement.isAutoGeneratedKey)
            DatabaseError.throwSqlException(23);
        if(closed)
            DatabaseError.throwSqlException(10);
        if(statement.closed)
            DatabaseError.throwSqlException(9);
        AutoKeyInfo autokeyinfo = statement.autoKeyInfo;
        autokeyinfo.statement = statement;
        autokeyinfo.connection = statement.connection;
        autokeyinfo.initMetaData(this);
        return autokeyinfo;
    }

    public synchronized Statement getStatement()
        throws SQLException
    {
        return statement;
    }

    public synchronized String getString(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getString(j);
    }

    public synchronized boolean getBoolean(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getBoolean(j);
    }

    public synchronized byte getByte(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getByte(j);
    }

    public synchronized short getShort(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getShort(j);
    }

    public synchronized int getInt(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getInt(j);
    }

    public synchronized long getLong(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getLong(j);
    }

    public synchronized float getFloat(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getFloat(j);
    }

    public synchronized double getDouble(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getDouble(j);
    }

    public synchronized BigDecimal getBigDecimal(int i, int j)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int k = statement.currentRow;
        if(k < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getBigDecimal(k, j);
    }

    public synchronized byte[] getBytes(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getBytes(j);
    }

    public synchronized Date getDate(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getDate(j);
    }

    public synchronized Time getTime(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getTime(j);
    }

    public synchronized Timestamp getTimestamp(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getTimestamp(j);
    }

    public synchronized InputStream getAsciiStream(int i)
        throws SQLException
    {
        DatabaseError.throwSqlException(23);
        return null;
    }

    public synchronized InputStream getUnicodeStream(int i)
        throws SQLException
    {
        DatabaseError.throwSqlException(23);
        return null;
    }

    public synchronized InputStream getBinaryStream(int i)
        throws SQLException
    {
        DatabaseError.throwSqlException(23);
        return null;
    }

    public synchronized Object getObject(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getObject(j);
    }

    public synchronized ResultSet getCursor(int i)
        throws SQLException
    {
        DatabaseError.throwSqlException(23);
        return null;
    }

    public synchronized Datum getOracleObject(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getOracleObject(j);
    }

    public synchronized ROWID getROWID(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getROWID(j);
    }

    public synchronized NUMBER getNUMBER(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getNUMBER(j);
    }

    public synchronized DATE getDATE(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getDATE(j);
    }

    public synchronized ARRAY getARRAY(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getARRAY(j);
    }

    public synchronized STRUCT getSTRUCT(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getSTRUCT(j);
    }

    public synchronized OPAQUE getOPAQUE(int i)
        throws SQLException
    {
        DatabaseError.throwSqlException(23);
        return null;
    }

    public synchronized REF getREF(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getREF(j);
    }

    public synchronized CHAR getCHAR(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getCHAR(j);
    }

    public synchronized RAW getRAW(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getRAW(j);
    }

    public synchronized BLOB getBLOB(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getBLOB(j);
    }

    public synchronized CLOB getCLOB(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getCLOB(j);
    }

    public synchronized BFILE getBFILE(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getBFILE(j);
    }

    public synchronized BFILE getBfile(int i)
        throws SQLException
    {
        return getBFILE(i);
    }

    public synchronized CustomDatum getCustomDatum(int i, CustomDatumFactory customdatumfactory)
        throws SQLException
    {
        DatabaseError.throwSqlException(23);
        return null;
    }

    public synchronized ORAData getORAData(int i, ORADataFactory oradatafactory)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getORAData(j, oradatafactory);
    }

    public synchronized Object getObject(int i, Map map)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getObject(j, map);
    }

    public synchronized Ref getRef(int i)
        throws SQLException
    {
        return getREF(i);
    }

    public synchronized Blob getBlob(int i)
        throws SQLException
    {
        return getBLOB(i);
    }

    public synchronized Clob getClob(int i)
        throws SQLException
    {
        return getCLOB(i);
    }

    public synchronized Array getArray(int i)
        throws SQLException
    {
        DatabaseError.throwSqlException(23);
        return null;
    }

    public synchronized Reader getCharacterStream(int i)
        throws SQLException
    {
        DatabaseError.throwSqlException(23);
        return null;
    }

    public BigDecimal getBigDecimal(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getBigDecimal(j);
    }

    public Date getDate(int i, Calendar calendar)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getDate(j, calendar);
    }

    public Time getTime(int i, Calendar calendar)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getTime(j, calendar);
    }

    public Timestamp getTimestamp(int i, Calendar calendar)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getTimestamp(j, calendar);
    }

    public INTERVALYM getINTERVALYM(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getINTERVALYM(j);
    }

    public INTERVALDS getINTERVALDS(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getINTERVALDS(j);
    }

    public TIMESTAMP getTIMESTAMP(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getTIMESTAMP(j);
    }

    public TIMESTAMPLTZ getTIMESTAMPLTZ(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getTIMESTAMPLTZ(j);
    }

    public synchronized URL getURL(int i)
        throws SQLException
    {
        if(closed)
            DatabaseError.throwSqlException(11);
        if(i <= 0 || i > statement.numReturnParams)
            DatabaseError.throwSqlException(3);
        int j = statement.currentRow;
        if(j < 0)
            DatabaseError.throwSqlException(14);
        statement.lastIndex = i;
        return returnAccessors[i - 1].getURL(j);
    }

    public boolean isBeforeFirst()
        throws SQLException
    {
        return !isEmptyResultSet() && statement.currentRow == -1 && !closed;
    }

    public boolean isAfterLast()
        throws SQLException
    {
        return !isEmptyResultSet() && closed;
    }

    public boolean isFirst()
        throws SQLException
    {
        return getRow() == 1;
    }

    public boolean isLast()
        throws SQLException
    {
        return getRow() == statement.rowsDmlReturned;
    }

    public int getRow()
        throws SQLException
    {
        return statement.totalRowsVisited;
    }

    public synchronized int findColumn(String s)
        throws SQLException
    {
        DatabaseError.throwSqlException(23);
        return -1;
    }

    public void setFetchSize(int i)
        throws SQLException
    {
        DatabaseError.throwSqlException(23);
    }

    public int getFetchSize()
        throws SQLException
    {
        DatabaseError.throwSqlException(23);
        return -1;
    }

    boolean isEmptyResultSet()
    {
        return statement.rowsDmlReturned == 0;
    }

    OracleStatement statement;
    boolean closed;
    Accessor returnAccessors[];
}
