// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ScrollableResultSet.java

package oracle.jdbc.driver;

import java.io.*;
import java.math.BigDecimal;
import java.net.MalformedURLException;
import java.net.URL;
import java.sql.*;
import java.util.*;
import oracle.sql.*;

// Referenced classes of package oracle.jdbc.driver:
//            BaseResultSet, OracleStatement, OracleResultSetCacheImpl, OracleResultSet, 
//            OracleResultSetMetaData, UpdatableResultSet, OraclePreparedStatement, ScrollRsetStatement, 
//            OracleResultSetCache, DatabaseError, OracleResultSetImpl, PhysicalConnection, 
//            DBConversion, SQLUtil, OracleSql, Accessor

class ScrollableResultSet extends BaseResultSet
{

    ScrollableResultSet(ScrollRsetStatement scrollrsetstatement, OracleResultSetImpl oracleresultsetimpl, int i, int j)
        throws SQLException
    {
        connection = ((OracleStatement)scrollrsetstatement).connection;
        resultSet = oracleresultsetimpl;
        metadata = null;
        scrollStmt = scrollrsetstatement;
        rsetType = i;
        rsetConcurency = j;
        autoRefetch = scrollrsetstatement.getAutoRefetch();
        beginColumnIndex = needIdentifier(i, j) ? 1 : 0;
        columnCount = 0;
        wasNull = -1;
        rsetCache = scrollrsetstatement.getResultSetCache();
        if(rsetCache == null)
            rsetCache = new OracleResultSetCacheImpl();
        else
            try
            {
                rsetCache.clear();
            }
            catch(IOException ioexception)
            {
                DatabaseError.throwSqlException(ioexception);
            }
        currentRow = 0;
        numRowsCached = 0;
        allRowsCached = false;
        lastRefetchSz = 0;
        refetchRowids = null;
        refetchStmt = null;
        usrFetchDirection = 1000;
        getInternalMetadata();
    }

    public void close()
        throws SQLException
    {
        synchronized(connection)
        {
            synchronized(this)
            {
                if(resultSet != null)
                    resultSet.close();
                if(refetchStmt != null)
                    refetchStmt.close();
                if(scrollStmt != null)
                    scrollStmt.notifyCloseRset();
                if(refetchRowids != null)
                    refetchRowids.removeAllElements();
                resultSet = null;
                scrollStmt = null;
                refetchStmt = null;
                refetchRowids = null;
                metadata = null;
                try
                {
                    if(rsetCache != null)
                    {
                        rsetCache.clear();
                        rsetCache.close();
                    }
                }
                catch(IOException ioexception)
                {
                    DatabaseError.throwSqlException(ioexception);
                }
                rsetCache = null;
            }
        }
    }

    public synchronized boolean wasNull()
        throws SQLException
    {
        if(wasNull == -1)
            DatabaseError.throwSqlException(24);
        return wasNull == 1;
    }

    public synchronized Statement getStatement()
        throws SQLException
    {
        return (Statement)scrollStmt;
    }

    synchronized void resetBeginColumnIndex()
    {
        beginColumnIndex = 0;
    }

    synchronized ResultSet getResultSet()
    {
        return resultSet;
    }

    synchronized int removeRowInCache(int i)
        throws SQLException
    {
        if(!isEmptyResultSet() && isValidRow(i))
        {
            removeCachedRowAt(i);
            numRowsCached--;
            if(i >= currentRow)
                currentRow--;
            return 1;
        } else
        {
            return 0;
        }
    }

    int refreshRowsInCache(int i, int j, int k)
        throws SQLException
    {
        PhysicalConnection physicalconnection = connection;
        JVM INSTR monitorenter ;
        ScrollableResultSet scrollableresultset = this;
        JVM INSTR monitorenter ;
        OracleResultSet oracleresultset;
        int l;
        oracleresultset = null;
        l = 0;
        l = get_refetch_size(i, j, k);
        if(l > 0)
        {
            if(l != lastRefetchSz)
            {
                if(refetchStmt != null)
                    refetchStmt.close();
                refetchStmt = prepare_refetch_statement(l);
                refetchStmt.setQueryTimeout(((OracleStatement)scrollStmt).getQueryTimeout());
                lastRefetchSz = l;
            }
            prepare_refetch_binds(refetchStmt, l);
            oracleresultset = (OracleResultSet)refetchStmt.executeQuery();
            save_refetch_results(oracleresultset, i, l, k);
        }
        if(oracleresultset != null)
            oracleresultset.close();
        break MISSING_BLOCK_LABEL_149;
        Exception exception;
        exception;
        if(oracleresultset != null)
            oracleresultset.close();
        throw exception;
        return l;
        Exception exception1;
        exception1;
        throw exception1;
        Exception exception2;
        exception2;
        throw exception2;
    }

    public synchronized boolean next()
        throws SQLException
    {
        if(isEmptyResultSet())
            return false;
        if(currentRow < 1)
            currentRow = 1;
        else
            currentRow++;
        return isValidRow(currentRow);
    }

    public synchronized boolean isBeforeFirst()
        throws SQLException
    {
        return !isEmptyResultSet() && currentRow < 1;
    }

    public synchronized boolean isAfterLast()
        throws SQLException
    {
        return !isEmptyResultSet() && currentRow > 0 && !isValidRow(currentRow);
    }

    public synchronized boolean isFirst()
        throws SQLException
    {
        return currentRow == 1;
    }

    public synchronized boolean isLast()
        throws SQLException
    {
        return !isEmptyResultSet() && isValidRow(currentRow) && !isValidRow(currentRow + 1);
    }

    public synchronized void beforeFirst()
        throws SQLException
    {
        if(!isEmptyResultSet())
            currentRow = 0;
    }

    public synchronized void afterLast()
        throws SQLException
    {
        if(!isEmptyResultSet())
            currentRow = getLastRow() + 1;
    }

    public synchronized boolean first()
        throws SQLException
    {
        if(isEmptyResultSet())
        {
            return false;
        } else
        {
            currentRow = 1;
            return isValidRow(currentRow);
        }
    }

    public synchronized boolean last()
        throws SQLException
    {
        if(isEmptyResultSet())
        {
            return false;
        } else
        {
            currentRow = getLastRow();
            return isValidRow(currentRow);
        }
    }

    public synchronized int getRow()
        throws SQLException
    {
        if(isValidRow(currentRow))
            return currentRow;
        else
            return 0;
    }

    public synchronized boolean absolute(int i)
        throws SQLException
    {
        if(i == 0)
            DatabaseError.throwSqlException(68, "absolute (0)");
        if(isEmptyResultSet())
            return false;
        if(i > 0)
            currentRow = i;
        else
        if(i < 0)
            currentRow = getLastRow() + 1 + i;
        return isValidRow(currentRow);
    }

    public synchronized boolean relative(int i)
        throws SQLException
    {
        if(isEmptyResultSet())
            return false;
        if(isValidRow(currentRow))
        {
            currentRow += i;
            return isValidRow(currentRow);
        } else
        {
            DatabaseError.throwSqlException(82, "relative");
            return false;
        }
    }

    public synchronized boolean previous()
        throws SQLException
    {
        if(isEmptyResultSet())
            return false;
        if(isAfterLast())
            currentRow = getLastRow();
        else
            currentRow--;
        return isValidRow(currentRow);
    }

    public synchronized Datum getOracleObject(int i)
        throws SQLException
    {
        wasNull = -1;
        if(!isValidRow(currentRow))
            DatabaseError.throwSqlException(11);
        if(i < 1 || i > getColumnCount())
            DatabaseError.throwSqlException(3);
        Datum datum = getCachedDatumValueAt(currentRow, i + beginColumnIndex);
        wasNull = datum != null ? 0 : 1;
        return datum;
    }

    public synchronized String getString(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            switch(getInternalMetadata().getColumnType(i + beginColumnIndex))
            {
            case 2005: 
                CLOB clob = (CLOB)datum;
                return clob.getSubString(1L, (int)clob.length());
            }
            return datum.stringValue();
        } else
        {
            return null;
        }
    }

    public synchronized boolean getBoolean(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.booleanValue();
        else
            return false;
    }

    public synchronized byte getByte(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.byteValue();
        else
            return 0;
    }

    public synchronized short getShort(int i)
        throws SQLException
    {
        long l = getLong(i);
        if(l > 0x10001L || l < 0xfffffffffffefffeL)
            DatabaseError.throwSqlException(26, "getShort");
        return (short)(int)l;
    }

    public synchronized int getInt(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.intValue();
        else
            return 0;
    }

    public synchronized long getLong(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.longValue();
        else
            return 0L;
    }

    public synchronized float getFloat(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.floatValue();
        else
            return 0.0F;
    }

    public synchronized double getDouble(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.doubleValue();
        else
            return 0.0D;
    }

    public synchronized BigDecimal getBigDecimal(int i, int j)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.bigDecimalValue();
        else
            return null;
    }

    public synchronized byte[] getBytes(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof RAW)
                return ((RAW)datum).shareBytes();
            DatabaseError.throwSqlException(4, "getBytes");
        }
        return null;
    }

    public synchronized Date getDate(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        Date date = null;
        if(datum != null)
        {
            ResultSetMetaData resultsetmetadata = getInternalMetadata();
            switch(resultsetmetadata.getColumnType(i + beginColumnIndex))
            {
            case 93: // ']'
                date = ((TIMESTAMP)datum).dateValue();
                break;

            case -101: 
                date = ((TIMESTAMPTZ)datum).dateValue(connection);
                break;

            case -102: 
                date = ((TIMESTAMPLTZ)datum).dateValue(connection);
                break;

            default:
                date = datum.dateValue();
                break;
            }
        }
        return date;
    }

    public synchronized Time getTime(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        Time time = null;
        if(datum != null)
        {
            ResultSetMetaData resultsetmetadata = getInternalMetadata();
            switch(resultsetmetadata.getColumnType(i + beginColumnIndex))
            {
            case 93: // ']'
                time = ((TIMESTAMP)datum).timeValue();
                break;

            case -101: 
                time = ((TIMESTAMPTZ)datum).timeValue(connection);
                break;

            case -102: 
                time = ((TIMESTAMPLTZ)datum).timeValue(connection);
                break;

            default:
                time = datum.timeValue();
                break;
            }
        }
        return time;
    }

    public synchronized Timestamp getTimestamp(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        Timestamp timestamp = null;
        if(datum != null)
        {
            ResultSetMetaData resultsetmetadata = getInternalMetadata();
            switch(resultsetmetadata.getColumnType(i + beginColumnIndex))
            {
            case 93: // ']'
                timestamp = ((TIMESTAMP)datum).timestampValue();
                break;

            case -101: 
                timestamp = ((TIMESTAMPTZ)datum).timestampValue(connection);
                break;

            case -102: 
                timestamp = ((TIMESTAMPLTZ)datum).timestampValue(connection, ((OracleStatement)scrollStmt).getDefaultCalendar());
                break;

            default:
                timestamp = datum.timestampValue();
                break;
            }
        }
        return timestamp;
    }

    public synchronized InputStream getAsciiStream(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.asciiStreamValue();
        else
            return null;
    }

    public synchronized InputStream getUnicodeStream(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            DBConversion dbconversion = connection.conversion;
            byte abyte0[] = datum.shareBytes();
            if(datum instanceof RAW)
            {
                PhysicalConnection _tmp = connection;
                return dbconversion.ConvertStream(new ByteArrayInputStream(abyte0), 3);
            }
            if(datum instanceof CHAR)
            {
                PhysicalConnection _tmp1 = connection;
                return dbconversion.ConvertStream(new ByteArrayInputStream(abyte0), 1);
            }
            DatabaseError.throwSqlException(4, "getUnicodeStream");
        }
        return null;
    }

    public synchronized InputStream getBinaryStream(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.binaryStreamValue();
        else
            return null;
    }

    public Object getObject(int i)
        throws SQLException
    {
        return getObject(i, connection.getTypeMap());
    }

    public synchronized Reader getCharacterStream(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
            return datum.characterStreamValue();
        else
            return null;
    }

    public BigDecimal getBigDecimal(int i)
        throws SQLException
    {
        return getBigDecimal(i, 0);
    }

    public synchronized Object getObject(int i, Map map)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof STRUCT)
                return ((STRUCT)datum).toJdbc(map);
            else
                return datum.toJdbc();
        } else
        {
            return null;
        }
    }

    public synchronized Ref getRef(int i)
        throws SQLException
    {
        return getREF(i);
    }

    public synchronized Blob getBlob(int i)
        throws SQLException
    {
        return getBLOB(i);
    }

    public synchronized Clob getClob(int i)
        throws SQLException
    {
        return getCLOB(i);
    }

    public synchronized Array getArray(int i)
        throws SQLException
    {
        return getARRAY(i);
    }

    public synchronized Date getDate(int i, Calendar calendar)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        Date date = null;
        if(datum != null)
        {
            ResultSetMetaData resultsetmetadata = getInternalMetadata();
            switch(resultsetmetadata.getColumnType(i + beginColumnIndex))
            {
            case 93: // ']'
                date = new Date(((TIMESTAMP)datum).timestampValue().getTime());
                break;

            case -101: 
                date = new Date(((TIMESTAMPTZ)datum).timestampValue(connection).getTime());
                break;

            case -102: 
                date = new Date(((TIMESTAMPLTZ)datum).timestampValue(connection, calendar).getTime());
                break;

            case 91: // '['
                date = ((DATE)datum).dateValue(calendar);
                break;

            default:
                DatabaseError.throwSqlException(4, "getDate");
                break;
            }
        }
        return date;
    }

    public synchronized Time getTime(int i, Calendar calendar)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        Time time = null;
        if(datum != null)
        {
            ResultSetMetaData resultsetmetadata = getInternalMetadata();
            switch(resultsetmetadata.getColumnType(i + beginColumnIndex))
            {
            case 93: // ']'
                time = new Time(((TIMESTAMP)datum).timestampValue().getTime());
                break;

            case -101: 
                time = new Time(((TIMESTAMPTZ)datum).timestampValue(connection).getTime());
                break;

            case -102: 
                time = new Time(((TIMESTAMPLTZ)datum).timestampValue(connection, calendar).getTime());
                break;

            case 91: // '['
                time = ((DATE)datum).timeValue(calendar);
                break;

            default:
                DatabaseError.throwSqlException(4, "getTime");
                break;
            }
        }
        return time;
    }

    public synchronized Timestamp getTimestamp(int i, Calendar calendar)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        Timestamp timestamp = null;
        if(datum != null)
        {
            ResultSetMetaData resultsetmetadata = getInternalMetadata();
            switch(resultsetmetadata.getColumnType(i + beginColumnIndex))
            {
            case 93: // ']'
                timestamp = ((TIMESTAMP)datum).timestampValue();
                break;

            case -101: 
                timestamp = ((TIMESTAMPTZ)datum).timestampValue(connection);
                break;

            case -102: 
                timestamp = ((TIMESTAMPLTZ)datum).timestampValue(connection, calendar);
                break;

            case 91: // '['
                timestamp = ((DATE)datum).timestampValue(calendar);
                break;

            default:
                DatabaseError.throwSqlException(4, "getTimestamp");
                break;
            }
        }
        return timestamp;
    }

    public synchronized URL getURL(int i)
        throws SQLException
    {
        URL url = null;
        int j = getInternalMetadata().getColumnType(i);
        int k = SQLUtil.getInternalType(j);
        if(k == 96 || k == 1 || k == 8)
            try
            {
                url = new URL(getString(i));
            }
            catch(MalformedURLException malformedurlexception)
            {
                DatabaseError.throwSqlException(136);
            }
        else
            throw new SQLException("Conversion to java.net.URL not supported.");
        return url;
    }

    public synchronized ResultSet getCursor(int i)
        throws SQLException
    {
        DatabaseError.throwSqlException(4, "getCursor");
        return null;
    }

    public synchronized ROWID getROWID(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof ROWID)
                return (ROWID)datum;
            DatabaseError.throwSqlException(4, "getROWID");
        }
        return null;
    }

    public synchronized NUMBER getNUMBER(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof NUMBER)
                return (NUMBER)datum;
            DatabaseError.throwSqlException(4, "getNUMBER");
        }
        return null;
    }

    public synchronized DATE getDATE(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof DATE)
                return (DATE)datum;
            DatabaseError.throwSqlException(4, "getDATE");
        }
        return null;
    }

    public synchronized TIMESTAMP getTIMESTAMP(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof TIMESTAMP)
                return (TIMESTAMP)datum;
            DatabaseError.throwSqlException(4, "getTIMESTAMP");
        }
        return null;
    }

    public synchronized TIMESTAMPTZ getTIMESTAMPTZ(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof TIMESTAMPTZ)
                return (TIMESTAMPTZ)datum;
            DatabaseError.throwSqlException(4, "getTIMESTAMPTZ");
        }
        return null;
    }

    public synchronized TIMESTAMPLTZ getTIMESTAMPLTZ(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof TIMESTAMPLTZ)
                return (TIMESTAMPLTZ)datum;
            DatabaseError.throwSqlException(4, "getTIMESTAMPLTZ");
        }
        return null;
    }

    public synchronized INTERVALDS getINTERVALDS(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof INTERVALDS)
                return (INTERVALDS)datum;
            DatabaseError.throwSqlException(4, "getINTERVALDS");
        }
        return null;
    }

    public synchronized INTERVALYM getINTERVALYM(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof INTERVALYM)
                return (INTERVALYM)datum;
            DatabaseError.throwSqlException(4, "getINTERVALYM");
        }
        return null;
    }

    public synchronized ARRAY getARRAY(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof ARRAY)
                return (ARRAY)datum;
            DatabaseError.throwSqlException(4, "getARRAY");
        }
        return null;
    }

    public synchronized STRUCT getSTRUCT(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof STRUCT)
                return (STRUCT)datum;
            DatabaseError.throwSqlException(4, "getSTRUCT");
        }
        return null;
    }

    public synchronized OPAQUE getOPAQUE(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof OPAQUE)
                return (OPAQUE)datum;
            DatabaseError.throwSqlException(4, "getOPAQUE");
        }
        return null;
    }

    public synchronized REF getREF(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof REF)
                return (REF)datum;
            DatabaseError.throwSqlException(4, "getREF");
        }
        return null;
    }

    public synchronized CHAR getCHAR(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof CHAR)
                return (CHAR)datum;
            DatabaseError.throwSqlException(4, "getCHAR");
        }
        return null;
    }

    public synchronized RAW getRAW(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof RAW)
                return (RAW)datum;
            DatabaseError.throwSqlException(4, "getRAW");
        }
        return null;
    }

    public synchronized BLOB getBLOB(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof BLOB)
                return (BLOB)datum;
            DatabaseError.throwSqlException(4, "getBLOB");
        }
        return null;
    }

    public synchronized CLOB getCLOB(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof CLOB)
                return (CLOB)datum;
            DatabaseError.throwSqlException(4, "getCLOB");
        }
        return null;
    }

    public synchronized BFILE getBFILE(int i)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        if(datum != null)
        {
            if(datum instanceof BFILE)
                return (BFILE)datum;
            DatabaseError.throwSqlException(4, "getBFILE");
        }
        return null;
    }

    public synchronized BFILE getBfile(int i)
        throws SQLException
    {
        return getBFILE(i);
    }

    public synchronized CustomDatum getCustomDatum(int i, CustomDatumFactory customdatumfactory)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        return customdatumfactory.create(datum, 0);
    }

    public synchronized ORAData getORAData(int i, ORADataFactory oradatafactory)
        throws SQLException
    {
        Datum datum = getOracleObject(i);
        return oradatafactory.create(datum, 0);
    }

    public ResultSetMetaData getMetaData()
        throws SQLException
    {
        PhysicalConnection physicalconnection = connection;
        JVM INSTR monitorenter ;
        ScrollableResultSet scrollableresultset = this;
        JVM INSTR monitorenter ;
        return new OracleResultSetMetaData(connection, (OracleStatement)scrollStmt, beginColumnIndex);
        Exception exception;
        exception;
        throw exception;
        Exception exception1;
        exception1;
        throw exception1;
    }

    public synchronized int findColumn(String s)
        throws SQLException
    {
        return resultSet.findColumn(s) - beginColumnIndex;
    }

    public synchronized void setFetchDirection(int i)
        throws SQLException
    {
        if(i == 1000)
            usrFetchDirection = i;
        else
        if(i == 1001 || i == 1002)
        {
            usrFetchDirection = i;
            sqlWarning = DatabaseError.addSqlWarning(sqlWarning, 87);
        } else
        {
            DatabaseError.throwSqlException(68, "setFetchDirection");
        }
    }

    public synchronized int getFetchDirection()
        throws SQLException
    {
        return 1000;
    }

    public synchronized void setFetchSize(int i)
        throws SQLException
    {
        resultSet.setFetchSize(i);
    }

    public synchronized int getFetchSize()
        throws SQLException
    {
        return resultSet.getFetchSize();
    }

    public int getType()
        throws SQLException
    {
        return rsetType;
    }

    public int getConcurrency()
        throws SQLException
    {
        return rsetConcurency;
    }

    public void refreshRow()
        throws SQLException
    {
        if(!needIdentifier(rsetType, rsetConcurency))
            DatabaseError.throwSqlException(23, "refreshRow");
        if(isValidRow(currentRow))
        {
            int i = getFetchDirection();
            try
            {
                refreshRowsInCache(currentRow, getFetchSize(), i);
            }
            catch(SQLException sqlexception)
            {
                DatabaseError.throwSqlException(sqlexception, 90, "Unsupported syntax for refreshRow()");
            }
        } else
        {
            DatabaseError.throwSqlException(82, "refreshRow");
        }
    }

    public void setCurrentRowValueAt(Object obj, int i, Object obj1)
        throws SQLException
    {
        if(obj instanceof UpdatableResultSet)
            putCachedValueAt(currentRow, i, obj1);
        else
            DatabaseError.throwSqlException(1);
    }

    private boolean isEmptyResultSet()
        throws SQLException
    {
        if(numRowsCached != 0)
            return false;
        if(numRowsCached == 0 && allRowsCached)
            return true;
        else
            return !isValidRow(1);
    }

    boolean isValidRow(int i)
        throws SQLException
    {
        if(i > 0 && i <= numRowsCached)
            return true;
        if(i <= 0)
            return false;
        else
            return cacheRowAt(i);
    }

    private boolean cacheRowAt(int i)
        throws SQLException
    {
        for(; numRowsCached < i && resultSet.next(); numRowsCached++)
        {
            for(int j = 0; j < getColumnCount(); j++)
            {
                byte abyte0[] = resultSet.privateGetBytes(j + 1);
                putCachedValueAt(numRowsCached + 1, j + 1, abyte0);
            }

        }

        if(numRowsCached < i)
        {
            allRowsCached = true;
            return false;
        } else
        {
            return true;
        }
    }

    private int cacheAllRows()
        throws SQLException
    {
        while(resultSet.next()) 
        {
            for(int i = 0; i < getColumnCount(); i++)
                putCachedValueAt(numRowsCached + 1, i + 1, resultSet.privateGetBytes(i + 1));

            numRowsCached++;
        }
        allRowsCached = true;
        return numRowsCached;
    }

    int getColumnCount()
        throws SQLException
    {
        if(columnCount == 0)
        {
            int i = resultSet.statement.numberOfDefinePositions;
            if(resultSet.statement.accessors != null && i > 0)
                columnCount = i;
            else
                columnCount = getInternalMetadata().getColumnCount();
        }
        return columnCount;
    }

    private ResultSetMetaData getInternalMetadata()
        throws SQLException
    {
        if(metadata == null)
            metadata = resultSet.getMetaData();
        return metadata;
    }

    private int getLastRow()
        throws SQLException
    {
        if(!allRowsCached)
            cacheAllRows();
        return numRowsCached;
    }

    private int get_refetch_size(int i, int j, int k)
        throws SQLException
    {
        byte byte0 = ((byte)(k != 1001 ? 1 : -1));
        int l = 0;
        if(refetchRowids == null)
            refetchRowids = new Vector(10);
        else
            refetchRowids.removeAllElements();
        for(; l < j && isValidRow(i + l * byte0); l++)
            refetchRowids.addElement(getCachedDatumValueAt(i + l * byte0, 1));

        return l;
    }

    private OraclePreparedStatement prepare_refetch_statement(int i)
        throws SQLException
    {
        if(i < 1)
            DatabaseError.throwSqlException(68);
        return (OraclePreparedStatement)connection.prepareStatement(((OracleStatement)scrollStmt).sqlObject.getRefetchSqlForScrollableResultSet(this, i));
    }

    private void prepare_refetch_binds(OraclePreparedStatement oraclepreparedstatement, int i)
        throws SQLException
    {
        int j = scrollStmt.copyBinds(oraclepreparedstatement, 0);
        for(int k = 0; k < i; k++)
            oraclepreparedstatement.setROWID(j + k + 1, (ROWID)refetchRowids.elementAt(k));

    }

    private void save_refetch_results(OracleResultSet oracleresultset, int i, int j, int k)
        throws SQLException
    {
        byte byte0 = ((byte)(k != 1001 ? 1 : -1));
        do
        {
            if(!oracleresultset.next())
                break;
            ROWID rowid = oracleresultset.getROWID(1);
            boolean flag = false;
            int l;
            for(l = i; !flag && l < i + j * byte0;)
                if(((ROWID)getCachedDatumValueAt(l, 1)).stringValue().equals(rowid.stringValue()))
                    flag = true;
                else
                    l += byte0;

            if(flag)
            {
                int i1 = 0;
                while(i1 < getColumnCount()) 
                {
                    putCachedValueAt(l, i1 + 1, oracleresultset.getOracleObject(i1 + 1));
                    i1++;
                }
            }
        } while(true);
    }

    private Object getCachedValueAt(int i, int j)
        throws SQLException
    {
        return rsetCache.get(i, j);
        IOException ioexception;
        ioexception;
        DatabaseError.throwSqlException(ioexception);
        return null;
    }

    private Datum getCachedDatumValueAt(int i, int j)
        throws SQLException
    {
        Object obj = null;
        try
        {
            obj = rsetCache.get(i, j);
        }
        catch(IOException ioexception)
        {
            DatabaseError.throwSqlException(ioexception);
        }
        Datum datum = null;
        if(obj != null)
            if(obj instanceof Datum)
                datum = (Datum)obj;
            else
            if(((byte[])obj).length > 0)
            {
                int k = getInternalMetadata().getColumnType(j);
                int l = getInternalMetadata().getColumnDisplaySize(j);
                int i1 = scrollStmt.getMaxFieldSize();
                if(i1 > 0 && i1 < l)
                    l = i1;
                String s = null;
                if(k == 2006 || k == 2002 || k == 2008 || k == 2007 || k == 2003)
                    s = getInternalMetadata().getColumnTypeName(j);
                int j1 = SQLUtil.getInternalType(k);
                short word0 = resultSet.statement.accessors[j - 1].formOfUse;
                if(word0 == 2 && (j1 == 96 || j1 == 1 || j1 == 8 || j1 == 112))
                    datum = SQLUtil.makeNDatum(connection, (byte[])obj, j1, s, word0, l);
                else
                    datum = SQLUtil.makeDatum(connection, (byte[])obj, j1, s, l);
                try
                {
                    rsetCache.put(i, j, datum);
                }
                catch(IOException ioexception2)
                {
                    DatabaseError.throwSqlException(ioexception2);
                }
            } else
            {
                try
                {
                    rsetCache.put(i, j, null);
                }
                catch(IOException ioexception1)
                {
                    DatabaseError.throwSqlException(ioexception1);
                }
            }
        return datum;
    }

    private void putCachedValueAt(int i, int j, Object obj)
        throws SQLException
    {
        try
        {
            rsetCache.put(i, j, obj);
        }
        catch(IOException ioexception)
        {
            DatabaseError.throwSqlException(ioexception);
        }
    }

    private void removeCachedRowAt(int i)
        throws SQLException
    {
        try
        {
            rsetCache.remove(i);
        }
        catch(IOException ioexception)
        {
            DatabaseError.throwSqlException(ioexception);
        }
    }

    public static boolean needIdentifier(int i, int j)
    {
        return (i != 1003 || j != 1007) && (i != 1004 || j != 1007);
    }

    public static boolean needCache(int i, int j)
    {
        return i != 1003 && (i != 1004 || j != 1007);
    }

    public static boolean supportRefreshRow(int i, int j)
    {
        return i != 1003 && (i != 1004 || j != 1007);
    }

    int getFirstUserColumnIndex()
    {
        return beginColumnIndex;
    }

    PhysicalConnection connection;
    OracleResultSetImpl resultSet;
    ScrollRsetStatement scrollStmt;
    ResultSetMetaData metadata;
    private int rsetType;
    private int rsetConcurency;
    private int beginColumnIndex;
    private int columnCount;
    private int wasNull;
    OracleResultSetCache rsetCache;
    int currentRow;
    private int numRowsCached;
    private boolean allRowsCached;
    private int lastRefetchSz;
    private Vector refetchRowids;
    private OraclePreparedStatement refetchStmt;
    private int usrFetchDirection;
    private static final String _Copyright_2004_Oracle_All_Rights_Reserved_ = null;
    public static final boolean TRACE = false;
    public static final boolean PRIVATE_TRACE = false;
    public static final String BUILD_DATE = "Sat_Feb__2_11:39:37_PST_2008";

}
