// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   UpdatableResultSet.java

package oracle.jdbc.driver;

import java.io.*;
import java.math.BigDecimal;
import java.net.MalformedURLException;
import java.net.URL;
import java.sql.*;
import java.util.Calendar;
import java.util.Map;
import oracle.sql.*;

// Referenced classes of package oracle.jdbc.driver:
//            BaseResultSet, OracleStatement, OracleResultSetMetaData, OracleResultSetImpl, 
//            ScrollableResultSet, OraclePreparedStatement, DatabaseError, ScrollRsetStatement, 
//            OracleResultSet, PhysicalConnection, DBConversion, SQLUtil, 
//            OracleSql

class UpdatableResultSet extends BaseResultSet
{

    UpdatableResultSet(ScrollRsetStatement scrollrsetstatement, ScrollableResultSet scrollableresultset, int i, int j)
        throws SQLException
    {
        init(scrollrsetstatement, scrollableresultset, i, j);
        scrollableresultset.resetBeginColumnIndex();
        getInternalMetadata();
        isCachedRset = true;
    }

    UpdatableResultSet(ScrollRsetStatement scrollrsetstatement, OracleResultSetImpl oracleresultsetimpl, int i, int j)
        throws SQLException
    {
        init(scrollrsetstatement, oracleresultsetimpl, i, j);
        getInternalMetadata();
        isCachedRset = false;
    }

    private void init(ScrollRsetStatement scrollrsetstatement, OracleResultSet oracleresultset, int i, int j)
        throws SQLException
    {
        if(scrollrsetstatement == null || oracleresultset == null || j != 1008)
            DatabaseError.throwSqlException(68);
        connection = ((OracleStatement)scrollrsetstatement).connection;
        resultSet = oracleresultset;
        scrollStmt = scrollrsetstatement;
        rsetType = i;
        autoRefetch = scrollrsetstatement.getAutoRefetch();
        deleteStmt = null;
        insertStmt = null;
        updateStmt = null;
        indexColsChanged = null;
        rowBuffer = null;
        m_nullIndicator = null;
        typeInfo = (int[][])null;
        isInserting = false;
        isUpdating = false;
        wasNull = -1;
        rsetMetaData = null;
        columnCount = 0;
    }

    public synchronized void close()
        throws SQLException
    {
        if(resultSet != null)
            resultSet.close();
        if(insertStmt != null)
            insertStmt.close();
        if(updateStmt != null)
            updateStmt.close();
        if(deleteStmt != null)
            deleteStmt.close();
        if(scrollStmt != null)
            scrollStmt.notifyCloseRset();
        cancelRowInserts();
        connection = null;
        resultSet = null;
        scrollStmt = null;
        rsetMetaData = null;
        scrollStmt = null;
        deleteStmt = null;
        insertStmt = null;
        updateStmt = null;
        indexColsChanged = null;
        rowBuffer = null;
        m_nullIndicator = null;
        typeInfo = (int[][])null;
    }

    public synchronized boolean wasNull()
        throws SQLException
    {
        switch(wasNull)
        {
        case 1: // '\001'
            return true;

        case 2: // '\002'
            return false;

        case 4: // '\004'
            return resultSet.wasNull();

        case 3: // '\003'
        default:
            DatabaseError.throwSqlException(24);
            break;
        }
        return false;
    }

    int getFirstUserColumnIndex()
    {
        return 1;
    }

    public synchronized Statement getStatement()
        throws SQLException
    {
        return (Statement)scrollStmt;
    }

    public SQLWarning getWarnings()
        throws SQLException
    {
        SQLWarning sqlwarning = resultSet.getWarnings();
        if(sqlWarning == null)
            return sqlwarning;
        SQLWarning sqlwarning1;
        for(sqlwarning1 = sqlWarning; sqlwarning1.getNextWarning() != null; sqlwarning1 = sqlwarning1.getNextWarning());
        sqlwarning1.setNextWarning(sqlwarning);
        return sqlWarning;
    }

    public void clearWarnings()
        throws SQLException
    {
        sqlWarning = null;
        resultSet.clearWarnings();
    }

    public synchronized boolean next()
        throws SQLException
    {
        cancelRowChanges();
        return resultSet.next();
    }

    public synchronized boolean isBeforeFirst()
        throws SQLException
    {
        return resultSet.isBeforeFirst();
    }

    public synchronized boolean isAfterLast()
        throws SQLException
    {
        return resultSet.isAfterLast();
    }

    public synchronized boolean isFirst()
        throws SQLException
    {
        return resultSet.isFirst();
    }

    public synchronized boolean isLast()
        throws SQLException
    {
        return resultSet.isLast();
    }

    public synchronized void beforeFirst()
        throws SQLException
    {
        cancelRowChanges();
        resultSet.beforeFirst();
    }

    public synchronized void afterLast()
        throws SQLException
    {
        cancelRowChanges();
        resultSet.afterLast();
    }

    public synchronized boolean first()
        throws SQLException
    {
        cancelRowChanges();
        return resultSet.first();
    }

    public synchronized boolean last()
        throws SQLException
    {
        cancelRowChanges();
        return resultSet.last();
    }

    public synchronized int getRow()
        throws SQLException
    {
        return resultSet.getRow();
    }

    public boolean absolute(int i)
        throws SQLException
    {
        PhysicalConnection physicalconnection = connection;
        JVM INSTR monitorenter ;
        UpdatableResultSet updatableresultset = this;
        JVM INSTR monitorenter ;
        cancelRowChanges();
        return resultSet.absolute(i);
        Exception exception;
        exception;
        throw exception;
        Exception exception1;
        exception1;
        throw exception1;
    }

    public synchronized boolean relative(int i)
        throws SQLException
    {
        cancelRowChanges();
        return resultSet.relative(i);
    }

    public synchronized boolean previous()
        throws SQLException
    {
        cancelRowChanges();
        return resultSet.previous();
    }

    public synchronized Datum getOracleObject(int i)
        throws SQLException
    {
        Datum datum = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            setIsNull(datum == null);
            datum = getRowBufferDatumAt(i);
        } else
        {
            setIsNull(4);
            datum = resultSet.getOracleObject(i + 1);
        }
        return datum;
    }

    public synchronized String getString(int i)
        throws SQLException
    {
        String s = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                s = datum.stringValue();
        } else
        {
            setIsNull(4);
            s = resultSet.getString(i + 1);
        }
        return s;
    }

    public synchronized boolean getBoolean(int i)
        throws SQLException
    {
        boolean flag = false;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                flag = datum.booleanValue();
        } else
        {
            setIsNull(4);
            flag = resultSet.getBoolean(i + 1);
        }
        return flag;
    }

    public synchronized byte getByte(int i)
        throws SQLException
    {
        byte byte0 = 0;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                byte0 = datum.byteValue();
        } else
        {
            setIsNull(4);
            byte0 = resultSet.getByte(i + 1);
        }
        return byte0;
    }

    public synchronized short getShort(int i)
        throws SQLException
    {
        short word0 = 0;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            long l = getLong(i);
            if(l > 0x10001L || l < 0xfffffffffffefffeL)
                DatabaseError.throwSqlException(26, "getShort");
            word0 = (short)(int)l;
        } else
        {
            setIsNull(4);
            word0 = resultSet.getShort(i + 1);
        }
        return word0;
    }

    public synchronized int getInt(int i)
        throws SQLException
    {
        int j = 0;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                j = datum.intValue();
        } else
        {
            setIsNull(4);
            j = resultSet.getInt(i + 1);
        }
        return j;
    }

    public synchronized long getLong(int i)
        throws SQLException
    {
        long l = 0L;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                l = datum.longValue();
        } else
        {
            setIsNull(4);
            l = resultSet.getLong(i + 1);
        }
        return l;
    }

    public synchronized float getFloat(int i)
        throws SQLException
    {
        float f = 0.0F;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                f = datum.floatValue();
        } else
        {
            setIsNull(4);
            f = resultSet.getFloat(i + 1);
        }
        return f;
    }

    public synchronized double getDouble(int i)
        throws SQLException
    {
        double d = 0.0D;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                d = datum.doubleValue();
        } else
        {
            setIsNull(4);
            d = resultSet.getDouble(i + 1);
        }
        return d;
    }

    public synchronized BigDecimal getBigDecimal(int i, int j)
        throws SQLException
    {
        BigDecimal bigdecimal = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                bigdecimal = datum.bigDecimalValue();
        } else
        {
            setIsNull(4);
            bigdecimal = resultSet.getBigDecimal(i + 1);
        }
        return bigdecimal;
    }

    public synchronized byte[] getBytes(int i)
        throws SQLException
    {
        byte abyte0[] = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                abyte0 = datum.getBytes();
        } else
        {
            setIsNull(4);
            abyte0 = resultSet.getBytes(i + 1);
        }
        return abyte0;
    }

    public synchronized Date getDate(int i)
        throws SQLException
    {
        Date date = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                date = datum.dateValue();
        } else
        {
            setIsNull(4);
            date = resultSet.getDate(i + 1);
        }
        return date;
    }

    public synchronized Time getTime(int i)
        throws SQLException
    {
        Time time = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                time = datum.timeValue();
        } else
        {
            setIsNull(4);
            time = resultSet.getTime(i + 1);
        }
        return time;
    }

    public synchronized Timestamp getTimestamp(int i)
        throws SQLException
    {
        Timestamp timestamp = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                timestamp = datum.timestampValue();
        } else
        {
            setIsNull(4);
            timestamp = resultSet.getTimestamp(i + 1);
        }
        return timestamp;
    }

    public synchronized InputStream getAsciiStream(int i)
        throws SQLException
    {
        InputStream inputstream = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Object obj = getRowBufferAt(i);
            setIsNull(obj == null);
            if(obj != null)
                if(obj instanceof InputStream)
                {
                    inputstream = (InputStream)obj;
                } else
                {
                    Datum datum = getRowBufferDatumAt(i);
                    inputstream = datum.asciiStreamValue();
                }
        } else
        {
            setIsNull(4);
            inputstream = resultSet.getAsciiStream(i + 1);
        }
        return inputstream;
    }

    public synchronized InputStream getUnicodeStream(int i)
        throws SQLException
    {
        InputStream inputstream = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Object obj = getRowBufferAt(i);
            setIsNull(obj == null);
            if(obj != null)
                if(obj instanceof InputStream)
                {
                    inputstream = (InputStream)obj;
                } else
                {
                    Datum datum = getRowBufferDatumAt(i);
                    DBConversion dbconversion = connection.conversion;
                    byte abyte0[] = datum.shareBytes();
                    if(datum instanceof RAW)
                    {
                        PhysicalConnection _tmp = connection;
                        inputstream = dbconversion.ConvertStream(new ByteArrayInputStream(abyte0), 3);
                    } else
                    if(datum instanceof CHAR)
                    {
                        PhysicalConnection _tmp1 = connection;
                        inputstream = dbconversion.ConvertStream(new ByteArrayInputStream(abyte0), 1);
                    } else
                    {
                        DatabaseError.throwSqlException(4, "getUnicodeStream");
                    }
                }
        } else
        {
            setIsNull(4);
            inputstream = resultSet.getUnicodeStream(i + 1);
        }
        return inputstream;
    }

    public synchronized InputStream getBinaryStream(int i)
        throws SQLException
    {
        InputStream inputstream = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Object obj = getRowBufferAt(i);
            setIsNull(obj == null);
            if(obj != null)
                if(obj instanceof InputStream)
                {
                    inputstream = (InputStream)obj;
                } else
                {
                    Datum datum = getRowBufferDatumAt(i);
                    inputstream = datum.binaryStreamValue();
                }
        } else
        {
            setIsNull(4);
            inputstream = resultSet.getBinaryStream(i + 1);
        }
        return inputstream;
    }

    public synchronized Object getObject(int i)
        throws SQLException
    {
        Object obj = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getOracleObject(i);
            setIsNull(datum == null);
            if(datum != null)
                obj = datum.toJdbc();
        } else
        {
            setIsNull(4);
            obj = resultSet.getObject(i + 1);
        }
        return obj;
    }

    public synchronized Reader getCharacterStream(int i)
        throws SQLException
    {
        Reader reader = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Object obj = getRowBufferAt(i);
            setIsNull(obj == null);
            if(obj != null)
                if(obj instanceof Reader)
                {
                    reader = (Reader)obj;
                } else
                {
                    Datum datum = getRowBufferDatumAt(i);
                    reader = datum.characterStreamValue();
                }
        } else
        {
            setIsNull(4);
            reader = resultSet.getCharacterStream(i + 1);
        }
        return reader;
    }

    public synchronized BigDecimal getBigDecimal(int i)
        throws SQLException
    {
        BigDecimal bigdecimal = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null)
                bigdecimal = datum.bigDecimalValue();
        } else
        {
            setIsNull(4);
            bigdecimal = resultSet.getBigDecimal(i + 1);
        }
        return bigdecimal;
    }

    public synchronized Object getObject(int i, Map map)
        throws SQLException
    {
        Object obj = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getOracleObject(i);
            setIsNull(datum == null);
            if(datum != null)
                if(datum instanceof STRUCT)
                    obj = ((STRUCT)datum).toJdbc(map);
                else
                    obj = datum.toJdbc();
        } else
        {
            setIsNull(4);
            obj = resultSet.getObject(i + 1, map);
        }
        return obj;
    }

    public synchronized Ref getRef(int i)
        throws SQLException
    {
        return getREF(i);
    }

    public synchronized Blob getBlob(int i)
        throws SQLException
    {
        return getBLOB(i);
    }

    public synchronized Clob getClob(int i)
        throws SQLException
    {
        return getCLOB(i);
    }

    public synchronized Array getArray(int i)
        throws SQLException
    {
        return getARRAY(i);
    }

    public synchronized Date getDate(int i, Calendar calendar)
        throws SQLException
    {
        Date date = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getOracleObject(i);
            setIsNull(datum == null);
            if(datum != null)
                if(datum instanceof DATE)
                {
                    date = ((DATE)datum).dateValue(calendar);
                } else
                {
                    DATE date1 = new DATE(datum.stringValue());
                    if(date1 != null)
                        date = date1.dateValue(calendar);
                }
        } else
        {
            setIsNull(4);
            date = resultSet.getDate(i + 1, calendar);
        }
        return date;
    }

    public synchronized Time getTime(int i, Calendar calendar)
        throws SQLException
    {
        Time time = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getOracleObject(i);
            setIsNull(datum == null);
            if(datum != null)
                if(datum instanceof DATE)
                {
                    time = ((DATE)datum).timeValue(calendar);
                } else
                {
                    DATE date = new DATE(datum.stringValue());
                    if(date != null)
                        time = date.timeValue(calendar);
                }
        } else
        {
            setIsNull(4);
            time = resultSet.getTime(i + 1, calendar);
        }
        return time;
    }

    public synchronized Timestamp getTimestamp(int i, Calendar calendar)
        throws SQLException
    {
        Timestamp timestamp = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getOracleObject(i);
            setIsNull(datum == null);
            if(datum != null)
                if(datum instanceof DATE)
                {
                    timestamp = ((DATE)datum).timestampValue(calendar);
                } else
                {
                    DATE date = new DATE(datum.stringValue());
                    if(date != null)
                        timestamp = date.timestampValue(calendar);
                }
        } else
        {
            setIsNull(4);
            timestamp = resultSet.getTimestamp(i + 1, calendar);
        }
        return timestamp;
    }

    public synchronized URL getURL(int i)
        throws SQLException
    {
        URL url = null;
        int j = getInternalMetadata().getColumnType(i);
        int k = SQLUtil.getInternalType(j);
        if(k == 96 || k == 1 || k == 8)
            try
            {
                url = new URL(getString(i));
            }
            catch(MalformedURLException malformedurlexception)
            {
                DatabaseError.throwSqlException(136);
            }
        else
            throw new SQLException("Conversion to java.net.URL not supported.");
        return url;
    }

    public synchronized ResultSet getCursor(int i)
        throws SQLException
    {
        ResultSet resultset = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getOracleObject(i);
            setIsNull(datum == null);
            DatabaseError.throwSqlException(4, "getCursor");
        } else
        {
            setIsNull(4);
            resultset = resultSet.getCursor(i + 1);
        }
        return resultset;
    }

    public synchronized ROWID getROWID(int i)
        throws SQLException
    {
        ROWID rowid = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof ROWID))
                DatabaseError.throwSqlException(4, "getROWID");
            rowid = (ROWID)datum;
        } else
        {
            setIsNull(4);
            rowid = resultSet.getROWID(i + 1);
        }
        return rowid;
    }

    public synchronized NUMBER getNUMBER(int i)
        throws SQLException
    {
        NUMBER number = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof NUMBER))
                DatabaseError.throwSqlException(4, "getNUMBER");
            number = (NUMBER)datum;
        } else
        {
            setIsNull(4);
            number = resultSet.getNUMBER(i + 1);
        }
        return number;
    }

    public synchronized DATE getDATE(int i)
        throws SQLException
    {
        DATE date = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof DATE))
                DatabaseError.throwSqlException(4, "getDATE");
            date = (DATE)datum;
        } else
        {
            setIsNull(4);
            date = resultSet.getDATE(i + 1);
        }
        return date;
    }

    public synchronized TIMESTAMP getTIMESTAMP(int i)
        throws SQLException
    {
        TIMESTAMP timestamp = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof TIMESTAMP))
                DatabaseError.throwSqlException(4, "getTIMESTAMP");
            timestamp = (TIMESTAMP)datum;
        } else
        {
            setIsNull(4);
            timestamp = resultSet.getTIMESTAMP(i + 1);
        }
        return timestamp;
    }

    public synchronized TIMESTAMPTZ getTIMESTAMPTZ(int i)
        throws SQLException
    {
        TIMESTAMPTZ timestamptz = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof TIMESTAMPTZ))
                DatabaseError.throwSqlException(4, "getTIMESTAMPTZ");
            timestamptz = (TIMESTAMPTZ)datum;
        } else
        {
            setIsNull(4);
            timestamptz = resultSet.getTIMESTAMPTZ(i + 1);
        }
        return timestamptz;
    }

    public synchronized TIMESTAMPLTZ getTIMESTAMPLTZ(int i)
        throws SQLException
    {
        TIMESTAMPLTZ timestampltz = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof TIMESTAMPLTZ))
                DatabaseError.throwSqlException(4, "getTIMESTAMPLTZ");
            timestampltz = (TIMESTAMPLTZ)datum;
        } else
        {
            setIsNull(4);
            timestampltz = resultSet.getTIMESTAMPLTZ(i + 1);
        }
        return timestampltz;
    }

    public synchronized INTERVALDS getINTERVALDS(int i)
        throws SQLException
    {
        INTERVALDS intervalds = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof INTERVALDS))
                DatabaseError.throwSqlException(4, "getINTERVALDS");
            intervalds = (INTERVALDS)datum;
        } else
        {
            setIsNull(4);
            intervalds = resultSet.getINTERVALDS(i + 1);
        }
        return intervalds;
    }

    public synchronized INTERVALYM getINTERVALYM(int i)
        throws SQLException
    {
        INTERVALYM intervalym = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof INTERVALYM))
                DatabaseError.throwSqlException(4, "getINTERVALYM");
            intervalym = (INTERVALYM)datum;
        } else
        {
            setIsNull(4);
            intervalym = resultSet.getINTERVALYM(i + 1);
        }
        return intervalym;
    }

    public synchronized ARRAY getARRAY(int i)
        throws SQLException
    {
        ARRAY array = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof ARRAY))
                DatabaseError.throwSqlException(4, "getARRAY");
            array = (ARRAY)datum;
        } else
        {
            setIsNull(4);
            array = resultSet.getARRAY(i + 1);
        }
        return array;
    }

    public synchronized STRUCT getSTRUCT(int i)
        throws SQLException
    {
        STRUCT struct = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof STRUCT))
                DatabaseError.throwSqlException(4, "getSTRUCT");
            struct = (STRUCT)datum;
        } else
        {
            setIsNull(4);
            struct = resultSet.getSTRUCT(i + 1);
        }
        return struct;
    }

    public synchronized OPAQUE getOPAQUE(int i)
        throws SQLException
    {
        OPAQUE opaque = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof OPAQUE))
                DatabaseError.throwSqlException(4, "getOPAQUE");
            opaque = (OPAQUE)datum;
        } else
        {
            setIsNull(4);
            opaque = resultSet.getOPAQUE(i + 1);
        }
        return opaque;
    }

    public synchronized REF getREF(int i)
        throws SQLException
    {
        REF ref = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof REF))
                DatabaseError.throwSqlException(4, "getREF");
            ref = (REF)datum;
        } else
        {
            setIsNull(4);
            ref = resultSet.getREF(i + 1);
        }
        return ref;
    }

    public synchronized CHAR getCHAR(int i)
        throws SQLException
    {
        CHAR char1 = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof CHAR))
                DatabaseError.throwSqlException(4, "getCHAR");
            char1 = (CHAR)datum;
        } else
        {
            setIsNull(4);
            char1 = resultSet.getCHAR(i + 1);
        }
        return char1;
    }

    public synchronized RAW getRAW(int i)
        throws SQLException
    {
        RAW raw = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof RAW))
                DatabaseError.throwSqlException(4, "getRAW");
            raw = (RAW)datum;
        } else
        {
            setIsNull(4);
            raw = resultSet.getRAW(i + 1);
        }
        return raw;
    }

    public synchronized BLOB getBLOB(int i)
        throws SQLException
    {
        BLOB blob = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof BLOB))
                DatabaseError.throwSqlException(4, "getBLOB");
            blob = (BLOB)datum;
        } else
        {
            setIsNull(4);
            blob = resultSet.getBLOB(i + 1);
        }
        return blob;
    }

    public synchronized CLOB getCLOB(int i)
        throws SQLException
    {
        CLOB clob = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof CLOB))
                DatabaseError.throwSqlException(4, "getCLOB");
            clob = (CLOB)datum;
        } else
        {
            setIsNull(4);
            clob = resultSet.getCLOB(i + 1);
        }
        return clob;
    }

    public synchronized BFILE getBFILE(int i)
        throws SQLException
    {
        BFILE bfile = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            if(datum != null && !(datum instanceof BFILE))
                DatabaseError.throwSqlException(4, "getBFILE");
            bfile = (BFILE)datum;
        } else
        {
            setIsNull(4);
            bfile = resultSet.getBFILE(i + 1);
        }
        return bfile;
    }

    public synchronized BFILE getBfile(int i)
        throws SQLException
    {
        return getBFILE(i);
    }

    public synchronized CustomDatum getCustomDatum(int i, CustomDatumFactory customdatumfactory)
        throws SQLException
    {
        if(customdatumfactory == null)
            DatabaseError.throwSqlException(68);
        CustomDatum customdatum = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            customdatum = customdatumfactory.create(datum, 0);
        } else
        {
            setIsNull(4);
            customdatum = resultSet.getCustomDatum(i + 1, customdatumfactory);
        }
        return customdatum;
    }

    public synchronized ORAData getORAData(int i, ORADataFactory oradatafactory)
        throws SQLException
    {
        if(oradatafactory == null)
            DatabaseError.throwSqlException(68);
        ORAData oradata = null;
        setIsNull(3);
        if(isOnInsertRow() || isUpdatingRow() && isRowBufferUpdatedAt(i))
        {
            Datum datum = getRowBufferDatumAt(i);
            setIsNull(datum == null);
            oradata = oradatafactory.create(datum, 0);
        } else
        {
            setIsNull(4);
            oradata = resultSet.getORAData(i + 1, oradatafactory);
        }
        return oradata;
    }

    public ResultSetMetaData getMetaData()
        throws SQLException
    {
        if(((OracleStatement)scrollStmt).closed)
            DatabaseError.throwSqlException(9, "getMetaData");
        PhysicalConnection physicalconnection = connection;
        JVM INSTR monitorenter ;
        UpdatableResultSet updatableresultset = this;
        JVM INSTR monitorenter ;
        return new OracleResultSetMetaData(connection, (OracleStatement)scrollStmt, 1);
        Exception exception;
        exception;
        throw exception;
        Exception exception1;
        exception1;
        throw exception1;
    }

    public synchronized int findColumn(String s)
        throws SQLException
    {
        return resultSet.findColumn(s) - 1;
    }

    public synchronized void setFetchDirection(int i)
        throws SQLException
    {
        resultSet.setFetchDirection(i);
    }

    public synchronized int getFetchDirection()
        throws SQLException
    {
        return resultSet.getFetchDirection();
    }

    public synchronized void setFetchSize(int i)
        throws SQLException
    {
        resultSet.setFetchSize(i);
    }

    public synchronized int getFetchSize()
        throws SQLException
    {
        return resultSet.getFetchSize();
    }

    public int getType()
        throws SQLException
    {
        return rsetType;
    }

    public int getConcurrency()
        throws SQLException
    {
        return 1008;
    }

    public boolean rowUpdated()
        throws SQLException
    {
        return false;
    }

    public boolean rowInserted()
        throws SQLException
    {
        return false;
    }

    public boolean rowDeleted()
        throws SQLException
    {
        return false;
    }

    public synchronized void insertRow()
        throws SQLException
    {
        if(!isOnInsertRow())
            DatabaseError.throwSqlException(83);
        prepareInsertRowStatement();
        prepareInsertRowBinds();
        executeInsertRow();
    }

    public void updateRow()
        throws SQLException
    {
        synchronized(connection)
        {
            synchronized(this)
            {
                if(isOnInsertRow())
                    DatabaseError.throwSqlException(84);
                int i = getNumColumnsChanged();
                if(i > 0)
                {
                    prepareUpdateRowStatement(i);
                    prepareUpdateRowBinds(i);
                    executeUpdateRow();
                }
            }
        }
    }

    public synchronized void deleteRow()
        throws SQLException
    {
        if(isOnInsertRow())
            DatabaseError.throwSqlException(84);
        prepareDeleteRowStatement();
        prepareDeleteRowBinds();
        executeDeleteRow();
    }

    public void refreshRow()
        throws SQLException
    {
        synchronized(connection)
        {
            synchronized(this)
            {
                if(isOnInsertRow())
                    DatabaseError.throwSqlException(84);
                resultSet.refreshRow();
            }
        }
    }

    public synchronized void cancelRowUpdates()
        throws SQLException
    {
        if(isUpdating)
        {
            isUpdating = false;
            clearRowBuffer();
        }
    }

    public synchronized void moveToInsertRow()
        throws SQLException
    {
        if(isOnInsertRow())
            return;
        isInserting = true;
        if(rowBuffer == null)
            rowBuffer = new Object[getColumnCount()];
        if(m_nullIndicator == null)
            m_nullIndicator = new boolean[getColumnCount()];
        clearRowBuffer();
    }

    public synchronized void moveToCurrentRow()
        throws SQLException
    {
        cancelRowInserts();
    }

    public synchronized void updateString(int i, String s)
        throws SQLException
    {
        updateObject(i, s);
    }

    public synchronized void updateNull(int i)
        throws SQLException
    {
        setRowBufferAt(i, null);
    }

    public void updateBoolean(int i, boolean flag)
        throws SQLException
    {
        updateObject(i, new Boolean(flag));
    }

    public void updateByte(int i, byte byte0)
        throws SQLException
    {
        updateObject(i, new Integer(byte0));
    }

    public void updateShort(int i, short word0)
        throws SQLException
    {
        updateObject(i, new Integer(word0));
    }

    public void updateInt(int i, int j)
        throws SQLException
    {
        updateObject(i, new Integer(j));
    }

    public void updateLong(int i, long l)
        throws SQLException
    {
        updateObject(i, new Long(l));
    }

    public void updateFloat(int i, float f)
        throws SQLException
    {
        updateObject(i, new Float(f));
    }

    public void updateDouble(int i, double d)
        throws SQLException
    {
        updateObject(i, new Double(d));
    }

    public void updateBigDecimal(int i, BigDecimal bigdecimal)
        throws SQLException
    {
        updateObject(i, bigdecimal);
    }

    public void updateBytes(int i, byte abyte0[])
        throws SQLException
    {
        updateObject(i, abyte0);
    }

    public void updateDate(int i, Date date)
        throws SQLException
    {
        updateObject(i, date);
    }

    public void updateTime(int i, Time time)
        throws SQLException
    {
        updateObject(i, time);
    }

    public void updateTimestamp(int i, Timestamp timestamp)
        throws SQLException
    {
        updateObject(i, timestamp);
    }

    public void updateAsciiStream(int i, InputStream inputstream, int j)
        throws SQLException
    {
        byte abyte0[];
        int k = getInternalMetadata().getColumnType(1 + i);
        if(inputstream == null || j <= 0)
            break MISSING_BLOCK_LABEL_117;
        if(isStreamType(k))
            break MISSING_BLOCK_LABEL_93;
        abyte0 = new byte[j];
        int l;
        l = inputstream.read(abyte0);
        inputstream.close();
        if(l <= 0)
        {
            updateNull(i);
            return;
        }
        try
        {
            String s = new String(abyte0, 0, l);
            updateString(i, s);
        }
        catch(IOException ioexception)
        {
            DatabaseError.throwSqlException(ioexception);
        }
        break MISSING_BLOCK_LABEL_123;
        int ai[] = {
            j, 1
        };
        setRowBufferAt(i, inputstream, ai);
        break MISSING_BLOCK_LABEL_123;
        setRowBufferAt(i, null);
    }

    final boolean isStreamType(int i)
    {
        return i == 2004 || i == 2005 || i == -4 || i == -1;
    }

    public void updateBinaryStream(int i, InputStream inputstream, int j)
        throws SQLException
    {
        byte abyte0[];
        int k = getInternalMetadata().getColumnType(1 + i);
        if(inputstream == null || j <= 0)
            break MISSING_BLOCK_LABEL_133;
        if(isStreamType(k))
            break MISSING_BLOCK_LABEL_109;
        abyte0 = new byte[j];
        int l = inputstream.read(abyte0);
        inputstream.close();
        if(l < j)
        {
            byte abyte1[] = new byte[l];
            System.arraycopy(abyte0, 0, abyte1, 0, l);
            abyte0 = abyte1;
        } else
        if(l <= 0)
        {
            updateNull(i);
            return;
        }
        try
        {
            updateBytes(i, abyte0);
        }
        catch(IOException ioexception)
        {
            DatabaseError.throwSqlException(ioexception);
        }
        break MISSING_BLOCK_LABEL_139;
        int ai[] = {
            j, 2
        };
        setRowBufferAt(i, inputstream, ai);
        break MISSING_BLOCK_LABEL_139;
        setRowBufferAt(i, null);
    }

    public void updateCharacterStream(int i, Reader reader, int j)
        throws SQLException
    {
        char ac[];
        int k = getInternalMetadata().getColumnType(1 + i);
        if(reader == null || j <= 0)
            break MISSING_BLOCK_LABEL_113;
        if(isStreamType(k))
            break MISSING_BLOCK_LABEL_93;
        ac = new char[j];
        int l;
        l = reader.read(ac);
        reader.close();
        if(l <= 0)
        {
            updateNull(i);
            return;
        }
        try
        {
            String s = new String(ac, 0, l);
            updateString(i, s);
        }
        catch(IOException ioexception)
        {
            DatabaseError.throwSqlException(ioexception);
        }
        break MISSING_BLOCK_LABEL_119;
        int ai[] = {
            j
        };
        setRowBufferAt(i, reader, ai);
        break MISSING_BLOCK_LABEL_119;
        setRowBufferAt(i, null);
    }

    public void updateObject(int i, Object obj, int j)
        throws SQLException
    {
        updateObject(i, obj);
    }

    public synchronized void updateObject(int i, Object obj)
        throws SQLException
    {
        Datum datum = null;
        if(obj != null)
            if(obj instanceof Datum)
            {
                datum = (Datum)obj;
            } else
            {
                OracleResultSetMetaData oracleresultsetmetadata = (OracleResultSetMetaData)getInternalMetadata();
                int j = i + 1;
                datum = SQLUtil.makeOracleDatum(connection, obj, oracleresultsetmetadata.getColumnType(j), null, oracleresultsetmetadata.isNCHAR(j));
            }
        setRowBufferAt(i, datum);
    }

    public synchronized void updateOracleObject(int i, Datum datum)
        throws SQLException
    {
        setRowBufferAt(i, datum);
    }

    public void updateROWID(int i, ROWID rowid)
        throws SQLException
    {
        updateOracleObject(i, rowid);
    }

    public void updateNUMBER(int i, NUMBER number)
        throws SQLException
    {
        updateOracleObject(i, number);
    }

    public void updateDATE(int i, DATE date)
        throws SQLException
    {
        updateOracleObject(i, date);
    }

    public void updateINTERVALYM(int i, INTERVALYM intervalym)
        throws SQLException
    {
        updateOracleObject(i, intervalym);
    }

    public void updateINTERVALDS(int i, INTERVALDS intervalds)
        throws SQLException
    {
        updateOracleObject(i, intervalds);
    }

    public void updateTIMESTAMP(int i, TIMESTAMP timestamp)
        throws SQLException
    {
        updateOracleObject(i, timestamp);
    }

    public void updateTIMESTAMPTZ(int i, TIMESTAMPTZ timestamptz)
        throws SQLException
    {
        updateOracleObject(i, timestamptz);
    }

    public void updateTIMESTAMPLTZ(int i, TIMESTAMPLTZ timestampltz)
        throws SQLException
    {
        updateOracleObject(i, timestampltz);
    }

    public void updateARRAY(int i, ARRAY array)
        throws SQLException
    {
        updateOracleObject(i, array);
    }

    public void updateSTRUCT(int i, STRUCT struct)
        throws SQLException
    {
        updateOracleObject(i, struct);
    }

    public void updateOPAQUE(int i, OPAQUE opaque)
        throws SQLException
    {
        updateOracleObject(i, opaque);
    }

    public void updateREF(int i, REF ref)
        throws SQLException
    {
        updateOracleObject(i, ref);
    }

    public void updateCHAR(int i, CHAR char1)
        throws SQLException
    {
        updateOracleObject(i, char1);
    }

    public void updateRAW(int i, RAW raw)
        throws SQLException
    {
        updateOracleObject(i, raw);
    }

    public void updateBLOB(int i, BLOB blob)
        throws SQLException
    {
        updateOracleObject(i, blob);
    }

    public void updateCLOB(int i, CLOB clob)
        throws SQLException
    {
        updateOracleObject(i, clob);
    }

    public void updateBFILE(int i, BFILE bfile)
        throws SQLException
    {
        updateOracleObject(i, bfile);
    }

    public void updateBfile(int i, BFILE bfile)
        throws SQLException
    {
        updateOracleObject(i, bfile);
    }

    public void updateCustomDatum(int i, CustomDatum customdatum)
        throws SQLException
    {
        throw new Error("wanna do datum = ((CustomDatum) x).toDatum(m_comm)");
    }

    public void updateORAData(int i, ORAData oradata)
        throws SQLException
    {
        Datum datum = oradata.toDatum(connection);
        updateOracleObject(i, datum);
    }

    public void updateRef(int i, Ref ref)
        throws SQLException
    {
        updateREF(i, (REF)ref);
    }

    public void updateBlob(int i, Blob blob)
        throws SQLException
    {
        updateBLOB(i, (BLOB)blob);
    }

    public void updateClob(int i, Clob clob)
        throws SQLException
    {
        updateCLOB(i, (CLOB)clob);
    }

    public void updateArray(int i, Array array)
        throws SQLException
    {
        updateARRAY(i, (ARRAY)array);
    }

    int getColumnCount()
        throws SQLException
    {
        if(columnCount == 0)
            if(resultSet instanceof OracleResultSetImpl)
            {
                if(((OracleResultSetImpl)resultSet).statement.accessors != null)
                    columnCount = ((OracleResultSetImpl)resultSet).statement.numberOfDefinePositions;
                else
                    columnCount = getInternalMetadata().getColumnCount();
            } else
            {
                columnCount = ((ScrollableResultSet)resultSet).getColumnCount();
            }
        return columnCount;
    }

    ResultSetMetaData getInternalMetadata()
        throws SQLException
    {
        if(rsetMetaData == null)
            rsetMetaData = resultSet.getMetaData();
        return rsetMetaData;
    }

    private synchronized void cancelRowChanges()
        throws SQLException
    {
        synchronized(connection)
        {
            synchronized(this)
            {
                if(isInserting)
                    cancelRowInserts();
                if(isUpdating)
                    cancelRowUpdates();
            }
        }
    }

    boolean isOnInsertRow()
    {
        return isInserting;
    }

    private void cancelRowInserts()
    {
        if(isInserting)
        {
            isInserting = false;
            clearRowBuffer();
        }
    }

    boolean isUpdatingRow()
    {
        return isUpdating;
    }

    private void clearRowBuffer()
    {
        if(rowBuffer != null)
        {
            for(int i = 0; i < rowBuffer.length; i++)
                rowBuffer[i] = null;

        }
        if(m_nullIndicator != null)
        {
            for(int j = 0; j < m_nullIndicator.length; j++)
                m_nullIndicator[j] = false;

        }
        if(typeInfo != null)
        {
            for(int k = 0; k < typeInfo.length; k++)
            {
                if(typeInfo[k] == null)
                    continue;
                for(int l = 0; l < typeInfo[k].length; l++)
                    typeInfo[k][l] = 0;

            }

        }
    }

    private void setRowBufferAt(int i, Datum datum)
        throws SQLException
    {
        setRowBufferAt(i, datum, (int[])null);
    }

    private void setRowBufferAt(int i, Object obj, int ai[])
        throws SQLException
    {
        if(!isInserting)
            if(isBeforeFirst() || isAfterLast() || getRow() == 0)
                DatabaseError.throwSqlException(82);
            else
                isUpdating = true;
        if(i < 1 || i > getColumnCount() - 1)
            DatabaseError.throwSqlException(68, "setRowBufferAt");
        if(rowBuffer == null)
            rowBuffer = new Object[getColumnCount()];
        if(m_nullIndicator == null)
        {
            m_nullIndicator = new boolean[getColumnCount()];
            for(int j = 0; j < getColumnCount(); j++)
                m_nullIndicator[j] = false;

        }
        if(ai != null)
        {
            if(typeInfo == null)
                typeInfo = new int[getColumnCount()][];
            typeInfo[i] = ai;
        }
        rowBuffer[i] = obj;
        m_nullIndicator[i] = obj == null;
    }

    private Datum getRowBufferDatumAt(int i)
        throws SQLException
    {
        if(i < 1 || i > getColumnCount() - 1)
            DatabaseError.throwSqlException(68, "getRowBufferDatumAt");
        Datum datum = null;
        if(rowBuffer != null)
        {
            Object obj = rowBuffer[i];
            if(obj != null)
                if(obj instanceof Datum)
                {
                    datum = (Datum)obj;
                } else
                {
                    OracleResultSetMetaData oracleresultsetmetadata = (OracleResultSetMetaData)getInternalMetadata();
                    int j = i + 1;
                    datum = SQLUtil.makeOracleDatum(connection, obj, oracleresultsetmetadata.getColumnType(j), null, oracleresultsetmetadata.isNCHAR(j));
                    rowBuffer[i] = datum;
                }
        }
        return datum;
    }

    private Object getRowBufferAt(int i)
        throws SQLException
    {
        if(i < 1 || i > getColumnCount() - 1)
            DatabaseError.throwSqlException(68, "getRowBufferDatumAt");
        if(rowBuffer != null)
            return rowBuffer[i];
        else
            return null;
    }

    private boolean isRowBufferUpdatedAt(int i)
    {
        if(rowBuffer == null)
            return false;
        else
            return rowBuffer[i] != null || m_nullIndicator[i];
    }

    private void prepareInsertRowStatement()
        throws SQLException
    {
        if(insertStmt == null)
        {
            insertStmt = (OraclePreparedStatement)connection.prepareStatement(((OracleStatement)scrollStmt).sqlObject.getInsertSqlForUpdatableResultSet(this));
            insertStmt.setQueryTimeout(((Statement)scrollStmt).getQueryTimeout());
            if(((OracleStatement)scrollStmt).sqlObject.generatedSqlNeedEscapeProcessing())
                insertStmt.setEscapeProcessing(true);
        }
    }

    private void prepareInsertRowBinds()
        throws SQLException
    {
        int i = 1;
        i = prepareSubqueryBinds(insertStmt, i);
        OracleResultSetMetaData oracleresultsetmetadata = (OracleResultSetMetaData)getInternalMetadata();
        for(int j = 1; j < getColumnCount(); j++)
        {
            Object obj = getRowBufferAt(j);
            if(obj != null)
            {
                if(obj instanceof Reader)
                {
                    insertStmt.setCharacterStream((i + j) - 1, (Reader)obj, typeInfo[j][0]);
                    continue;
                }
                if(obj instanceof InputStream)
                {
                    if(typeInfo[j][1] == 2)
                    {
                        insertStmt.setBinaryStream((i + j) - 1, (InputStream)obj, typeInfo[j][0]);
                        continue;
                    }
                    if(typeInfo[j][1] == 1)
                        insertStmt.setAsciiStream((i + j) - 1, (InputStream)obj, typeInfo[j][0]);
                    continue;
                }
                Datum datum = getRowBufferDatumAt(j);
                if(oracleresultsetmetadata.isNCHAR(j + 1))
                    insertStmt.setFormOfUse((i + j) - 1, (short)2);
                insertStmt.setOracleObject((i + j) - 1, datum);
                continue;
            }
            int k = getInternalMetadata().getColumnType(j + 1);
            if(k == 2006 || k == 2002 || k == 2008 || k == 2007 || k == 2003)
                insertStmt.setNull((i + j) - 1, k, getInternalMetadata().getColumnTypeName(j + 1));
            else
                insertStmt.setNull((i + j) - 1, k);
        }

    }

    private void executeInsertRow()
        throws SQLException
    {
        if(insertStmt.executeUpdate() != 1)
            DatabaseError.throwSqlException(85);
    }

    private int getNumColumnsChanged()
        throws SQLException
    {
        int i = 0;
        if(indexColsChanged == null)
            indexColsChanged = new int[getColumnCount()];
        if(rowBuffer != null)
        {
            for(int j = 1; j < getColumnCount(); j++)
                if(rowBuffer[j] != null || rowBuffer[j] == null && m_nullIndicator[j])
                    indexColsChanged[i++] = j;

        }
        return i;
    }

    private void prepareUpdateRowStatement(int i)
        throws SQLException
    {
        if(updateStmt != null)
            updateStmt.close();
        updateStmt = (OraclePreparedStatement)connection.prepareStatement(((OracleStatement)scrollStmt).sqlObject.getUpdateSqlForUpdatableResultSet(this, i, rowBuffer, indexColsChanged));
        updateStmt.setQueryTimeout(((Statement)scrollStmt).getQueryTimeout());
    }

    private void prepareUpdateRowBinds(int i)
        throws SQLException
    {
        int j = 1;
        j = prepareSubqueryBinds(updateStmt, j);
        OracleResultSetMetaData oracleresultsetmetadata = (OracleResultSetMetaData)getInternalMetadata();
        for(int k = 0; k < i; k++)
        {
            int l = indexColsChanged[k];
            Object obj = getRowBufferAt(l);
            if(obj != null)
            {
                if(obj instanceof Reader)
                {
                    updateStmt.setCharacterStream(j++, (Reader)obj, typeInfo[l][0]);
                    continue;
                }
                if(obj instanceof InputStream)
                {
                    if(typeInfo[l][1] == 2)
                    {
                        updateStmt.setBinaryStream(j++, (InputStream)obj, typeInfo[l][0]);
                        continue;
                    }
                    if(typeInfo[l][1] == 1)
                        updateStmt.setAsciiStream(j++, (InputStream)obj, typeInfo[l][0]);
                    continue;
                }
                Datum datum = getRowBufferDatumAt(l);
                if(oracleresultsetmetadata.isNCHAR(l + 1))
                    updateStmt.setFormOfUse(j, (short)2);
                updateStmt.setOracleObject(j++, datum);
                continue;
            }
            int i1 = getInternalMetadata().getColumnType(l + 1);
            if(i1 == 2006 || i1 == 2002 || i1 == 2008 || i1 == 2007 || i1 == 2003)
                updateStmt.setNull(j++, i1, getInternalMetadata().getColumnTypeName(l + 1));
            else
                updateStmt.setNull(j++, i1);
        }

        prepareCompareSelfBinds(updateStmt, j);
    }

    private void executeUpdateRow()
        throws SQLException
    {
        try
        {
            if(updateStmt.executeUpdate() == 0)
                DatabaseError.throwSqlException(85);
            if(isCachedRset)
                if(autoRefetch)
                {
                    ((ScrollableResultSet)resultSet).refreshRowsInCache(getRow(), 1, 1000);
                    cancelRowUpdates();
                } else
                {
                    if(rowBuffer != null)
                    {
                        for(int i = 1; i < getColumnCount(); i++)
                            if(rowBuffer[i] != null || rowBuffer[i] == null && m_nullIndicator[i])
                                ((ScrollableResultSet)resultSet).setCurrentRowValueAt(this, i + 1, rowBuffer[i]);

                    }
                    cancelRowUpdates();
                }
        }
        finally
        {
            if(updateStmt != null)
            {
                updateStmt.close();
                updateStmt = null;
            }
        }
    }

    private void prepareDeleteRowStatement()
        throws SQLException
    {
        if(deleteStmt == null)
        {
            StringBuffer stringbuffer = new StringBuffer();
            deleteStmt = (OraclePreparedStatement)connection.prepareStatement(((OracleStatement)scrollStmt).sqlObject.getDeleteSqlForUpdatableResultSet(this));
            deleteStmt.setQueryTimeout(((Statement)scrollStmt).getQueryTimeout());
            if(((OracleStatement)scrollStmt).sqlObject.generatedSqlNeedEscapeProcessing())
                deleteStmt.setEscapeProcessing(true);
        }
    }

    private void prepareDeleteRowBinds()
        throws SQLException
    {
        int i = 1;
        i = prepareSubqueryBinds(deleteStmt, i);
        prepareCompareSelfBinds(deleteStmt, i);
    }

    private void executeDeleteRow()
        throws SQLException
    {
        if(deleteStmt.executeUpdate() == 0)
            DatabaseError.throwSqlException(85);
        if(isCachedRset)
            ((ScrollableResultSet)resultSet).removeRowInCache(getRow());
    }

    private int prepareCompareSelfBinds(OraclePreparedStatement oraclepreparedstatement, int i)
        throws SQLException
    {
        Datum datum = resultSet.getOracleObject(1);
        oraclepreparedstatement.setOracleObject(i, resultSet.getOracleObject(1));
        return i + 1;
    }

    private int prepareSubqueryBinds(OraclePreparedStatement oraclepreparedstatement, int i)
        throws SQLException
    {
        int j = scrollStmt.copyBinds(oraclepreparedstatement, i - 1);
        return j + 1;
    }

    private void setIsNull(int i)
    {
        wasNull = i;
    }

    private void setIsNull(boolean flag)
    {
        if(flag)
            wasNull = 1;
        else
            wasNull = 2;
    }

    static final int concurrencyType = 1008;
    static final int beginColumnIndex = 1;
    PhysicalConnection connection;
    OracleResultSet resultSet;
    boolean isCachedRset;
    ScrollRsetStatement scrollStmt;
    ResultSetMetaData rsetMetaData;
    private int rsetType;
    private int columnCount;
    private OraclePreparedStatement deleteStmt;
    private OraclePreparedStatement insertStmt;
    private OraclePreparedStatement updateStmt;
    private int indexColsChanged[];
    private Object rowBuffer[];
    private boolean m_nullIndicator[];
    private int typeInfo[][];
    private boolean isInserting;
    private boolean isUpdating;
    private int wasNull;
    private static final int VALUE_NULL = 1;
    private static final int VALUE_NOT_NULL = 2;
    private static final int VALUE_UNKNOWN = 3;
    private static final int VALUE_IN_RSET = 4;
    private static final int ASCII_STREAM = 1;
    private static final int BINARY_STREAM = 2;
    private static final int UNICODE_STREAM = 3;
    private static int _MIN_STREAM_SIZE = 4000;
    private static final String _Copyright_2004_Oracle_All_Rights_Reserved_ = null;
    public static final boolean TRACE = false;
    public static final boolean PRIVATE_TRACE = false;
    public static final String BUILD_DATE = "Sat_Feb__2_11:39:40_PST_2008";

}
