// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleCachedRowSet.java

package oracle.jdbc.rowset;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.CharArrayReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;
import java.io.Reader;
import java.io.Serializable;
import java.io.StringBufferInputStream;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.net.URL;
import java.sql.Array;
import java.sql.Blob;
import java.sql.Clob;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.Date;
import java.sql.DriverManager;
import java.sql.Ref;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.Savepoint;
import java.sql.Statement;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.Calendar;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;
import java.util.Vector;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;
import javax.sql.RowSet;
import javax.sql.RowSetEvent;
import javax.sql.RowSetInternal;
import javax.sql.RowSetMetaData;
import javax.sql.RowSetReader;
import javax.sql.RowSetWriter;
import javax.sql.rowset.CachedRowSet;
import javax.sql.rowset.RowSetWarning;
import javax.sql.rowset.spi.SyncFactory;
import javax.sql.rowset.spi.SyncFactoryException;
import javax.sql.rowset.spi.SyncProvider;
import javax.sql.rowset.spi.SyncProviderException;
import oracle.jdbc.OracleConnection;
import oracle.jdbc.OracleSavepoint;
import oracle.jdbc.driver.OracleDriver;
import oracle.sql.BLOB;
import oracle.sql.CLOB;

// Referenced classes of package oracle.jdbc.rowset:
//            OracleRowSet, OracleCachedRowSetReader, OracleCachedRowSetWriter, OracleSerialClob, 
//            OracleSerialBlob, OracleRow, OracleRowSetMetaData

public class OracleCachedRowSet extends OracleRowSet
    implements RowSet, RowSetInternal, Serializable, Cloneable, CachedRowSet
{

    public OracleCachedRowSet()
        throws SQLException
    {
        isConnectionStayingOpenForTxnControl = false;
        driverManagerInitialized = false;
        insertRowFlag = false;
        updateRowFlag = false;
        presentRow = 0;
        previousColumnWasNull = false;
        param = new Vector();
        rows = new Vector();
        sqlWarning = new SQLWarning();
        try
        {
            syncProvider = SyncFactory.getInstance("com.sun.rowset.providers.RIOptimisticProvider");
        }
        catch(SyncFactoryException syncfactoryexception)
        {
            throw new SQLException("SyncProvider instance not constructed.");
        }
        setReader(new OracleCachedRowSetReader());
        setWriter(new OracleCachedRowSetWriter());
        currentPage = 0;
        pageSize = 0;
        isPopulateDone = false;
        keyColumns = null;
        tableName = null;
    }

    public Connection getConnection()
        throws SQLException
    {
        return getConnectionInternal();
    }

    Connection getConnectionInternal()
        throws SQLException
    {
        if(connection == null || connection.isClosed())
        {
            String s = getUsername();
            String s1 = getPassword();
            if(getDataSourceName() != null)
                try
                {
                    InitialContext initialcontext = null;
                    try
                    {
                        java.util.Properties properties = System.getProperties();
                        initialcontext = new InitialContext(properties);
                    }
                    catch(SecurityException securityexception) { }
                    if(initialcontext == null)
                        initialcontext = new InitialContext();
                    DataSource datasource = (DataSource)initialcontext.lookup(getDataSourceName());
                    if(username == null || s1 == null)
                        connection = datasource.getConnection();
                    else
                        connection = datasource.getConnection(username, s1);
                }
                catch(NamingException namingexception)
                {
                    throw new SQLException("Unable to connect through the DataSource\n" + namingexception.getMessage());
                }
            else
            if(getUrl() != null)
            {
                if(!driverManagerInitialized)
                {
                    DriverManager.registerDriver(new OracleDriver());
                    driverManagerInitialized = true;
                }
                String s2 = getUrl();
                if(s2.equals("") || s.equals("") || s1.equals(""))
                    throw new SQLException("One or more of the authenticating parameter not set");
                connection = DriverManager.getConnection(s2, s, s1);
            } else
            {
                throw new SQLException("Authentication parameters not set");
            }
        }
        return connection;
    }

    public Statement getStatement()
        throws SQLException
    {
        if(resultSet == null)
            throw new SQLException("ResultSet not open");
        else
            return resultSet.getStatement();
    }

    public RowSetReader getReader()
    {
        return reader;
    }

    public RowSetWriter getWriter()
    {
        return writer;
    }

    public void setFetchDirection(int i)
        throws SQLException
    {
        if(rowsetType == 1005)
            throw new SQLException("Fetch direction cannot be applied when RowSet type is TYPE_SCROLL_SENSITIVE");
        switch(i)
        {
        case 1000: 
        case 1002: 
            presentRow = 0;
            break;

        case 1001: 
            if(rowsetType == 1003)
                throw new SQLException("FETCH_REVERSE cannot be applied when RowSet type is TYPE_FORWARD_ONLY");
            presentRow = rowCount + 1;
            break;

        default:
            throw new SQLException("Illegal fetch direction");
        }
        super.setFetchDirection(i);
    }

    public void setReader(RowSetReader rowsetreader)
    {
        reader = rowsetreader;
    }

    public void setWriter(RowSetWriter rowsetwriter)
    {
        writer = rowsetwriter;
    }

    private final int getColumnIndex(String s)
        throws SQLException
    {
        s = s.toUpperCase();
        int i;
        for(i = 0; i < metaData.length && !s.equals(metaData[i]); i++);
        if(i >= metaData.length)
            throw new SQLException("Invalid column name: " + s);
        else
            return i + 1;
    }

    private final void checkColumnIndex(int i)
        throws SQLException
    {
        if(readOnly)
            throw new SQLException("The RowSet is not write enabled");
        if(i < 1 || i > colCount)
            throw new SQLException("invalid index : " + i);
        else
            return;
    }

    private final boolean isUpdated(int i)
        throws SQLException
    {
        if(i < 1 || i > colCount)
            throw new SQLException("Invalid index : " + i);
        else
            return getCurrentRow().isColumnChanged(i);
    }

    private final void checkParamIndex(int i)
        throws SQLException
    {
        if(i < 1)
            throw new SQLException("Invalid parameter index : " + i);
        else
            return;
    }

    private final void populateInit(ResultSet resultset)
        throws SQLException
    {
        resultSet = resultset;
        Statement statement = resultset.getStatement();
        maxFieldSize = statement.getMaxFieldSize();
        fetchSize = statement.getFetchSize();
        queryTimeout = statement.getQueryTimeout();
        connection = statement.getConnection();
        transactionIsolation = connection.getTransactionIsolation();
        typeMap = connection.getTypeMap();
        DatabaseMetaData databasemetadata = connection.getMetaData();
        url = databasemetadata.getURL();
        username = databasemetadata.getUserName();
    }

    private synchronized InputStream getStream(int i)
        throws SQLException
    {
        Object obj;
        obj = getObject(i);
        if(obj == null)
            return null;
        if(obj instanceof InputStream)
            return (InputStream)obj;
        if(obj instanceof String)
            return new ByteArrayInputStream(((String)obj).getBytes());
        if(obj instanceof byte[])
            return new ByteArrayInputStream((byte[])obj);
        if(obj instanceof OracleSerialClob)
            return ((OracleSerialClob)obj).getAsciiStream();
        if(obj instanceof OracleSerialBlob)
            return ((OracleSerialBlob)obj).getBinaryStream();
        if(!(obj instanceof Reader))
            break MISSING_BLOCK_LABEL_197;
        PipedInputStream pipedinputstream;
        BufferedReader bufferedreader = new BufferedReader((Reader)obj);
        int j = 0;
        pipedinputstream = new PipedInputStream();
        PipedOutputStream pipedoutputstream = new PipedOutputStream(pipedinputstream);
        while((j = bufferedreader.read()) != -1) 
            pipedoutputstream.write(j);
        pipedoutputstream.close();
        return pipedinputstream;
        IOException ioexception;
        ioexception;
        throw new SQLException("Error during conversion: " + ioexception.getMessage());
        throw new SQLException("Could not convert the column into a stream type");
    }

    protected synchronized void notifyCursorMoved()
    {
        if(insertRowFlag)
        {
            insertRowFlag = false;
            insertRow.setRowUpdated(false);
            sqlWarning.setNextWarning(new SQLWarning("Cancelling insertion, due to cursor movement."));
        } else
        if(updateRowFlag)
            try
            {
                updateRowFlag = false;
                int i = presentRow;
                presentRow = updateRowPosition;
                getCurrentRow().setRowUpdated(false);
                presentRow = i;
                sqlWarning.setNextWarning(new SQLWarning("Cancelling all updates, due to cursor movement."));
            }
            catch(SQLException sqlexception) { }
        super.notifyCursorMoved();
    }

    protected void checkAndFilterObject(int i, Object obj)
        throws SQLException
    {
    }

    OracleRow getCurrentRow()
        throws SQLException
    {
        int i = presentRow - 1;
        if(presentRow < 1 || presentRow > rowCount)
            throw new SQLException("Operation with out calling next/previous");
        else
            return (OracleRow)rows.elementAt(presentRow - 1);
    }

    boolean isConnectionStayingOpen()
    {
        return isConnectionStayingOpenForTxnControl;
    }

    void setOriginal()
        throws SQLException
    {
        int i = 1;
        do
        {
            boolean flag = setOriginalRowInternal(i);
            if(!flag)
                i++;
        } while(i <= rowCount);
        notifyRowSetChanged();
        presentRow = 0;
    }

    boolean setOriginalRowInternal(int i)
        throws SQLException
    {
        if(i < 1 || i > rowCount)
            throw new SQLException("Invalid cursor position, try next/previous first");
        boolean flag = false;
        OracleRow oraclerow = (OracleRow)rows.elementAt(i - 1);
        if(oraclerow.isRowDeleted())
        {
            rows.remove(i - 1);
            rowCount--;
            flag = true;
        } else
        {
            if(oraclerow.isRowInserted())
                oraclerow.setInsertedFlag(false);
            if(oraclerow.isRowUpdated())
                oraclerow.makeUpdatesOriginal();
        }
        return flag;
    }

    public boolean next()
        throws SQLException
    {
        if(rowCount < 0)
            return false;
        if(fetchDirection == 1000 || fetchDirection == 1002)
            if(presentRow + 1 <= rowCount)
            {
                presentRow++;
                if(!showDeleted && getCurrentRow().isRowDeleted())
                {
                    return next();
                } else
                {
                    notifyCursorMoved();
                    return true;
                }
            } else
            {
                presentRow = rowCount + 1;
                return false;
            }
        if(fetchDirection == 1001)
        {
            if(presentRow - 1 > 0)
            {
                presentRow--;
                if(!showDeleted && getCurrentRow().isRowDeleted())
                {
                    return next();
                } else
                {
                    notifyCursorMoved();
                    return true;
                }
            } else
            {
                presentRow = 0;
                return false;
            }
        } else
        {
            return false;
        }
    }

    public boolean previous()
        throws SQLException
    {
        if(rowCount < 0)
            return false;
        if(fetchDirection == 1001)
            if(presentRow + 1 <= rowCount)
            {
                presentRow++;
                if(!showDeleted && getCurrentRow().isRowDeleted())
                {
                    return previous();
                } else
                {
                    notifyCursorMoved();
                    return true;
                }
            } else
            {
                presentRow = rowCount + 1;
                return false;
            }
        if(fetchDirection == 1000 || fetchDirection == 1002)
        {
            if(presentRow - 1 > 0)
            {
                presentRow--;
                if(!showDeleted && getCurrentRow().isRowDeleted())
                {
                    return previous();
                } else
                {
                    notifyCursorMoved();
                    return true;
                }
            } else
            {
                presentRow = 0;
                return false;
            }
        } else
        {
            return false;
        }
    }

    public boolean isBeforeFirst()
        throws SQLException
    {
        return rowCount > 0 && presentRow == 0;
    }

    public boolean isAfterLast()
        throws SQLException
    {
        return rowCount > 0 && presentRow == rowCount + 1;
    }

    public boolean isFirst()
        throws SQLException
    {
        return presentRow == 1;
    }

    public boolean isLast()
        throws SQLException
    {
        return presentRow == rowCount;
    }

    public void beforeFirst()
        throws SQLException
    {
        presentRow = 0;
    }

    public void afterLast()
        throws SQLException
    {
        presentRow = rowCount + 1;
    }

    public boolean first()
        throws SQLException
    {
        return absolute(1);
    }

    public boolean last()
        throws SQLException
    {
        return absolute(-1);
    }

    public boolean absolute(int i)
        throws SQLException
    {
        if(rowsetType == 1003)
            throw new SQLException("The RowSet type is TYPE_FORWARD_ONLY");
        if(i == 0 || Math.abs(i) > rowCount)
        {
            return false;
        } else
        {
            presentRow = i >= 0 ? i : rowCount + i + 1;
            notifyCursorMoved();
            return true;
        }
    }

    public boolean relative(int i)
        throws SQLException
    {
        return absolute(presentRow + i);
    }

    public synchronized void populate(ResultSet resultset)
        throws SQLException
    {
        if(rows == null)
            rows = new Vector(50, 10);
        else
            rows.clear();
        rowsetMetaData = new OracleRowSetMetaData(resultset.getMetaData());
        metaData = new String[colCount = rowsetMetaData.getColumnCount()];
        for(int i = 0; i < colCount; i++)
            metaData[i] = rowsetMetaData.getColumnName(i + 1);

        if(!(resultset instanceof OracleCachedRowSet))
            populateInit(resultset);
        boolean flag = fetchDirection == 1000 || fetchDirection == 1002;
        rowCount = 0;
        Object obj = null;
        int j;
        if(maxRows == 0 && pageSize == 0)
            j = 0x7fffffff;
        else
        if(maxRows == 0 || pageSize == 0)
            j = Math.max(maxRows, pageSize);
        else
            j = Math.min(maxRows, pageSize);
        if(resultset.getType() != 1003 && rows.size() == 0 && !flag)
            resultset.afterLast();
        for(; rowCount < j && (flag ? resultset.next() : resultset.previous()); rowCount++)
        {
            OracleRow oraclerow = new OracleRow(colCount);
            for(int k = 1; k <= colCount; k++)
            {
                Object obj1 = null;
                try
                {
                    obj1 = resultset.getObject(k, typeMap);
                }
                catch(Exception exception)
                {
                    obj1 = resultset.getObject(k);
                }
                catch(AbstractMethodError abstractmethoderror)
                {
                    obj1 = resultset.getObject(k);
                }
                if((obj1 instanceof Clob) || (obj1 instanceof CLOB))
                    oraclerow.setColumnValue(k, new OracleSerialClob((Clob)obj1));
                else
                if((obj1 instanceof Blob) || (obj1 instanceof BLOB))
                    oraclerow.setColumnValue(k, new OracleSerialBlob((Blob)obj1));
                else
                    oraclerow.setColumnValue(k, obj1);
                oraclerow.markOriginalNull(k, resultset.wasNull());
            }

            if(flag)
                rows.add(oraclerow);
            else
                rows.add(1, oraclerow);
        }

        if(flag && resultset.isAfterLast() || !flag && resultset.isBeforeFirst())
            isPopulateDone = true;
        connection = null;
        notifyRowSetChanged();
    }

    public String getCursorName()
        throws SQLException
    {
        throw new SQLException("Getting the cursor name is not supported.");
    }

    public synchronized void clearParameters()
        throws SQLException
    {
        param = null;
        param = new Vector();
    }

    public boolean wasNull()
        throws SQLException
    {
        return previousColumnWasNull;
    }

    public void close()
        throws SQLException
    {
        release();
    }

    public SQLWarning getWarnings()
        throws SQLException
    {
        return sqlWarning;
    }

    public void clearWarnings()
        throws SQLException
    {
        sqlWarning = null;
    }

    public ResultSetMetaData getMetaData()
        throws SQLException
    {
        return rowsetMetaData;
    }

    public int findColumn(String s)
        throws SQLException
    {
        return getColumnIndex(s);
    }

    public Object[] getParams()
        throws SQLException
    {
        return param.toArray();
    }

    public void setMetaData(RowSetMetaData rowsetmetadata)
        throws SQLException
    {
        rowsetMetaData = rowsetmetadata;
        if(rowsetmetadata != null)
            colCount = rowsetmetadata.getColumnCount();
    }

    public synchronized void execute()
        throws SQLException
    {
        isConnectionStayingOpenForTxnControl = false;
        getReader().readData(this);
    }

    public void acceptChanges()
        throws SyncProviderException
    {
        try
        {
            getWriter().writeData(this);
        }
        catch(SQLException sqlexception)
        {
            throw new SyncProviderException(sqlexception.getMessage());
        }
    }

    public void acceptChanges(Connection connection1)
        throws SyncProviderException
    {
        connection = connection1;
        isConnectionStayingOpenForTxnControl = true;
        acceptChanges();
    }

    public Object clone()
        throws CloneNotSupportedException
    {
        return createCopy();
        SQLException sqlexception;
        sqlexception;
        throw new CloneNotSupportedException("SQL Error occured while cloning,\n" + sqlexception.getMessage());
    }

    public CachedRowSet createCopy()
        throws SQLException
    {
        OracleCachedRowSet oraclecachedrowset = (OracleCachedRowSet)createShared();
        int i = rows.size();
        oraclecachedrowset.rows = new Vector(i);
        for(int j = 0; j < i; j++)
            oraclecachedrowset.rows.add(((OracleRow)rows.elementAt(j)).createCopy());

        return oraclecachedrowset;
    }

    public RowSet createShared()
        throws SQLException
    {
        OracleCachedRowSet oraclecachedrowset = new OracleCachedRowSet();
        oraclecachedrowset.rows = rows;
        oraclecachedrowset.setDataSource(getDataSource());
        oraclecachedrowset.setDataSourceName(getDataSourceName());
        oraclecachedrowset.setUsername(getUsername());
        oraclecachedrowset.setPassword(getPassword());
        oraclecachedrowset.setUrl(getUrl());
        oraclecachedrowset.setTypeMap(getTypeMap());
        oraclecachedrowset.setMaxFieldSize(getMaxFieldSize());
        oraclecachedrowset.setMaxRows(getMaxRows());
        oraclecachedrowset.setQueryTimeout(getQueryTimeout());
        oraclecachedrowset.setFetchSize(getFetchSize());
        oraclecachedrowset.setEscapeProcessing(getEscapeProcessing());
        oraclecachedrowset.setConcurrency(getConcurrency());
        oraclecachedrowset.setReadOnly(readOnly);
        rowsetType = getType();
        fetchDirection = getFetchDirection();
        oraclecachedrowset.setCommand(getCommand());
        oraclecachedrowset.setTransactionIsolation(getTransactionIsolation());
        oraclecachedrowset.presentRow = presentRow;
        oraclecachedrowset.colCount = colCount;
        oraclecachedrowset.rowCount = rowCount;
        oraclecachedrowset.showDeleted = showDeleted;
        oraclecachedrowset.syncProvider = syncProvider;
        oraclecachedrowset.currentPage = currentPage;
        oraclecachedrowset.pageSize = pageSize;
        oraclecachedrowset.tableName = tableName != null ? new String(tableName) : null;
        oraclecachedrowset.keyColumns = keyColumns != null ? (int[])keyColumns.clone() : null;
        int i = listener.size();
        for(int j = 0; j < i; j++)
            oraclecachedrowset.listener.add(listener.elementAt(j));

        oraclecachedrowset.rowsetMetaData = new OracleRowSetMetaData(rowsetMetaData);
        i = param.size();
        for(int k = 0; k < i; k++)
            oraclecachedrowset.param.add(param.elementAt(k));

        oraclecachedrowset.metaData = new String[metaData.length];
        System.arraycopy(metaData, 0, oraclecachedrowset.metaData, 0, metaData.length);
        return oraclecachedrowset;
    }

    public void release()
        throws SQLException
    {
        rows = null;
        rows = new Vector();
        if(connection != null && !connection.isClosed())
            connection.close();
        rowCount = 0;
        presentRow = 0;
        notifyRowSetChanged();
    }

    public void restoreOriginal()
        throws SQLException
    {
        boolean flag = false;
        for(int i = 0; i < rowCount; i++)
        {
            OracleRow oraclerow = (OracleRow)rows.elementAt(i);
            if(oraclerow.isRowInserted())
            {
                rows.remove(i);
                rowCount--;
                i--;
                flag = true;
                continue;
            }
            if(oraclerow.isRowUpdated())
            {
                oraclerow.setRowUpdated(false);
                flag = true;
                continue;
            }
            if(oraclerow.isRowDeleted())
            {
                oraclerow.setRowDeleted(false);
                flag = true;
            }
        }

        if(!flag)
        {
            throw new SQLException("None of the rows are changed");
        } else
        {
            notifyRowSetChanged();
            presentRow = 0;
            return;
        }
    }

    public Collection toCollection()
        throws SQLException
    {
        Map map = Collections.synchronizedMap(new TreeMap());
        try
        {
            for(int i = 0; i < rowCount; i++)
                map.put(new Integer(i), ((OracleRow)rows.elementAt(i)).toCollection());

        }
        catch(Exception exception)
        {
            map = null;
            throw new SQLException("Map operation failed in toCollection()");
        }
        return map.values();
    }

    public Collection toCollection(int i)
        throws SQLException
    {
        if(i < 1 || i > colCount)
            throw new SQLException("invalid index : " + i);
        Vector vector = new Vector(rowCount);
        for(int j = 0; j < rowCount; j++)
        {
            OracleRow oraclerow = (OracleRow)rows.elementAt(j);
            Object obj = oraclerow.isColumnChanged(i) ? oraclerow.getModifiedColumn(i) : oraclerow.getColumn(i);
            vector.add(obj);
        }

        return vector;
    }

    public Collection toCollection(String s)
        throws SQLException
    {
        return toCollection(getColumnIndex(s));
    }

    public int getRow()
        throws SQLException
    {
        if(presentRow > rowCount)
            return rowCount;
        else
            return presentRow;
    }

    public void cancelRowInsert()
        throws SQLException
    {
        if(getCurrentRow().isRowInserted())
        {
            rows.remove(--presentRow);
            rowCount--;
            notifyRowChanged();
        } else
        {
            throw new SQLException("The row is not inserted");
        }
    }

    public void cancelRowDelete()
        throws SQLException
    {
        if(getCurrentRow().isRowDeleted())
        {
            getCurrentRow().setRowDeleted(false);
            notifyRowChanged();
        } else
        {
            throw new SQLException("The row is not deleted");
        }
    }

    public void cancelRowUpdates()
        throws SQLException
    {
        if(getCurrentRow().isRowUpdated())
        {
            updateRowFlag = false;
            getCurrentRow().setRowUpdated(false);
            notifyRowChanged();
        } else
        {
            throw new SQLException("The row is not updated.");
        }
    }

    public void insertRow()
        throws SQLException
    {
        if(!insertRowFlag)
            throw new SQLException("Current row not inserted/updated.");
        if(!insertRow.isRowFullyPopulated())
        {
            throw new SQLException("All the columns of the row are not set");
        } else
        {
            insertRow.insertRow();
            rows.insertElementAt(insertRow, insertRowPosition - 1);
            insertRowFlag = false;
            rowCount++;
            notifyRowChanged();
            return;
        }
    }

    public void updateRow()
        throws SQLException
    {
        if(updateRowFlag)
        {
            updateRowFlag = false;
            getCurrentRow().setRowUpdated(true);
            notifyRowChanged();
        } else
        {
            throw new SQLException("Current row not updated");
        }
    }

    public void deleteRow()
        throws SQLException
    {
        getCurrentRow().setRowDeleted(true);
        notifyRowChanged();
    }

    public void refreshRow()
        throws SQLException
    {
        OracleRow oraclerow = getCurrentRow();
        if(oraclerow.isRowUpdated())
            oraclerow.cancelRowUpdates();
    }

    public void moveToInsertRow()
        throws SQLException
    {
        insertRow = new OracleRow(colCount, true);
        insertRowFlag = true;
        if(isAfterLast())
            insertRowPosition = presentRow;
        else
            insertRowPosition = presentRow + 1;
    }

    public void moveToCurrentRow()
        throws SQLException
    {
        insertRowFlag = false;
        updateRowFlag = false;
        absolute(presentRow);
    }

    public boolean rowUpdated()
        throws SQLException
    {
        return getCurrentRow().isRowUpdated();
    }

    public boolean rowInserted()
        throws SQLException
    {
        return getCurrentRow().isRowInserted();
    }

    public boolean rowDeleted()
        throws SQLException
    {
        return getCurrentRow().isRowDeleted();
    }

    public ResultSet getOriginalRow()
        throws SQLException
    {
        OracleCachedRowSet oraclecachedrowset = new OracleCachedRowSet();
        oraclecachedrowset.rowsetMetaData = rowsetMetaData;
        oraclecachedrowset.rowCount = 1;
        oraclecachedrowset.colCount = colCount;
        oraclecachedrowset.presentRow = 0;
        oraclecachedrowset.setReader(null);
        oraclecachedrowset.setWriter(null);
        OracleRow oraclerow = new OracleRow(rowsetMetaData.getColumnCount(), getCurrentRow().getOriginalRow());
        oraclecachedrowset.rows.add(oraclerow);
        return oraclecachedrowset;
    }

    public ResultSet getOriginal()
        throws SQLException
    {
        OracleCachedRowSet oraclecachedrowset = new OracleCachedRowSet();
        oraclecachedrowset.rowsetMetaData = rowsetMetaData;
        oraclecachedrowset.rowCount = rowCount;
        oraclecachedrowset.colCount = colCount;
        oraclecachedrowset.presentRow = 0;
        oraclecachedrowset.setType(1004);
        oraclecachedrowset.setConcurrency(1008);
        oraclecachedrowset.setReader(null);
        oraclecachedrowset.setWriter(null);
        int i = rowsetMetaData.getColumnCount();
        Object obj = null;
        OracleRow oraclerow;
        for(Iterator iterator = rows.iterator(); iterator.hasNext(); oraclecachedrowset.rows.add(oraclerow))
            oraclerow = new OracleRow(i, ((OracleRow)iterator.next()).getOriginalRow());

        return oraclecachedrowset;
    }

    public void setNull(int i, int j)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, null);
    }

    public void setNull(int i, int j, String s)
        throws SQLException
    {
        checkParamIndex(i);
        Object aobj[] = {
            new Integer(j), s
        };
        param.add(i - 1, ((Object) (aobj)));
    }

    public void setBoolean(int i, boolean flag)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, new Boolean(flag));
    }

    public void setByte(int i, byte byte0)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, new Byte(byte0));
    }

    public void setShort(int i, short word0)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, new Short(word0));
    }

    public void setInt(int i, int j)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, new Integer(j));
    }

    public void setLong(int i, long l)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, new Long(l));
    }

    public void setFloat(int i, float f)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, new Float(f));
    }

    public void setDouble(int i, double d)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, new Double(d));
    }

    public void setBigDecimal(int i, BigDecimal bigdecimal)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, bigdecimal);
    }

    public void setString(int i, String s)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, s);
    }

    public void setBytes(int i, byte abyte0[])
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, abyte0);
    }

    public void setDate(int i, Date date)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, date);
    }

    public void setTime(int i, Time time)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, time);
    }

    public void setObject(int i, Object obj)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, obj);
    }

    public void setRef(int i, Ref ref)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, ref);
    }

    public void setBlob(int i, Blob blob)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, blob);
    }

    public void setClob(int i, Clob clob)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, clob);
    }

    public void setArray(int i, Array array)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, array);
    }

    public void setBinaryStream(int i, InputStream inputstream, int j)
        throws SQLException
    {
        checkParamIndex(i);
        Object aobj[] = {
            inputstream, new Integer(j), new Integer(546)
        };
        param.add(i - 1, ((Object) (aobj)));
    }

    public void setTime(int i, Time time, Calendar calendar)
        throws SQLException
    {
        checkParamIndex(i);
        Object aobj[] = {
            time, calendar
        };
        param.add(i - 1, ((Object) (aobj)));
    }

    public void setTimestamp(int i, Timestamp timestamp, Calendar calendar)
        throws SQLException
    {
        checkParamIndex(i);
        Object aobj[] = {
            timestamp, calendar
        };
        param.add(i - 1, ((Object) (aobj)));
    }

    public void setTimestamp(int i, Timestamp timestamp)
        throws SQLException
    {
        checkParamIndex(i);
        param.add(i - 1, timestamp);
    }

    public void setAsciiStream(int i, InputStream inputstream, int j)
        throws SQLException
    {
        checkParamIndex(i);
        Object aobj[] = {
            inputstream, new Integer(j), new Integer(819)
        };
        param.add(i - 1, ((Object) (aobj)));
    }

    public void setUnicodeStream(int i, InputStream inputstream, int j)
        throws SQLException
    {
        checkParamIndex(i);
        Object aobj[] = {
            inputstream, new Integer(j), new Integer(273)
        };
        param.add(i - 1, ((Object) (aobj)));
    }

    public void setCharacterStream(int i, Reader reader1, int j)
        throws SQLException
    {
        checkParamIndex(i);
        Object aobj[] = {
            reader1, new Integer(j)
        };
        param.add(i - 1, ((Object) (aobj)));
    }

    public void setObject(int i, Object obj, int j, int k)
        throws SQLException
    {
        checkParamIndex(i);
        Object aobj[] = {
            obj, new Integer(j), new Integer(k)
        };
        param.add(i - 1, ((Object) (aobj)));
    }

    public void setObject(int i, Object obj, int j)
        throws SQLException
    {
        checkParamIndex(i);
        Object aobj[] = {
            obj, new Integer(j)
        };
        param.add(i - 1, ((Object) (aobj)));
    }

    public void setDate(int i, Date date, Calendar calendar)
        throws SQLException
    {
        checkParamIndex(i);
        Object aobj[] = {
            date, calendar
        };
        param.add(i - 1, ((Object) (aobj)));
    }

    public synchronized Object getObject(int i)
        throws SQLException
    {
        int j = (presentRow * colCount + i) - 1;
        Object obj = null;
        if(!isUpdated(i))
            obj = getCurrentRow().getColumn(i);
        else
            obj = getCurrentRow().getModifiedColumn(i);
        previousColumnWasNull = obj == null;
        return obj;
    }

    private synchronized Number getNumber(int i)
        throws SQLException
    {
        Object obj;
        obj = getObject(i);
        if(obj == null || (obj instanceof BigDecimal) || (obj instanceof Number))
            return (Number)obj;
        if(obj instanceof Boolean)
            return new Integer(((Boolean)obj).booleanValue() ? 1 : 0);
        if(!(obj instanceof String))
            break MISSING_BLOCK_LABEL_90;
        return new BigDecimal((String)obj);
        NumberFormatException numberformatexception;
        numberformatexception;
        throw new SQLException("Fail to convert to internal representation");
        throw new SQLException("Fail to convert to internal representation");
    }

    public Object getObject(int i, Map map)
        throws SQLException
    {
        return getObject(i);
    }

    public boolean getBoolean(int i)
        throws SQLException
    {
        Object obj = getObject(i);
        if(obj == null)
            return false;
        if(obj instanceof Boolean)
            return ((Boolean)obj).booleanValue();
        if(obj instanceof Number)
            return ((Number)obj).doubleValue() != 0.0D;
        else
            throw new SQLException("Fail to convert to internal representation");
    }

    public byte getByte(int i)
        throws SQLException
    {
        Object obj = getObject(i);
        if(obj == null)
            return 0;
        if(obj instanceof Number)
            return ((Number)obj).byteValue();
        if(obj instanceof String)
            return ((String)obj).getBytes()[0];
        if(obj instanceof OracleSerialBlob)
        {
            OracleSerialBlob oracleserialblob = (OracleSerialBlob)obj;
            return oracleserialblob.getBytes(0L, 1)[0];
        }
        if(obj instanceof OracleSerialClob)
        {
            OracleSerialClob oracleserialclob = (OracleSerialClob)obj;
            return oracleserialclob.getSubString(0L, 1).getBytes()[0];
        } else
        {
            throw new SQLException("Fail to convert to internal representation");
        }
    }

    public short getShort(int i)
        throws SQLException
    {
        Number number = getNumber(i);
        return number != null ? number.shortValue() : 0;
    }

    public int getInt(int i)
        throws SQLException
    {
        Number number = getNumber(i);
        return number != null ? number.intValue() : 0;
    }

    public long getLong(int i)
        throws SQLException
    {
        Number number = getNumber(i);
        return number != null ? number.longValue() : 0L;
    }

    public float getFloat(int i)
        throws SQLException
    {
        Number number = getNumber(i);
        return number != null ? number.floatValue() : 0.0F;
    }

    public double getDouble(int i)
        throws SQLException
    {
        Number number = getNumber(i);
        return number != null ? number.doubleValue() : 0.0D;
    }

    public BigDecimal getBigDecimal(int i)
        throws SQLException
    {
        Number number = getNumber(i);
        if(number == null || (number instanceof BigDecimal))
            return (BigDecimal)number;
        if(number instanceof Number)
            return new BigDecimal(((Number)number).doubleValue());
        else
            return null;
    }

    public BigDecimal getBigDecimal(int i, int j)
        throws SQLException
    {
        return getBigDecimal(i);
    }

    public Date getDate(int i)
        throws SQLException
    {
        Object obj = getObject(i);
        if(obj == null)
            return (Date)obj;
        if(obj instanceof Time)
        {
            Time time = (Time)obj;
            return new Date(time.getTime());
        }
        if(obj instanceof java.util.Date)
        {
            java.util.Date date = (java.util.Date)obj;
            return new Date(date.getYear(), date.getMonth(), date.getDate());
        } else
        {
            throw new SQLException("Invalid column type");
        }
    }

    public Date getDate(int i, Calendar calendar)
        throws SQLException
    {
        return getDate(i);
    }

    public Time getTime(int i)
        throws SQLException
    {
        Object obj = getObject(i);
        if(obj == null)
            return (Time)obj;
        if(obj instanceof java.util.Date)
        {
            java.util.Date date = (java.util.Date)obj;
            return new Time(date.getHours(), date.getMinutes(), date.getSeconds());
        } else
        {
            throw new SQLException("Invalid column type");
        }
    }

    public Time getTime(int i, Calendar calendar)
        throws SQLException
    {
        return getTime(i);
    }

    public Timestamp getTimestamp(int i)
        throws SQLException
    {
        Object obj = getObject(i);
        if(obj == null || (obj instanceof Timestamp))
            return (Timestamp)obj;
        if(obj instanceof java.util.Date)
            return new Timestamp(((java.util.Date)obj).getTime());
        else
            throw new SQLException("Invalid column type");
    }

    public Timestamp getTimestamp(int i, Calendar calendar)
        throws SQLException
    {
        return getTimestamp(i);
    }

    public byte[] getBytes(int i)
        throws SQLException
    {
        Object obj = getObject(i);
        if(obj == null)
            return (byte[])obj;
        if(obj instanceof byte[])
            return (byte[])obj;
        if(obj instanceof String)
            return (byte[])((String)obj).getBytes();
        if(obj instanceof Number)
            return (byte[])((Number)obj).toString().getBytes();
        if(obj instanceof BigDecimal)
            return (byte[])((BigDecimal)obj).toString().getBytes();
        if(obj instanceof OracleSerialBlob)
        {
            OracleSerialBlob oracleserialblob = (OracleSerialBlob)obj;
            return oracleserialblob.getBytes(0L, (int)oracleserialblob.length());
        }
        if(obj instanceof OracleSerialClob)
        {
            OracleSerialClob oracleserialclob = (OracleSerialClob)obj;
            return oracleserialclob.getSubString(0L, (int)oracleserialclob.length()).getBytes();
        } else
        {
            throw new SQLException("Fail to convert to internal representation");
        }
    }

    public Ref getRef(int i)
        throws SQLException
    {
        Object obj = getObject(i);
        if(obj == null || (obj instanceof Ref))
            return (Ref)obj;
        else
            throw new SQLException("Invalid column type");
    }

    public Blob getBlob(int i)
        throws SQLException
    {
        Object obj = getObject(i);
        if(obj instanceof OracleSerialBlob)
            return obj != null ? (Blob)obj : null;
        else
            throw new SQLException("Invalid column type");
    }

    public Clob getClob(int i)
        throws SQLException
    {
        Object obj = getObject(i);
        if(obj instanceof OracleSerialClob)
            return obj != null ? (Clob)obj : null;
        else
            throw new SQLException("Invalid column type");
    }

    public Array getArray(int i)
        throws SQLException
    {
        Object obj = getObject(i);
        if(obj == null || (obj instanceof Array))
            return (Array)obj;
        else
            throw new SQLException("Invalid column type");
    }

    public String getString(int i)
        throws SQLException
    {
        Object obj;
        obj = getObject(i);
        if(obj == null)
            return (String)obj;
        if(obj instanceof String)
            return (String)obj;
        if((obj instanceof Number) || (obj instanceof BigDecimal))
            return obj.toString();
        if(obj instanceof Date)
            return ((Date)obj).toString();
        if(obj instanceof Timestamp)
            return ((Date)obj).toString();
        if(obj instanceof byte[])
            return new String((byte[])obj);
        if(obj instanceof OracleSerialClob)
        {
            OracleSerialClob oracleserialclob = (OracleSerialClob)obj;
            return oracleserialclob.getSubString(0L, (int)oracleserialclob.length());
        }
        if(obj instanceof OracleSerialBlob)
        {
            OracleSerialBlob oracleserialblob = (OracleSerialBlob)obj;
            return new String(oracleserialblob.getBytes(0L, (int)oracleserialblob.length()));
        }
        if(obj instanceof URL)
            return ((URL)obj).toString();
        if(!(obj instanceof Reader))
            break MISSING_BLOCK_LABEL_266;
        StringBuffer stringbuffer;
        Reader reader1 = (Reader)obj;
        char ac[] = new char[1024];
        int j = 0;
        stringbuffer = new StringBuffer(1024);
        while((j = reader1.read(ac)) > 0) 
            stringbuffer.append(ac, 0, j);
        return stringbuffer.substring(0, stringbuffer.length());
        IOException ioexception;
        ioexception;
        throw new SQLException("Error during conversion: " + ioexception.getMessage());
        throw new SQLException("Fail to convert to internal representation");
    }

    public InputStream getAsciiStream(int i)
        throws SQLException
    {
        InputStream inputstream = getStream(i);
        return inputstream != null ? inputstream : null;
    }

    public InputStream getUnicodeStream(int i)
        throws SQLException
    {
        Object obj = getObject(i);
        if(obj == null)
            return (InputStream)obj;
        if(obj instanceof String)
            return new StringBufferInputStream((String)obj);
        else
            throw new SQLException("Fail to convert to internal representation");
    }

    public InputStream getBinaryStream(int i)
        throws SQLException
    {
        InputStream inputstream = getStream(i);
        return inputstream != null ? inputstream : null;
    }

    public synchronized Reader getCharacterStream(int i)
        throws SQLException
    {
        InputStream inputstream = getAsciiStream(i);
        if(inputstream == null)
            return null;
        CharArrayReader chararrayreader;
        StringBuffer stringbuffer = new StringBuffer();
        for(int j = 0; (j = inputstream.read()) != -1;)
            stringbuffer.append((char)j);

        char ac[] = new char[stringbuffer.length()];
        stringbuffer.getChars(0, stringbuffer.length(), ac, 0);
        chararrayreader = new CharArrayReader(ac);
        ac = null;
        return chararrayreader;
        IOException ioexception;
        ioexception;
        throw new SQLException("Error: could not read from the stream");
    }

    public synchronized Object getObject(String s)
        throws SQLException
    {
        return getObject(getColumnIndex(s));
    }

    public boolean getBoolean(String s)
        throws SQLException
    {
        return getBoolean(getColumnIndex(s));
    }

    public byte getByte(String s)
        throws SQLException
    {
        return getByte(getColumnIndex(s));
    }

    public short getShort(String s)
        throws SQLException
    {
        return getShort(getColumnIndex(s));
    }

    public int getInt(String s)
        throws SQLException
    {
        return getInt(getColumnIndex(s));
    }

    public long getLong(String s)
        throws SQLException
    {
        return getLong(getColumnIndex(s));
    }

    public float getFloat(String s)
        throws SQLException
    {
        return getFloat(getColumnIndex(s));
    }

    public double getDouble(String s)
        throws SQLException
    {
        return getDouble(getColumnIndex(s));
    }

    public BigDecimal getBigDecimal(String s, int i)
        throws SQLException
    {
        return getBigDecimal(getColumnIndex(s), i);
    }

    public byte[] getBytes(String s)
        throws SQLException
    {
        return getBytes(getColumnIndex(s));
    }

    public Date getDate(String s)
        throws SQLException
    {
        return getDate(getColumnIndex(s));
    }

    public Time getTime(String s)
        throws SQLException
    {
        return getTime(getColumnIndex(s));
    }

    public Timestamp getTimestamp(String s)
        throws SQLException
    {
        return getTimestamp(getColumnIndex(s));
    }

    public Time getTime(String s, Calendar calendar)
        throws SQLException
    {
        return getTime(getColumnIndex(s), calendar);
    }

    public Date getDate(String s, Calendar calendar)
        throws SQLException
    {
        return getDate(getColumnIndex(s), calendar);
    }

    public InputStream getAsciiStream(String s)
        throws SQLException
    {
        return getAsciiStream(getColumnIndex(s));
    }

    public InputStream getUnicodeStream(String s)
        throws SQLException
    {
        return getUnicodeStream(getColumnIndex(s));
    }

    public String getString(String s)
        throws SQLException
    {
        return getString(getColumnIndex(s));
    }

    public InputStream getBinaryStream(String s)
        throws SQLException
    {
        return getBinaryStream(getColumnIndex(s));
    }

    public Reader getCharacterStream(String s)
        throws SQLException
    {
        return getCharacterStream(getColumnIndex(s));
    }

    public BigDecimal getBigDecimal(String s)
        throws SQLException
    {
        return getBigDecimal(getColumnIndex(s));
    }

    public Timestamp getTimestamp(String s, Calendar calendar)
        throws SQLException
    {
        return getTimestamp(getColumnIndex(s), calendar);
    }

    public Object getObject(String s, Map map)
        throws SQLException
    {
        return getObject(getColumnIndex(s), map);
    }

    public Ref getRef(String s)
        throws SQLException
    {
        return getRef(getColumnIndex(s));
    }

    public Blob getBlob(String s)
        throws SQLException
    {
        return getBlob(getColumnIndex(s));
    }

    public Clob getClob(String s)
        throws SQLException
    {
        return getClob(getColumnIndex(s));
    }

    public Array getArray(String s)
        throws SQLException
    {
        return getArray(getColumnIndex(s));
    }

    public synchronized void updateObject(int i, Object obj)
        throws SQLException
    {
        checkColumnIndex(i);
        if(insertRowFlag)
        {
            checkAndFilterObject(i, obj);
            insertRow.updateObject(i, obj);
        } else
        if(!isBeforeFirst() && !isAfterLast())
        {
            updateRowFlag = true;
            updateRowPosition = presentRow;
            getCurrentRow().updateObject(i, obj);
        } else
        {
            throw new SQLException("Updation not allowed on this column");
        }
    }

    public void updateNull(int i)
        throws SQLException
    {
        updateObject(i, null);
    }

    public synchronized void updateCharacterStream(int i, Reader reader1, int j)
        throws SQLException
    {
        checkColumnIndex(i);
        try
        {
            char ac[] = new char[j];
            int k = 0;
            do
                k += reader1.read(ac, k, j - k);
            while(k < j);
            updateObject(i, new CharArrayReader(ac));
            ac = null;
        }
        catch(IOException ioexception)
        {
            throw new SQLException("Error while reading the Stream\n" + ioexception.getMessage());
        }
    }

    public void updateCharacterStream(String s, Reader reader1, int i)
        throws SQLException
    {
        updateCharacterStream(getColumnIndex(s), reader1, i);
    }

    public void updateTimestamp(String s, Timestamp timestamp)
        throws SQLException
    {
        updateTimestamp(getColumnIndex(s), timestamp);
    }

    public void updateBinaryStream(String s, InputStream inputstream, int i)
        throws SQLException
    {
        updateBinaryStream(getColumnIndex(s), inputstream, i);
    }

    public synchronized void updateBinaryStream(int i, InputStream inputstream, int j)
        throws SQLException
    {
        try
        {
            byte abyte0[] = new byte[j];
            int k = 0;
            do
                k += inputstream.read(abyte0, k, j - k);
            while(k < j);
            updateObject(i, new ByteArrayInputStream(abyte0));
            abyte0 = null;
        }
        catch(IOException ioexception)
        {
            throw new SQLException("Error while reading the Stream\n" + ioexception.getMessage());
        }
    }

    public synchronized void updateAsciiStream(int i, InputStream inputstream, int j)
        throws SQLException
    {
        try
        {
            InputStreamReader inputstreamreader = new InputStreamReader(inputstream);
            char ac[] = new char[j];
            int k = 0;
            do
                k += inputstreamreader.read(ac, k, j - k);
            while(k < j);
            updateObject(i, new CharArrayReader(ac));
            ac = null;
        }
        catch(IOException ioexception)
        {
            throw new SQLException("Error while reading the Stream\n" + ioexception.getMessage());
        }
    }

    public void updateTimestamp(int i, Timestamp timestamp)
        throws SQLException
    {
        updateObject(i, timestamp);
    }

    public void updateBoolean(int i, boolean flag)
        throws SQLException
    {
        updateObject(i, new Boolean(flag));
    }

    public void updateByte(int i, byte byte0)
        throws SQLException
    {
        updateObject(i, new Byte(byte0));
    }

    public void updateShort(int i, short word0)
        throws SQLException
    {
        updateObject(i, new Short(word0));
    }

    public void updateInt(int i, int j)
        throws SQLException
    {
        updateObject(i, new Integer(j));
    }

    public void updateLong(int i, long l)
        throws SQLException
    {
        updateObject(i, new Long(l));
    }

    public void updateFloat(int i, float f)
        throws SQLException
    {
        updateObject(i, new Float(f));
    }

    public void updateDouble(int i, double d)
        throws SQLException
    {
        updateObject(i, new Double(d));
    }

    public void updateBigDecimal(int i, BigDecimal bigdecimal)
        throws SQLException
    {
        updateObject(i, bigdecimal);
    }

    public void updateString(int i, String s)
        throws SQLException
    {
        updateObject(i, s);
    }

    public void updateBytes(int i, byte abyte0[])
        throws SQLException
    {
        updateObject(i, abyte0);
    }

    public void updateDate(int i, Date date)
        throws SQLException
    {
        updateObject(i, date);
    }

    public void updateTime(int i, Time time)
        throws SQLException
    {
        updateObject(i, new Timestamp(0, 0, 0, time.getHours(), time.getMinutes(), time.getSeconds(), 0));
    }

    public void updateObject(int i, Object obj, int j)
        throws SQLException
    {
        if(!(obj instanceof Number))
        {
            throw new SQLException("Passed object is not Numeric type");
        } else
        {
            updateObject(i, new BigDecimal(new BigInteger(((Number)obj).toString()), j));
            return;
        }
    }

    public void updateNull(String s)
        throws SQLException
    {
        updateNull(getColumnIndex(s));
    }

    public void updateAsciiStream(String s, InputStream inputstream, int i)
        throws SQLException
    {
        updateAsciiStream(getColumnIndex(s), inputstream, i);
    }

    public void updateBoolean(String s, boolean flag)
        throws SQLException
    {
        updateBoolean(getColumnIndex(s), flag);
    }

    public void updateByte(String s, byte byte0)
        throws SQLException
    {
        updateByte(getColumnIndex(s), byte0);
    }

    public void updateShort(String s, short word0)
        throws SQLException
    {
        updateShort(getColumnIndex(s), word0);
    }

    public void updateInt(String s, int i)
        throws SQLException
    {
        updateInt(getColumnIndex(s), i);
    }

    public void updateLong(String s, long l)
        throws SQLException
    {
        updateLong(getColumnIndex(s), l);
    }

    public void updateFloat(String s, float f)
        throws SQLException
    {
        updateFloat(getColumnIndex(s), f);
    }

    public void updateDouble(String s, double d)
        throws SQLException
    {
        updateDouble(getColumnIndex(s), d);
    }

    public void updateBigDecimal(String s, BigDecimal bigdecimal)
        throws SQLException
    {
        updateBigDecimal(getColumnIndex(s), bigdecimal);
    }

    public void updateString(String s, String s1)
        throws SQLException
    {
        updateString(getColumnIndex(s), s1);
    }

    public void updateBytes(String s, byte abyte0[])
        throws SQLException
    {
        updateBytes(getColumnIndex(s), abyte0);
    }

    public void updateDate(String s, Date date)
        throws SQLException
    {
        updateDate(getColumnIndex(s), date);
    }

    public void updateTime(String s, Time time)
        throws SQLException
    {
        updateTime(getColumnIndex(s), time);
    }

    public void updateObject(String s, Object obj)
        throws SQLException
    {
        updateObject(getColumnIndex(s), obj);
    }

    public void updateObject(String s, Object obj, int i)
        throws SQLException
    {
        updateObject(getColumnIndex(s), obj, i);
    }

    public URL getURL(int i)
        throws SQLException
    {
        Object obj = getObject(i);
        if(obj == null)
            return (URL)obj;
        if(obj instanceof URL)
            return (URL)obj;
        else
            throw new SQLException("Invalid column type");
    }

    public URL getURL(String s)
        throws SQLException
    {
        return getURL(getColumnIndex(s));
    }

    public void updateRef(int i, Ref ref)
        throws SQLException
    {
        updateObject(i, ref);
    }

    public void updateRef(String s, Ref ref)
        throws SQLException
    {
        updateRef(getColumnIndex(s), ref);
    }

    public void updateBlob(int i, Blob blob)
        throws SQLException
    {
        updateObject(i, blob);
    }

    public void updateBlob(String s, Blob blob)
        throws SQLException
    {
        updateBlob(getColumnIndex(s), blob);
    }

    public void updateClob(int i, Clob clob)
        throws SQLException
    {
        updateObject(i, clob);
    }

    public void updateClob(String s, Clob clob)
        throws SQLException
    {
        updateClob(getColumnIndex(s), clob);
    }

    public void updateArray(int i, Array array)
        throws SQLException
    {
        updateObject(i, array);
    }

    public void updateArray(String s, Array array)
        throws SQLException
    {
        updateArray(getColumnIndex(s), array);
    }

    public int[] getKeyColumns()
        throws SQLException
    {
        return keyColumns;
    }

    public void setKeyColumns(int ai[])
        throws SQLException
    {
        int i = 0;
        if(rowsetMetaData != null)
        {
            i = rowsetMetaData.getColumnCount();
            if(ai == null || ai.length > i)
                throw new SQLException("Invalid number of key columns");
        }
        int j = ai.length;
        keyColumns = new int[j];
        for(int k = 0; k < j; k++)
        {
            if(ai[k] <= 0 || ai[k] > i)
                throw new SQLException("Invalid column index: " + ai[k]);
            keyColumns[k] = ai[k];
        }

    }

    public int getPageSize()
    {
        return pageSize;
    }

    public void setPageSize(int i)
        throws SQLException
    {
        if(i < 0 || maxRows > 0 && i > maxRows)
        {
            throw new SQLException("Invalid page size specified");
        } else
        {
            pageSize = i;
            return;
        }
    }

    public SyncProvider getSyncProvider()
        throws SQLException
    {
        return syncProvider;
    }

    public void setSyncProvider(String s)
        throws SQLException
    {
        syncProvider = SyncFactory.getInstance(s);
        reader = syncProvider.getRowSetReader();
        writer = syncProvider.getRowSetWriter();
    }

    public String getTableName()
        throws SQLException
    {
        return tableName;
    }

    public void setTableName(String s)
        throws SQLException
    {
        tableName = s;
    }

    public CachedRowSet createCopyNoConstraints()
        throws SQLException
    {
        OracleCachedRowSet oraclecachedrowset = (OracleCachedRowSet)createCopy();
        oraclecachedrowset.initializeProperties();
        oraclecachedrowset.listener = new Vector();
        try
        {
            oraclecachedrowset.unsetMatchColumn(oraclecachedrowset.getMatchColumnIndexes());
            oraclecachedrowset.unsetMatchColumn(oraclecachedrowset.getMatchColumnNames());
        }
        catch(SQLException sqlexception) { }
        return oraclecachedrowset;
    }

    public CachedRowSet createCopySchema()
        throws SQLException
    {
        OracleCachedRowSet oraclecachedrowset = (OracleCachedRowSet)createCopy();
        oraclecachedrowset.rows = null;
        oraclecachedrowset.rowCount = 0;
        oraclecachedrowset.currentPage = 0;
        return oraclecachedrowset;
    }

    public boolean columnUpdated(int i)
        throws SQLException
    {
        if(insertRowFlag)
            throw new SQLException("Trying to mark an inserted row as original");
        else
            return getCurrentRow().isColumnChanged(i);
    }

    public boolean columnUpdated(String s)
        throws SQLException
    {
        return columnUpdated(getColumnIndex(s));
    }

    public synchronized void execute(Connection connection1)
        throws SQLException
    {
        connection = connection1;
        execute();
    }

    public void commit()
        throws SQLException
    {
        getConnectionInternal().commit();
    }

    public void rollback()
        throws SQLException
    {
        getConnectionInternal().rollback();
    }

    public void rollback(Savepoint savepoint)
        throws SQLException
    {
        Connection connection1;
        boolean flag;
        connection1 = getConnectionInternal();
        flag = connection1.getAutoCommit();
        connection1.setAutoCommit(false);
        connection1.rollback(savepoint);
        connection1.setAutoCommit(flag);
        break MISSING_BLOCK_LABEL_48;
        Exception exception;
        exception;
        connection1.setAutoCommit(flag);
        throw exception;
    }

    public void oracleRollback(OracleSavepoint oraclesavepoint)
        throws SQLException
    {
        ((OracleConnection)getConnectionInternal()).oracleRollback(oraclesavepoint);
    }

    public void setOriginalRow()
        throws SQLException
    {
        if(insertRowFlag)
        {
            throw new SQLException("Invalid operation on this row before insertRow is called");
        } else
        {
            setOriginalRowInternal(presentRow);
            return;
        }
    }

    public int size()
    {
        return rowCount;
    }

    public boolean nextPage()
        throws SQLException
    {
        if(fetchDirection == 1001 && resultSet != null && resultSet.getType() == 1003)
            throw new SQLException("The underlying ResultSet does not support this operation");
        if(rows.size() == 0 && !isPopulateDone)
        {
            throw new SQLException("This operation can not be called without previous paging operations");
        } else
        {
            populate(resultSet);
            currentPage++;
            return !isPopulateDone;
        }
    }

    public boolean previousPage()
        throws SQLException
    {
        if(resultSet != null && resultSet.getType() == 1003)
            throw new SQLException("The underlying ResultSet does not support this operation");
        if(rows.size() == 0 && !isPopulateDone)
            throw new SQLException("This operation can not be called without previous paging operations");
        if(fetchDirection == 1001)
            resultSet.relative(pageSize * 2);
        else
            resultSet.relative(-2 * pageSize);
        populate(resultSet);
        if(currentPage > 0)
            currentPage--;
        return currentPage != 0;
    }

    public void rowSetPopulated(RowSetEvent rowsetevent, int i)
        throws SQLException
    {
        if(i <= 0 || i < fetchSize)
            throw new SQLException("Invalid number of row parameter specified");
        if(rowCount % i == 0)
        {
            rowsetEvent = new RowSetEvent(this);
            notifyRowSetChanged();
        }
    }

    public RowSetWarning getRowSetWarnings()
        throws SQLException
    {
        return rowsetWarning;
    }

    public void populate(ResultSet resultset, int i)
        throws SQLException
    {
        if(i < 0)
            throw new SQLException("The start position should not be negative");
        if(resultset == null)
            throw new SQLException("Null ResultSet supplied to populate");
        int j = resultset.getType();
        if(j == 1003)
        {
            int k;
            for(k = 0; resultset.next() && k < i; k++);
            if(k < i)
                throw new SQLException("Too few rows to start populating at this position");
        } else
        {
            resultset.absolute(i);
        }
        populate(resultset);
    }

    public void undoDelete()
        throws SQLException
    {
        cancelRowDelete();
    }

    public void undoInsert()
        throws SQLException
    {
        cancelRowInsert();
    }

    public void undoUpdate()
        throws SQLException
    {
        cancelRowUpdates();
    }

    private SQLWarning sqlWarning;
    private RowSetWarning rowsetWarning;
    protected int presentRow;
    private int currentPage;
    private boolean isPopulateDone;
    private boolean previousColumnWasNull;
    private OracleRow insertRow;
    private int insertRowPosition;
    private boolean insertRowFlag;
    private int updateRowPosition;
    private boolean updateRowFlag;
    protected ResultSetMetaData rowsetMetaData;
    private transient ResultSet resultSet;
    private transient Connection connection;
    private transient boolean isConnectionStayingOpenForTxnControl;
    protected Vector rows;
    private Vector param;
    private String metaData[];
    protected int colCount;
    protected int rowCount;
    private RowSetReader reader;
    private RowSetWriter writer;
    private int keyColumns[];
    private int pageSize;
    private SyncProvider syncProvider;
    private static final String DEFAULT_SYNCPROVIDER = "com.sun.rowset.providers.RIOptimisticProvider";
    private String tableName;
    private boolean driverManagerInitialized;
}
