// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleCachedRowSetWriter.java

package oracle.jdbc.rowset;

import java.io.Serializable;
import java.sql.*;
import java.util.StringTokenizer;
import javax.sql.*;

// Referenced classes of package oracle.jdbc.rowset:
//            OracleCachedRowSet, OracleCachedRowSetReader, OracleRow

public class OracleCachedRowSetWriter
    implements RowSetWriter, Serializable
{

    public OracleCachedRowSetWriter()
    {
        updateClause = new StringBuffer("");
        deleteClause = new StringBuffer("");
        insertClause = new StringBuffer("");
    }

    private String getSchemaName(RowSet rowset)
        throws SQLException
    {
        return rowset.getUsername();
    }

    private String getTableName(RowSet rowset)
        throws SQLException
    {
        String s = ((OracleCachedRowSet)rowset).getTableName();
        if(s != null)
            return s;
        String s1 = rowset.getCommand().toUpperCase();
        int i = s1.indexOf(" FROM ");
        if(i == -1)
            throw new SQLException("Could not parse the SQL String to get the table name.\n" + (s1 == "" ? "Please use RowSet.setCommand (String) to set the SQL query string." : s1));
        String s2 = s1.substring(i + 6).trim();
        StringTokenizer stringtokenizer = new StringTokenizer(s2);
        if(stringtokenizer.hasMoreTokens())
            s2 = stringtokenizer.nextToken();
        return s2;
    }

    private void initSQLStatement(RowSet rowset)
        throws SQLException
    {
        insertClause = new StringBuffer("INSERT INTO " + getTableName(rowset) + "(");
        updateClause = new StringBuffer("UPDATE " + getTableName(rowset) + " SET ");
        deleteClause = new StringBuffer("DELETE FROM " + getTableName(rowset) + " WHERE ");
        rsmd = rowset.getMetaData();
        columnCount = rsmd.getColumnCount();
        for(int i = 0; i < columnCount; i++)
        {
            if(i != 0)
                insertClause.append(", ");
            insertClause.append(rsmd.getColumnName(i + 1));
            if(i != 0)
                updateClause.append(", ");
            updateClause.append(rsmd.getColumnName(i + 1) + " = :" + i);
            if(i != 0)
                deleteClause.append(" AND ");
            deleteClause.append(rsmd.getColumnName(i + 1) + " = :" + i);
        }

        insertClause.append(") VALUES (");
        updateClause.append(" WHERE ");
        for(int j = 0; j < columnCount; j++)
        {
            if(j != 0)
                insertClause.append(", ");
            insertClause.append(":" + j);
            if(j != 0)
                updateClause.append(" AND ");
            updateClause.append(rsmd.getColumnName(j + 1) + " = :" + j);
        }

        insertClause.append(")");
        insertStmt = connection.prepareStatement(insertClause.substring(0, insertClause.length()));
        updateStmt = connection.prepareStatement(updateClause.substring(0, updateClause.length()));
        deleteStmt = connection.prepareStatement(deleteClause.substring(0, deleteClause.length()));
    }

    private boolean insertRow(OracleRow oraclerow)
        throws SQLException
    {
        insertStmt.clearParameters();
        for(int i = 1; i <= columnCount; i++)
        {
            Object obj = null;
            obj = oraclerow.isColumnChanged(i) ? oraclerow.getModifiedColumn(i) : oraclerow.getColumn(i);
            if(obj == null)
                insertStmt.setNull(i, rsmd.getColumnType(i));
            else
                insertStmt.setObject(i, obj);
        }

        return insertStmt.executeUpdate() == 1;
    }

    private boolean updateRow(RowSet rowset, OracleRow oraclerow)
        throws SQLException
    {
        updateStmt.clearParameters();
        for(int i = 1; i <= columnCount; i++)
        {
            Object obj = null;
            obj = oraclerow.isColumnChanged(i) ? oraclerow.getModifiedColumn(i) : oraclerow.getColumn(i);
            if(obj == null)
                updateStmt.setNull(i, rsmd.getColumnType(i));
            else
                updateStmt.setObject(i, obj);
        }

        for(int j = 1; j <= columnCount; j++)
        {
            if(oraclerow.isOriginalNull(j))
                return updateRowWithNull(rowset, oraclerow);
            updateStmt.setObject(j + columnCount, oraclerow.getColumn(j));
        }

        return updateStmt.executeUpdate() == 1;
    }

    private boolean updateRowWithNull(RowSet rowset, OracleRow oraclerow)
        throws SQLException
    {
        StringBuffer stringbuffer;
        PreparedStatement preparedstatement;
        boolean flag = false;
        stringbuffer = new StringBuffer("UPDATE " + getTableName(rowset) + " SET ");
        for(int i = 1; i <= columnCount; i++)
        {
            if(i != 1)
                stringbuffer.append(", ");
            stringbuffer.append(rsmd.getColumnName(i) + " = :" + i);
        }

        stringbuffer.append(" WHERE ");
        for(int j = 1; j <= columnCount; j++)
        {
            if(j != 1)
                stringbuffer.append(" AND ");
            if(oraclerow.isOriginalNull(j))
                stringbuffer.append(rsmd.getColumnName(j) + " IS NULL ");
            else
                stringbuffer.append(rsmd.getColumnName(j) + " = :" + j);
        }

        preparedstatement = null;
        boolean flag1;
        preparedstatement = connection.prepareStatement(stringbuffer.substring(0, stringbuffer.length()));
        for(int k = 1; k <= columnCount; k++)
        {
            Object obj = null;
            obj = oraclerow.isColumnChanged(k) ? oraclerow.getModifiedColumn(k) : oraclerow.getColumn(k);
            if(obj == null)
                preparedstatement.setNull(k, rsmd.getColumnType(k));
            else
                preparedstatement.setObject(k, obj);
        }

        int l = 1;
        int i1 = 1;
        for(; l <= columnCount; l++)
            if(!oraclerow.isOriginalNull(l))
            {
                preparedstatement.setObject(i1 + columnCount, oraclerow.getColumn(l));
                i1++;
            }

        flag1 = preparedstatement.executeUpdate() == 1;
        if(preparedstatement != null)
            preparedstatement.close();
        break MISSING_BLOCK_LABEL_454;
        Exception exception;
        exception;
        if(preparedstatement != null)
            preparedstatement.close();
        throw exception;
        return flag1;
    }

    private boolean deleteRow(RowSet rowset, OracleRow oraclerow)
        throws SQLException
    {
        deleteStmt.clearParameters();
        for(int i = 1; i <= columnCount; i++)
        {
            if(oraclerow.isOriginalNull(i))
                return deleteRowWithNull(rowset, oraclerow);
            Object obj = oraclerow.getColumn(i);
            if(obj == null)
                deleteStmt.setNull(i, rsmd.getColumnType(i));
            else
                deleteStmt.setObject(i, obj);
        }

        return deleteStmt.executeUpdate() == 1;
    }

    private boolean deleteRowWithNull(RowSet rowset, OracleRow oraclerow)
        throws SQLException
    {
        StringBuffer stringbuffer;
        PreparedStatement preparedstatement;
        boolean flag = false;
        stringbuffer = new StringBuffer("DELETE FROM " + getTableName(rowset) + " WHERE ");
        for(int i = 1; i <= columnCount; i++)
        {
            if(i != 1)
                stringbuffer.append(" AND ");
            if(oraclerow.isOriginalNull(i))
                stringbuffer.append(rsmd.getColumnName(i) + " IS NULL ");
            else
                stringbuffer.append(rsmd.getColumnName(i) + " = :" + i);
        }

        preparedstatement = null;
        boolean flag1;
        preparedstatement = connection.prepareStatement(stringbuffer.substring(0, stringbuffer.length()));
        int j = 1;
        int k = 1;
        for(; j <= columnCount; j++)
            if(!oraclerow.isOriginalNull(j))
                preparedstatement.setObject(k++, oraclerow.getColumn(j));

        flag1 = preparedstatement.executeUpdate() == 1;
        if(preparedstatement != null)
            preparedstatement.close();
        break MISSING_BLOCK_LABEL_283;
        Exception exception;
        exception;
        if(preparedstatement != null)
            preparedstatement.close();
        throw exception;
        return flag1;
    }

    public synchronized boolean writeData(RowSetInternal rowsetinternal)
        throws SQLException
    {
        OracleCachedRowSet oraclecachedrowset = (OracleCachedRowSet)rowsetinternal;
        connection = ((OracleCachedRowSetReader)oraclecachedrowset.getReader()).getConnection(rowsetinternal);
        if(connection == null)
            throw new SQLException("Unable to get Connection");
        if(connection.getAutoCommit())
            connection.setAutoCommit(false);
        connection.setTransactionIsolation(oraclecachedrowset.getTransactionIsolation());
        initSQLStatement(oraclecachedrowset);
        if(columnCount < 1)
        {
            connection.close();
            return true;
        }
        boolean flag = oraclecachedrowset.getShowDeleted();
        oraclecachedrowset.setShowDeleted(true);
        oraclecachedrowset.beforeFirst();
        boolean flag1 = true;
        boolean flag2 = true;
        boolean flag3 = true;
        Object obj = null;
        do
        {
            if(!oraclecachedrowset.next())
                break;
            if(oraclecachedrowset.rowInserted())
            {
                if(!oraclecachedrowset.rowDeleted())
                {
                    OracleRow oraclerow = oraclecachedrowset.getCurrentRow();
                    flag2 = insertRow(oraclerow) || flag2;
                }
            } else
            if(oraclecachedrowset.rowUpdated())
            {
                OracleRow oraclerow1 = oraclecachedrowset.getCurrentRow();
                flag1 = updateRow(oraclecachedrowset, oraclerow1) || flag1;
            } else
            if(oraclecachedrowset.rowDeleted())
            {
                OracleRow oraclerow2 = oraclecachedrowset.getCurrentRow();
                flag3 = deleteRow(oraclecachedrowset, oraclerow2) || flag3;
            }
        } while(true);
        if(flag1 && flag2 && flag3)
        {
            connection.commit();
            oraclecachedrowset.setOriginal();
        } else
        {
            connection.rollback();
        }
        insertStmt.close();
        updateStmt.close();
        deleteStmt.close();
        if(!oraclecachedrowset.isConnectionStayingOpen())
            connection.close();
        oraclecachedrowset.setShowDeleted(flag);
        return true;
    }

    private StringBuffer updateClause;
    private StringBuffer deleteClause;
    private StringBuffer insertClause;
    private PreparedStatement insertStmt;
    private PreparedStatement updateStmt;
    private PreparedStatement deleteStmt;
    private ResultSetMetaData rsmd;
    private transient Connection connection;
    private int columnCount;
}
