// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleJDBCRowSet.java

package oracle.jdbc.rowset;

import java.io.InputStream;
import java.io.Reader;
import java.math.BigDecimal;
import java.net.URL;
import java.sql.*;
import java.util.Calendar;
import java.util.Map;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;
import javax.sql.RowSet;
import javax.sql.rowset.JdbcRowSet;
import javax.sql.rowset.RowSetWarning;
import oracle.jdbc.*;
import oracle.jdbc.driver.OracleDriver;

// Referenced classes of package oracle.jdbc.rowset:
//            OracleRowSet, OracleRowSetMetaData

public class OracleJDBCRowSet extends OracleRowSet
    implements RowSet, JdbcRowSet
{

    public OracleJDBCRowSet()
        throws SQLException
    {
        driverManagerInitialized = false;
    }

    public OracleJDBCRowSet(Connection connection1)
        throws SQLException
    {
        this();
        connection = connection1;
    }

    public void execute()
        throws SQLException
    {
        connection = getConnection(this);
        connection.setTransactionIsolation(getTransactionIsolation());
        connection.setTypeMap(getTypeMap());
        if(preparedStatement == null)
            preparedStatement = connection.prepareStatement(getCommand(), getType(), getConcurrency());
        preparedStatement.setFetchSize(getFetchSize());
        preparedStatement.setFetchDirection(getFetchDirection());
        preparedStatement.setMaxFieldSize(getMaxFieldSize());
        preparedStatement.setMaxRows(getMaxRows());
        preparedStatement.setQueryTimeout(getQueryTimeout());
        preparedStatement.setEscapeProcessing(getEscapeProcessing());
        resultSet = preparedStatement.executeQuery();
        notifyRowSetChanged();
    }

    public void close()
        throws SQLException
    {
        if(resultSet != null)
            resultSet.close();
        if(preparedStatement != null)
            preparedStatement.close();
        if(connection != null && !connection.isClosed())
        {
            connection.commit();
            connection.close();
        }
        notifyRowSetChanged();
    }

    private Connection getConnection(RowSet rowset)
        throws SQLException
    {
        Connection connection1 = null;
        if(connection != null && !connection.isClosed())
            connection1 = connection;
        else
        if(rowset.getDataSourceName() != null)
            try
            {
                InitialContext initialcontext = new InitialContext();
                DataSource datasource = (DataSource)initialcontext.lookup(rowset.getDataSourceName());
                if(rowset.getUsername() == null || rowset.getPassword() == null)
                    connection1 = datasource.getConnection();
                else
                    connection1 = datasource.getConnection(rowset.getUsername(), rowset.getPassword());
            }
            catch(NamingException namingexception)
            {
                throw new SQLException("Unable to connect through the DataSource\n" + namingexception.getMessage());
            }
        else
        if(rowset.getUrl() != null)
        {
            if(!driverManagerInitialized)
            {
                DriverManager.registerDriver(new OracleDriver());
                driverManagerInitialized = true;
            }
            String s = rowset.getUrl();
            String s1 = rowset.getUsername();
            String s2 = rowset.getPassword();
            if(s.equals("") || s1.equals("") || s2.equals(""))
                throw new SQLException("One or more of the authenticating parameter not set");
            connection1 = DriverManager.getConnection(s, s1, s2);
        }
        return connection1;
    }

    public boolean wasNull()
        throws SQLException
    {
        return resultSet.wasNull();
    }

    public SQLWarning getWarnings()
        throws SQLException
    {
        return resultSet.getWarnings();
    }

    public void clearWarnings()
        throws SQLException
    {
        resultSet.clearWarnings();
    }

    public String getCursorName()
        throws SQLException
    {
        return resultSet.getCursorName();
    }

    public ResultSetMetaData getMetaData()
        throws SQLException
    {
        return new OracleRowSetMetaData(resultSet.getMetaData());
    }

    public int findColumn(String s)
        throws SQLException
    {
        return resultSet.findColumn(s);
    }

    public void clearParameters()
        throws SQLException
    {
        preparedStatement.clearParameters();
    }

    public Statement getStatement()
        throws SQLException
    {
        return resultSet.getStatement();
    }

    public void setCommand(String s)
        throws SQLException
    {
        super.setCommand(s);
        if(connection == null || connection.isClosed())
            connection = getConnection(this);
        if(preparedStatement != null)
            try
            {
                preparedStatement.close();
                preparedStatement = null;
            }
            catch(SQLException sqlexception) { }
        preparedStatement = connection.prepareStatement(s, getType(), getConcurrency());
    }

    public void setReadOnly(boolean flag)
        throws SQLException
    {
        super.setReadOnly(flag);
        if(connection != null)
            connection.setReadOnly(flag);
        else
            throw new SQLException("Connection not open");
    }

    public void setFetchDirection(int i)
        throws SQLException
    {
        super.setFetchDirection(i);
        resultSet.setFetchDirection(fetchDirection);
    }

    public void setShowDeleted(boolean flag)
        throws SQLException
    {
        if(flag)
        {
            throw new SQLException("This JdbcRowSet implementation does not allow deleted rows to be visible");
        } else
        {
            super.setShowDeleted(flag);
            return;
        }
    }

    public boolean next()
        throws SQLException
    {
        boolean flag = resultSet.next();
        if(flag)
            notifyCursorMoved();
        return flag;
    }

    public boolean previous()
        throws SQLException
    {
        boolean flag = resultSet.previous();
        if(flag)
            notifyCursorMoved();
        return flag;
    }

    public void beforeFirst()
        throws SQLException
    {
        if(!isBeforeFirst())
        {
            resultSet.beforeFirst();
            notifyCursorMoved();
        }
    }

    public void afterLast()
        throws SQLException
    {
        if(!isAfterLast())
        {
            resultSet.afterLast();
            notifyCursorMoved();
        }
    }

    public boolean first()
        throws SQLException
    {
        boolean flag = resultSet.first();
        if(flag)
            notifyCursorMoved();
        return flag;
    }

    public boolean last()
        throws SQLException
    {
        boolean flag = resultSet.last();
        if(flag)
            notifyCursorMoved();
        return flag;
    }

    public boolean absolute(int i)
        throws SQLException
    {
        boolean flag = resultSet.absolute(i);
        if(flag)
            notifyCursorMoved();
        return flag;
    }

    public boolean relative(int i)
        throws SQLException
    {
        boolean flag = resultSet.relative(i);
        if(flag)
            notifyCursorMoved();
        return flag;
    }

    public boolean isBeforeFirst()
        throws SQLException
    {
        return resultSet.isBeforeFirst();
    }

    public boolean isAfterLast()
        throws SQLException
    {
        return resultSet.isAfterLast();
    }

    public boolean isFirst()
        throws SQLException
    {
        return resultSet.isFirst();
    }

    public boolean isLast()
        throws SQLException
    {
        return resultSet.isLast();
    }

    public void insertRow()
        throws SQLException
    {
        resultSet.insertRow();
        notifyRowChanged();
    }

    public void updateRow()
        throws SQLException
    {
        resultSet.updateRow();
        notifyRowChanged();
    }

    public void deleteRow()
        throws SQLException
    {
        resultSet.deleteRow();
        notifyRowChanged();
    }

    public void refreshRow()
        throws SQLException
    {
        resultSet.refreshRow();
    }

    public void cancelRowUpdates()
        throws SQLException
    {
        resultSet.cancelRowUpdates();
        notifyRowChanged();
    }

    public void moveToInsertRow()
        throws SQLException
    {
        resultSet.moveToInsertRow();
    }

    public void moveToCurrentRow()
        throws SQLException
    {
        resultSet.moveToCurrentRow();
    }

    public int getRow()
        throws SQLException
    {
        return resultSet.getRow();
    }

    public boolean rowUpdated()
        throws SQLException
    {
        return resultSet.rowUpdated();
    }

    public boolean rowInserted()
        throws SQLException
    {
        return resultSet.rowInserted();
    }

    public boolean rowDeleted()
        throws SQLException
    {
        return resultSet.rowDeleted();
    }

    public void setNull(int i, int j)
        throws SQLException
    {
        preparedStatement.setNull(i, j);
    }

    public void setNull(int i, int j, String s)
        throws SQLException
    {
        preparedStatement.setNull(i, j, s);
    }

    public void setBoolean(int i, boolean flag)
        throws SQLException
    {
        preparedStatement.setBoolean(i, flag);
    }

    public void setByte(int i, byte byte0)
        throws SQLException
    {
        preparedStatement.setByte(i, byte0);
    }

    public void setShort(int i, short word0)
        throws SQLException
    {
        preparedStatement.setShort(i, word0);
    }

    public void setInt(int i, int j)
        throws SQLException
    {
        preparedStatement.setInt(i, j);
    }

    public void setLong(int i, long l)
        throws SQLException
    {
        preparedStatement.setLong(i, l);
    }

    public void setFloat(int i, float f)
        throws SQLException
    {
        preparedStatement.setFloat(i, f);
    }

    public void setDouble(int i, double d)
        throws SQLException
    {
        preparedStatement.setDouble(i, d);
    }

    public void setBigDecimal(int i, BigDecimal bigdecimal)
        throws SQLException
    {
        preparedStatement.setBigDecimal(i, bigdecimal);
    }

    public void setString(int i, String s)
        throws SQLException
    {
        preparedStatement.setString(i, s);
    }

    public void setBytes(int i, byte abyte0[])
        throws SQLException
    {
        preparedStatement.setBytes(i, abyte0);
    }

    public void setDate(int i, Date date)
        throws SQLException
    {
        preparedStatement.setDate(i, date);
    }

    public void setTime(int i, Time time)
        throws SQLException
    {
        preparedStatement.setTime(i, time);
    }

    public void setObject(int i, Object obj)
        throws SQLException
    {
        preparedStatement.setObject(i, obj);
    }

    public void setRef(int i, Ref ref)
        throws SQLException
    {
        preparedStatement.setRef(i, ref);
    }

    public void setBlob(int i, Blob blob)
        throws SQLException
    {
        preparedStatement.setBlob(i, blob);
    }

    public void setClob(int i, Clob clob)
        throws SQLException
    {
        preparedStatement.setClob(i, clob);
    }

    public void setArray(int i, Array array)
        throws SQLException
    {
        preparedStatement.setArray(i, array);
    }

    public void setBinaryStream(int i, InputStream inputstream, int j)
        throws SQLException
    {
        preparedStatement.setBinaryStream(i, inputstream, j);
    }

    public void setTime(int i, Time time, Calendar calendar)
        throws SQLException
    {
        preparedStatement.setTime(i, time, calendar);
    }

    public void setTimestamp(int i, Timestamp timestamp, Calendar calendar)
        throws SQLException
    {
        preparedStatement.setTimestamp(i, timestamp, calendar);
    }

    public void setTimestamp(int i, Timestamp timestamp)
        throws SQLException
    {
        preparedStatement.setTimestamp(i, timestamp);
    }

    public void setAsciiStream(int i, InputStream inputstream, int j)
        throws SQLException
    {
        preparedStatement.setAsciiStream(i, inputstream, j);
    }

    public void setCharacterStream(int i, Reader reader, int j)
        throws SQLException
    {
        preparedStatement.setCharacterStream(i, reader, j);
    }

    public void setObject(int i, Object obj, int j, int k)
        throws SQLException
    {
        preparedStatement.setObject(i, obj, j, k);
    }

    public void setObject(int i, Object obj, int j)
        throws SQLException
    {
        preparedStatement.setObject(i, obj, j);
    }

    public void setDate(int i, Date date, Calendar calendar)
        throws SQLException
    {
        preparedStatement.setDate(i, date, calendar);
    }

    public Object getObject(int i, Map map)
        throws SQLException
    {
        return resultSet.getObject(i, map);
    }

    public BigDecimal getBigDecimal(int i)
        throws SQLException
    {
        return resultSet.getBigDecimal(i);
    }

    public Ref getRef(int i)
        throws SQLException
    {
        return resultSet.getRef(i);
    }

    public Blob getBlob(int i)
        throws SQLException
    {
        return resultSet.getBlob(i);
    }

    public Clob getClob(int i)
        throws SQLException
    {
        return resultSet.getClob(i);
    }

    public Array getArray(int i)
        throws SQLException
    {
        return resultSet.getArray(i);
    }

    public Date getDate(int i, Calendar calendar)
        throws SQLException
    {
        return resultSet.getDate(i, calendar);
    }

    public Reader getCharacterStream(int i)
        throws SQLException
    {
        return resultSet.getCharacterStream(i);
    }

    public Time getTime(int i, Calendar calendar)
        throws SQLException
    {
        return resultSet.getTime(i, calendar);
    }

    public InputStream getBinaryStream(int i)
        throws SQLException
    {
        return resultSet.getBinaryStream(i);
    }

    public Timestamp getTimestamp(int i, Calendar calendar)
        throws SQLException
    {
        return resultSet.getTimestamp(i, calendar);
    }

    public String getString(int i)
        throws SQLException
    {
        return resultSet.getString(i);
    }

    public boolean getBoolean(int i)
        throws SQLException
    {
        return resultSet.getBoolean(i);
    }

    public byte getByte(int i)
        throws SQLException
    {
        return resultSet.getByte(i);
    }

    public short getShort(int i)
        throws SQLException
    {
        return resultSet.getShort(i);
    }

    public long getLong(int i)
        throws SQLException
    {
        return resultSet.getLong(i);
    }

    public float getFloat(int i)
        throws SQLException
    {
        return resultSet.getFloat(i);
    }

    public double getDouble(int i)
        throws SQLException
    {
        return resultSet.getDouble(i);
    }

    public BigDecimal getBigDecimal(int i, int j)
        throws SQLException
    {
        return resultSet.getBigDecimal(i, j);
    }

    public byte[] getBytes(int i)
        throws SQLException
    {
        return resultSet.getBytes(i);
    }

    public Date getDate(int i)
        throws SQLException
    {
        return resultSet.getDate(i);
    }

    public Time getTime(int i)
        throws SQLException
    {
        return resultSet.getTime(i);
    }

    public Timestamp getTimestamp(int i)
        throws SQLException
    {
        return resultSet.getTimestamp(i);
    }

    public InputStream getAsciiStream(int i)
        throws SQLException
    {
        return resultSet.getAsciiStream(i);
    }

    public InputStream getUnicodeStream(int i)
        throws SQLException
    {
        return resultSet.getUnicodeStream(i);
    }

    public int getInt(int i)
        throws SQLException
    {
        return resultSet.getInt(i);
    }

    public Object getObject(int i)
        throws SQLException
    {
        return resultSet.getObject(i);
    }

    public int getInt(String s)
        throws SQLException
    {
        return resultSet.getInt(s);
    }

    public long getLong(String s)
        throws SQLException
    {
        return resultSet.getLong(s);
    }

    public float getFloat(String s)
        throws SQLException
    {
        return resultSet.getFloat(s);
    }

    public double getDouble(String s)
        throws SQLException
    {
        return resultSet.getDouble(s);
    }

    public BigDecimal getBigDecimal(String s, int i)
        throws SQLException
    {
        return resultSet.getBigDecimal(s, i);
    }

    public byte[] getBytes(String s)
        throws SQLException
    {
        return resultSet.getBytes(s);
    }

    public Date getDate(String s)
        throws SQLException
    {
        return resultSet.getDate(s);
    }

    public Time getTime(String s)
        throws SQLException
    {
        return resultSet.getTime(s);
    }

    public Timestamp getTimestamp(String s)
        throws SQLException
    {
        return resultSet.getTimestamp(s);
    }

    public InputStream getAsciiStream(String s)
        throws SQLException
    {
        return resultSet.getAsciiStream(s);
    }

    public InputStream getUnicodeStream(String s)
        throws SQLException
    {
        return resultSet.getUnicodeStream(s);
    }

    public Object getObject(String s)
        throws SQLException
    {
        return resultSet.getObject(s);
    }

    public Reader getCharacterStream(String s)
        throws SQLException
    {
        return resultSet.getCharacterStream(s);
    }

    public Object getObject(String s, Map map)
        throws SQLException
    {
        return resultSet.getObject(s, map);
    }

    public Ref getRef(String s)
        throws SQLException
    {
        return resultSet.getRef(s);
    }

    public Blob getBlob(String s)
        throws SQLException
    {
        return resultSet.getBlob(s);
    }

    public Clob getClob(String s)
        throws SQLException
    {
        return resultSet.getClob(s);
    }

    public Array getArray(String s)
        throws SQLException
    {
        return resultSet.getArray(s);
    }

    public BigDecimal getBigDecimal(String s)
        throws SQLException
    {
        return resultSet.getBigDecimal(s);
    }

    public Date getDate(String s, Calendar calendar)
        throws SQLException
    {
        return resultSet.getDate(s, calendar);
    }

    public Time getTime(String s, Calendar calendar)
        throws SQLException
    {
        return resultSet.getTime(s, calendar);
    }

    public InputStream getBinaryStream(String s)
        throws SQLException
    {
        return resultSet.getBinaryStream(s);
    }

    public Timestamp getTimestamp(String s, Calendar calendar)
        throws SQLException
    {
        return resultSet.getTimestamp(s, calendar);
    }

    public String getString(String s)
        throws SQLException
    {
        return resultSet.getString(s);
    }

    public boolean getBoolean(String s)
        throws SQLException
    {
        return resultSet.getBoolean(s);
    }

    public byte getByte(String s)
        throws SQLException
    {
        return resultSet.getByte(s);
    }

    public short getShort(String s)
        throws SQLException
    {
        return resultSet.getShort(s);
    }

    public void updateNull(int i)
        throws SQLException
    {
        resultSet.updateNull(i);
    }

    public void updateCharacterStream(int i, Reader reader, int j)
        throws SQLException
    {
        resultSet.updateCharacterStream(i, reader, j);
    }

    public void updateTimestamp(int i, Timestamp timestamp)
        throws SQLException
    {
        resultSet.updateTimestamp(i, timestamp);
    }

    public void updateBinaryStream(int i, InputStream inputstream, int j)
        throws SQLException
    {
        resultSet.updateBinaryStream(i, inputstream, j);
    }

    public void updateAsciiStream(int i, InputStream inputstream, int j)
        throws SQLException
    {
        resultSet.updateAsciiStream(i, inputstream, j);
    }

    public void updateBoolean(int i, boolean flag)
        throws SQLException
    {
        resultSet.updateBoolean(i, flag);
    }

    public void updateByte(int i, byte byte0)
        throws SQLException
    {
        resultSet.updateByte(i, byte0);
    }

    public void updateShort(int i, short word0)
        throws SQLException
    {
        resultSet.updateShort(i, word0);
    }

    public void updateInt(int i, int j)
        throws SQLException
    {
        resultSet.updateInt(i, j);
    }

    public void updateLong(int i, long l)
        throws SQLException
    {
        resultSet.updateLong(i, l);
    }

    public void updateFloat(int i, float f)
        throws SQLException
    {
        resultSet.updateFloat(i, f);
    }

    public void updateDouble(int i, double d)
        throws SQLException
    {
        resultSet.updateDouble(i, d);
    }

    public void updateBigDecimal(int i, BigDecimal bigdecimal)
        throws SQLException
    {
        resultSet.updateBigDecimal(i, bigdecimal);
    }

    public void updateString(int i, String s)
        throws SQLException
    {
        resultSet.updateString(i, s);
    }

    public void updateBytes(int i, byte abyte0[])
        throws SQLException
    {
        resultSet.updateBytes(i, abyte0);
    }

    public void updateDate(int i, Date date)
        throws SQLException
    {
        resultSet.updateDate(i, date);
    }

    public void updateTime(int i, Time time)
        throws SQLException
    {
        resultSet.updateTime(i, time);
    }

    public void updateObject(int i, Object obj)
        throws SQLException
    {
        resultSet.updateObject(i, obj);
    }

    public void updateObject(int i, Object obj, int j)
        throws SQLException
    {
        resultSet.updateObject(i, obj, j);
    }

    public void updateNull(String s)
        throws SQLException
    {
        resultSet.updateNull(s);
    }

    public void updateBoolean(String s, boolean flag)
        throws SQLException
    {
        resultSet.updateBoolean(s, flag);
    }

    public void updateByte(String s, byte byte0)
        throws SQLException
    {
        resultSet.updateByte(s, byte0);
    }

    public void updateShort(String s, short word0)
        throws SQLException
    {
        resultSet.updateShort(s, word0);
    }

    public void updateInt(String s, int i)
        throws SQLException
    {
        resultSet.updateInt(s, i);
    }

    public void updateLong(String s, long l)
        throws SQLException
    {
        resultSet.updateLong(s, l);
    }

    public void updateFloat(String s, float f)
        throws SQLException
    {
        resultSet.updateFloat(s, f);
    }

    public void updateDouble(String s, double d)
        throws SQLException
    {
        resultSet.updateDouble(s, d);
    }

    public void updateBigDecimal(String s, BigDecimal bigdecimal)
        throws SQLException
    {
        resultSet.updateBigDecimal(s, bigdecimal);
    }

    public void updateString(String s, String s1)
        throws SQLException
    {
        resultSet.updateString(s, s1);
    }

    public void updateBytes(String s, byte abyte0[])
        throws SQLException
    {
        resultSet.updateBytes(s, abyte0);
    }

    public void updateDate(String s, Date date)
        throws SQLException
    {
        resultSet.updateDate(s, date);
    }

    public void updateTime(String s, Time time)
        throws SQLException
    {
        resultSet.updateTime(s, time);
    }

    public void updateObject(String s, Object obj)
        throws SQLException
    {
        resultSet.updateObject(s, obj);
    }

    public void updateObject(String s, Object obj, int i)
        throws SQLException
    {
        resultSet.updateObject(s, obj, i);
    }

    public void updateBinaryStream(String s, InputStream inputstream, int i)
        throws SQLException
    {
        resultSet.updateBinaryStream(s, inputstream, i);
    }

    public void updateAsciiStream(String s, InputStream inputstream, int i)
        throws SQLException
    {
        resultSet.updateAsciiStream(s, inputstream, i);
    }

    public void updateTimestamp(String s, Timestamp timestamp)
        throws SQLException
    {
        resultSet.updateTimestamp(s, timestamp);
    }

    public void updateCharacterStream(String s, Reader reader, int i)
        throws SQLException
    {
        resultSet.updateCharacterStream(s, reader, i);
    }

    public URL getURL(int i)
        throws SQLException
    {
        return ((OracleResultSet)resultSet).getURL(i);
    }

    public URL getURL(String s)
        throws SQLException
    {
        return ((OracleResultSet)resultSet).getURL(s);
    }

    public void updateRef(int i, Ref ref)
        throws SQLException
    {
        ((OracleResultSet)resultSet).updateRef(i, ref);
    }

    public void updateRef(String s, Ref ref)
        throws SQLException
    {
        ((OracleResultSet)resultSet).updateRef(s, ref);
    }

    public void updateBlob(int i, Blob blob)
        throws SQLException
    {
        ((OracleResultSet)resultSet).updateBlob(i, blob);
    }

    public void updateBlob(String s, Blob blob)
        throws SQLException
    {
        ((OracleResultSet)resultSet).updateBlob(s, blob);
    }

    public void updateClob(int i, Clob clob)
        throws SQLException
    {
        ((OracleResultSet)resultSet).updateClob(i, clob);
    }

    public void updateClob(String s, Clob clob)
        throws SQLException
    {
        ((OracleResultSet)resultSet).updateClob(s, clob);
    }

    public void updateArray(int i, Array array)
        throws SQLException
    {
        ((OracleResultSet)resultSet).updateArray(i, array);
    }

    public void updateArray(String s, Array array)
        throws SQLException
    {
        ((OracleResultSet)resultSet).updateArray(s, array);
    }

    public void commit()
        throws SQLException
    {
        if(connection != null)
            connection.commit();
        else
            throw new SQLException("Connection not open");
    }

    public void rollback()
        throws SQLException
    {
        if(connection != null)
            connection.rollback();
        else
            throw new SQLException("Connection not open");
    }

    public void rollback(Savepoint savepoint)
        throws SQLException
    {
        if(connection != null)
            connection.rollback(savepoint);
        else
            throw new SQLException("Connection not open");
    }

    public void oracleRollback(OracleSavepoint oraclesavepoint)
        throws SQLException
    {
        if(connection != null)
            ((OracleConnection)connection).oracleRollback(oraclesavepoint);
        else
            throw new SQLException("Connection not open");
    }

    public boolean getAutoCommit()
        throws SQLException
    {
        if(connection != null)
            return connection.getAutoCommit();
        else
            throw new SQLException("Connection not open");
    }

    public void setAutoCommit(boolean flag)
        throws SQLException
    {
        if(connection != null)
            connection.setAutoCommit(flag);
        else
            throw new SQLException("Connection not open");
    }

    public RowSetWarning getRowSetWarnings()
        throws SQLException
    {
        return null;
    }

    String getTableName()
        throws SQLException
    {
        return getMetaData().getTableName(getMatchColumnIndexes()[0]);
    }

    private Connection connection;
    private static boolean driverManagerInitialized;
    private PreparedStatement preparedStatement;
    private ResultSet resultSet;
}
