// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleJoinRowSet.java

package oracle.jdbc.rowset;

import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.Collection;
import java.util.Vector;
import javax.sql.RowSet;
import javax.sql.RowSetMetaData;
import javax.sql.rowset.*;

// Referenced classes of package oracle.jdbc.rowset:
//            OracleWebRowSet, OracleRowSet, OracleCachedRowSet, OracleRowSetMetaData, 
//            OracleRow, OracleJDBCRowSet

public class OracleJoinRowSet extends OracleWebRowSet
    implements JoinRowSet
{

    public OracleJoinRowSet()
        throws SQLException
    {
        joinType = 1;
        addedRowSets = new Vector();
        addedRowSetNames = new Vector();
    }

    public synchronized void addRowSet(Joinable joinable)
        throws SQLException
    {
        if(joinable == null)
            throw new SQLException("Invalid empty RowSet parameter");
        if(!(joinable instanceof RowSet))
            throw new SQLException("The parameter is not a RowSet instance");
        OracleCachedRowSet oraclecachedrowset = checkAndWrapRowSet((RowSet)joinable);
        String s = getMatchColumnTableName((RowSet)joinable);
        switch(joinType)
        {
        case 1: // '\001'
            doInnerJoin(oraclecachedrowset);
            addedRowSets.add(joinable);
            addedRowSetNames.add(s);
            break;

        case 0: // '\0'
        case 2: // '\002'
        case 3: // '\003'
        case 4: // '\004'
        default:
            throw new SQLException("Join type is not supported");
        }
    }

    public synchronized void addRowSet(RowSet rowset, int i)
        throws SQLException
    {
        ((OracleRowSet)rowset).setMatchColumn(i);
        addRowSet((Joinable)rowset);
    }

    public synchronized void addRowSet(RowSet rowset, String s)
        throws SQLException
    {
        ((OracleRowSet)rowset).setMatchColumn(s);
        addRowSet((Joinable)rowset);
    }

    public synchronized void addRowSet(RowSet arowset[], int ai[])
        throws SQLException
    {
        if(arowset.length != ai.length)
            throw new SQLException("Number of elements in rowsets is not equal to match columns");
        for(int i = 0; i < arowset.length; i++)
        {
            ((OracleRowSet)arowset[i]).setMatchColumn(ai[i]);
            addRowSet((Joinable)arowset[i]);
        }

    }

    public synchronized void addRowSet(RowSet arowset[], String as[])
        throws SQLException
    {
        if(arowset.length != as.length)
            throw new SQLException("Number of elements in rowsets is not equal to match columns");
        for(int i = 0; i < arowset.length; i++)
        {
            ((OracleRowSet)arowset[i]).setMatchColumn(as[i]);
            addRowSet((Joinable)arowset[i]);
        }

    }

    public Collection getRowSets()
        throws SQLException
    {
        return addedRowSets;
    }

    public String[] getRowSetNames()
        throws SQLException
    {
        Object aobj[] = addedRowSetNames.toArray();
        String as[] = new String[aobj.length];
        for(int i = 0; i < aobj.length; i++)
            as[i] = (String)aobj[i];

        return as;
    }

    public CachedRowSet toCachedRowSet()
        throws SQLException
    {
        OracleCachedRowSet oraclecachedrowset = (OracleCachedRowSet)createCopy();
        oraclecachedrowset.setCommand("");
        return oraclecachedrowset;
    }

    public int getJoinType()
    {
        return joinType;
    }

    public boolean supportsCrossJoin()
    {
        return supportedJoins[0];
    }

    public boolean supportsInnerJoin()
    {
        return supportedJoins[1];
    }

    public boolean supportsLeftOuterJoin()
    {
        return supportedJoins[2];
    }

    public boolean supportsRightOuterJoin()
    {
        return supportedJoins[3];
    }

    public boolean supportsFullJoin()
    {
        return supportedJoins[4];
    }

    public void setJoinType(int i)
        throws SQLException
    {
        if(i != 1)
        {
            throw new SQLException("Join type is not supported");
        } else
        {
            joinType = i;
            return;
        }
    }

    public synchronized String getWhereClause()
        throws SQLException
    {
        if(addedRowSets.size() < 2)
            return "WHERE";
        StringBuffer stringbuffer = new StringBuffer();
        stringbuffer.append("WHERE\n");
        OracleRowSet oraclerowset = (OracleRowSet)addedRowSets.get(0);
        int ai[] = oraclerowset.getMatchColumnIndexes();
        ResultSetMetaData resultsetmetadata = oraclerowset.getMetaData();
        String s = oraclerowset.getTableName();
        for(int i = 1; i < addedRowSets.size(); i++)
        {
            if(i > 1)
                stringbuffer.append("\nAND\n");
            OracleRowSet oraclerowset2 = (OracleRowSet)addedRowSets.get(i);
            int ai1[] = oraclerowset2.getMatchColumnIndexes();
            ResultSetMetaData resultsetmetadata1 = oraclerowset2.getMetaData();
            String s1 = oraclerowset2.getTableName();
            for(int j = 0; j < ai.length; j++)
            {
                if(j > 0)
                    stringbuffer.append("\nAND\n");
                stringbuffer.append("(" + s + "." + resultsetmetadata.getColumnName(ai[j]) + " = " + s1 + "." + resultsetmetadata1.getColumnName(ai1[j]) + ")");
            }

            OracleRowSet oraclerowset1 = oraclerowset2;
            ai = ai1;
            resultsetmetadata = resultsetmetadata1;
            s = s1;
        }

        stringbuffer.append(";");
        return stringbuffer.toString();
    }

    private void doInnerJoin(OracleCachedRowSet oraclecachedrowset)
        throws SQLException
    {
        if(addedRowSets.isEmpty())
        {
            setMetaData((RowSetMetaData)oraclecachedrowset.getMetaData());
            populate(oraclecachedrowset);
            setMatchColumn(oraclecachedrowset.getMatchColumnIndexes());
        } else
        {
            Vector vector = new Vector(100);
            OracleRowSetMetaData oraclerowsetmetadata = new OracleRowSetMetaData(10);
            int ai[] = getMatchColumnIndexes();
            int ai1[] = oraclecachedrowset.getMatchColumnIndexes();
            int i = (getMetaData().getColumnCount() + oraclecachedrowset.getMetaData().getColumnCount()) - ai1.length;
            oraclerowsetmetadata.setColumnCount(i);
            String s = getTableName() + "#" + oraclecachedrowset.getTableName();
            for(int j = 1; j <= colCount; j++)
            {
                boolean flag = false;
                int k = 0;
                do
                {
                    if(k >= ai.length)
                        break;
                    if(j == ai[k])
                    {
                        flag = true;
                        break;
                    }
                    k++;
                } while(true);
                setNewColumnMetaData(j, oraclerowsetmetadata, j, (RowSetMetaData)rowsetMetaData, flag, s);
            }

            RowSetMetaData rowsetmetadata = (RowSetMetaData)oraclecachedrowset.getMetaData();
            int l = rowsetmetadata.getColumnCount();
            int i1 = colCount + 1;
            int ai2[] = new int[l];
            for(int j1 = 1; j1 <= l; j1++)
            {
                boolean flag1 = false;
                int l1 = 0;
                do
                {
                    if(l1 >= ai1.length)
                        break;
                    if(j1 == ai[l1])
                    {
                        flag1 = true;
                        break;
                    }
                    l1++;
                } while(true);
                if(!flag1)
                {
                    setNewColumnMetaData(i1, oraclerowsetmetadata, j1, rowsetmetadata, flag1, s);
                    ai2[j1 - 1] = i1;
                    i1++;
                } else
                {
                    ai2[j1 - 1] = -1;
                }
            }

            beforeFirst();
            int k1 = oraclecachedrowset.size();
            boolean flag2 = false;
            for(int i2 = 1; i2 <= rowCount; i2++)
            {
                next();
                oraclecachedrowset.beforeFirst();
                for(int j2 = 1; j2 <= k1; j2++)
                {
                    oraclecachedrowset.next();
                    boolean flag3 = true;
                    int k2 = 0;
                    do
                    {
                        if(k2 >= ai.length)
                            break;
                        Object obj = getObject(ai[k2]);
                        Object obj1 = oraclecachedrowset.getObject(ai1[k2]);
                        if(!obj.equals(obj1))
                        {
                            flag3 = false;
                            break;
                        }
                        k2++;
                    } while(true);
                    if(!flag3)
                        continue;
                    OracleRow oraclerow = new OracleRow(i, true);
                    for(int l2 = 1; l2 <= colCount; l2++)
                        oraclerow.updateObject(l2, getObject(l2));

                    for(int i3 = 1; i3 <= l; i3++)
                        if(ai2[i3 - 1] != -1)
                            oraclerow.updateObject(ai2[i3 - 1], oraclecachedrowset.getObject(i3));

                    vector.add(oraclerow);
                }

            }

            rows = vector;
            presentRow = 0;
            rowCount = rows.size();
            setMetaData(oraclerowsetmetadata);
        }
    }

    private void setNewColumnMetaData(int i, RowSetMetaData rowsetmetadata, int j, RowSetMetaData rowsetmetadata1, boolean flag, String s)
        throws SQLException
    {
        rowsetmetadata.setAutoIncrement(i, rowsetmetadata1.isAutoIncrement(j));
        rowsetmetadata.setCaseSensitive(i, rowsetmetadata1.isCaseSensitive(j));
        rowsetmetadata.setCatalogName(i, rowsetmetadata1.getCatalogName(j));
        rowsetmetadata.setColumnDisplaySize(i, rowsetmetadata1.getColumnDisplaySize(j));
        if(flag)
            rowsetmetadata.setColumnName(i, rowsetmetadata1.getColumnName(i) + "#MATCH_COLUMN");
        else
            rowsetmetadata.setColumnName(i, rowsetmetadata1.getColumnName(j));
        rowsetmetadata.setColumnLabel(i, rowsetmetadata.getColumnName(j));
        rowsetmetadata.setColumnType(i, rowsetmetadata1.getColumnType(j));
        rowsetmetadata.setColumnTypeName(i, rowsetmetadata1.getColumnTypeName(j));
        rowsetmetadata.setCurrency(i, rowsetmetadata1.isCurrency(j));
        rowsetmetadata.setNullable(i, rowsetmetadata1.isNullable(j));
        rowsetmetadata.setPrecision(i, rowsetmetadata1.getPrecision(j));
        rowsetmetadata.setScale(i, rowsetmetadata1.getScale(j));
        rowsetmetadata.setSchemaName(i, rowsetmetadata1.getSchemaName(j));
        rowsetmetadata.setSearchable(i, rowsetmetadata1.isSearchable(j));
        rowsetmetadata.setSigned(i, rowsetmetadata1.isSigned(j));
        if(flag)
            rowsetmetadata.setTableName(i, s);
        else
            rowsetmetadata.setTableName(i, rowsetmetadata1.getTableName(j));
    }

    private OracleCachedRowSet checkAndWrapRowSet(RowSet rowset)
        throws SQLException
    {
        OracleCachedRowSet oraclecachedrowset;
        if(rowset instanceof OracleCachedRowSet)
            oraclecachedrowset = (OracleCachedRowSet)rowset;
        else
        if(rowset instanceof OracleJDBCRowSet)
        {
            oraclecachedrowset = new OracleCachedRowSet();
            oraclecachedrowset.populate(rowset);
            int ai[] = ((OracleJDBCRowSet)rowset).getMatchColumnIndexes();
            oraclecachedrowset.setMatchColumn(ai);
        } else
        {
            throw new SQLException("Third-party RowSet Join not yet supported");
        }
        return oraclecachedrowset;
    }

    private String getMatchColumnTableName(RowSet rowset)
        throws SQLException
    {
        String s = null;
        if(rowset instanceof OracleRowSet)
            s = ((OracleRowSet)rowset).getTableName();
        return s;
    }

    private static final String MATCH_COLUMN_SUFFIX = "#MATCH_COLUMN";
    private static boolean supportedJoins[] = {
        false, true, false, false, false
    };
    private int joinType;
    private Vector addedRowSets;
    private Vector addedRowSetNames;
    private Object lockForJoinActions;

}
