// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleRow.java

package oracle.jdbc.rowset;

import java.io.*;
import java.math.BigDecimal;
import java.sql.*;
import java.util.Collection;
import java.util.Vector;

public class OracleRow
    implements Serializable, Cloneable
{

    public OracleRow(int i)
    {
        noColumn = 0;
        rowDeleted = false;
        rowInserted = false;
        rowUpdated = false;
        noColumn = i;
        column = new Object[i];
        changedColumn = new Object[i];
        columnChangeFlag = new byte[i];
        isOriginalNull = new boolean[i];
        for(int j = 0; j < i; j++)
            columnChangeFlag[j] = 0;

    }

    public OracleRow(int i, boolean flag)
    {
        this(i);
        rowInserted = flag;
        noColumnsInserted = 0;
    }

    public OracleRow(int i, Object aobj[])
    {
        this(i);
        System.arraycopy(((Object) (aobj)), 0, ((Object) (column)), 0, i);
    }

    public void setColumnValue(int i, Object obj)
    {
        if(rowInserted)
            noColumnsInserted++;
        column[i - 1] = obj;
    }

    void markOriginalNull(int i, boolean flag)
        throws SQLException
    {
        isOriginalNull[i - 1] = flag;
    }

    boolean isOriginalNull(int i)
        throws SQLException
    {
        return isOriginalNull[i - 1];
    }

    public void updateObject(int i, Object obj)
    {
        if(rowInserted)
            noColumnsInserted++;
        columnChangeFlag[i - 1] = 17;
        changedColumn[i - 1] = obj;
    }

    public void cancelRowUpdates()
    {
        noColumnsInserted = 0;
        for(int i = 0; i < noColumn; i++)
            columnChangeFlag[i] = 0;

        changedColumn = null;
        changedColumn = new Object[noColumn];
    }

    public Object getColumn(int i)
    {
        return column[i - 1];
    }

    public Object getModifiedColumn(int i)
    {
        return changedColumn[i - 1];
    }

    public boolean isColumnChanged(int i)
    {
        return columnChangeFlag[i - 1] == 17;
    }

    public boolean isRowUpdated()
    {
        if(rowInserted || rowDeleted)
            return false;
        for(int i = 0; i < noColumn; i++)
            if(columnChangeFlag[i] == 17)
                return true;

        return false;
    }

    public void setRowUpdated(boolean flag)
    {
        rowUpdated = flag;
        if(!flag)
            cancelRowUpdates();
    }

    public boolean isRowInserted()
    {
        return rowInserted;
    }

    public void cancelRowDeletion()
    {
        rowDeleted = false;
    }

    public void setRowDeleted(boolean flag)
    {
        rowDeleted = flag;
    }

    public boolean isRowDeleted()
    {
        return rowDeleted;
    }

    public Object[] getOriginalRow()
    {
        return column;
    }

    public boolean isRowFullyPopulated()
    {
        if(!rowInserted)
            return false;
        else
            return noColumnsInserted == noColumn;
    }

    public void setInsertedFlag(boolean flag)
    {
        rowInserted = flag;
    }

    void makeUpdatesOriginal()
    {
        for(int i = 0; i < noColumn; i++)
            if(columnChangeFlag[i] == 17)
            {
                column[i] = changedColumn[i];
                changedColumn[i] = null;
                columnChangeFlag[i] = 0;
            }

        rowUpdated = false;
    }

    public void insertRow()
    {
        columnChangeFlag = null;
        columnChangeFlag = new byte[noColumn];
        System.arraycopy(((Object) (changedColumn)), 0, ((Object) (column)), 0, noColumn);
        changedColumn = null;
        changedColumn = new Object[noColumn];
    }

    public Collection toCollection()
    {
        Vector vector = new Vector(noColumn);
        for(int i = 1; i <= noColumn; i++)
            vector.add(isColumnChanged(i) ? getModifiedColumn(i) : getColumn(i));

        return vector;
    }

    public OracleRow createCopy()
        throws SQLException
    {
        OracleRow oraclerow = new OracleRow(noColumn);
        for(int i = 0; i < noColumn; i++)
        {
            oraclerow.column[i] = getCopy(column[i]);
            oraclerow.changedColumn[i] = getCopy(changedColumn[i]);
        }

        System.arraycopy(columnChangeFlag, 0, oraclerow.columnChangeFlag, 0, noColumn);
        oraclerow.noColumnsInserted = noColumnsInserted;
        oraclerow.rowDeleted = rowDeleted;
        oraclerow.rowInserted = rowInserted;
        oraclerow.rowUpdated = rowUpdated;
        return oraclerow;
    }

    public Object getCopy(Object obj)
        throws SQLException
    {
        Object obj1 = null;
        if(obj == null)
            return null;
        Object obj2;
        try
        {
            if(obj instanceof String)
                obj2 = new String((String)obj);
            else
            if(obj instanceof Number)
                obj2 = new BigDecimal(((Number)obj).toString());
            else
            if(obj instanceof Date)
                obj2 = new Date(((Date)obj).getTime());
            else
            if(obj instanceof Timestamp)
                obj2 = new Timestamp(((Timestamp)obj).getTime());
            else
            if(obj instanceof InputStream)
                obj2 = new DataInputStream((InputStream)obj);
            else
            if(obj instanceof OutputStream)
                obj2 = new DataOutputStream((OutputStream)obj);
            else
                throw new SQLException("Error, could not reproduce the copy of the object, " + obj.getClass().getName());
        }
        catch(Exception exception)
        {
            throw new SQLException("Error while creating a copy of the column of type, " + obj.getClass().getName() + "\n" + exception.getMessage());
        }
        return obj2;
    }

    public Object clone()
        throws CloneNotSupportedException
    {
        return createCopy();
        SQLException sqlexception;
        sqlexception;
        throw new CloneNotSupportedException("Error while cloning\n" + sqlexception.getMessage());
    }

    private Object column[];
    private Object changedColumn[];
    private boolean isOriginalNull[];
    private byte columnChangeFlag[];
    private int noColumn;
    private int noColumnsInserted;
    private boolean rowDeleted;
    private boolean rowInserted;
    private final byte COLUMN_CHANGED = 17;
    private boolean rowUpdated;
}
