// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleRowSet.java

package oracle.jdbc.rowset;

import java.io.Serializable;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.*;
import javax.sql.*;
import javax.sql.rowset.Joinable;

abstract class OracleRowSet
    implements Serializable, Cloneable, Joinable
{

    protected OracleRowSet()
        throws SQLException
    {
        initializeProperties();
        matchColumnIndexes = new Vector(10);
        matchColumnNames = new Vector(10);
        listener = new Vector();
        rowsetEvent = new RowSetEvent((RowSet)this);
    }

    protected void initializeProperties()
    {
        command = null;
        concurrency = 1007;
        dataSource = null;
        dataSourceName = null;
        escapeProcessing = true;
        fetchDirection = 1002;
        fetchSize = 0;
        maxFieldSize = 0;
        maxRows = 0;
        queryTimeout = 0;
        readOnly = true;
        showDeleted = false;
        transactionIsolation = 2;
        rowsetType = 1005;
        typeMap = new HashMap();
        username = null;
        password = null;
        url = null;
    }

    public String getCommand()
    {
        return command;
    }

    public int getConcurrency()
        throws SQLException
    {
        return concurrency;
    }

    /**
     * @deprecated Method getDataSource is deprecated
     */

    public String getDataSource()
    {
        return dataSource;
    }

    public String getDataSourceName()
    {
        return dataSourceName;
    }

    public boolean getEscapeProcessing()
        throws SQLException
    {
        return escapeProcessing;
    }

    public int getFetchDirection()
        throws SQLException
    {
        return fetchDirection;
    }

    public int getFetchSize()
        throws SQLException
    {
        return fetchSize;
    }

    public int getMaxFieldSize()
        throws SQLException
    {
        return maxFieldSize;
    }

    public int getMaxRows()
        throws SQLException
    {
        return maxRows;
    }

    public String getPassword()
    {
        return password;
    }

    public int getQueryTimeout()
        throws SQLException
    {
        return queryTimeout;
    }

    public boolean getReadOnly()
    {
        return isReadOnly();
    }

    public boolean isReadOnly()
    {
        return readOnly;
    }

    public boolean getShowDeleted()
    {
        return showDeleted;
    }

    public int getTransactionIsolation()
    {
        return transactionIsolation;
    }

    public int getType()
        throws SQLException
    {
        return rowsetType;
    }

    public Map getTypeMap()
        throws SQLException
    {
        return typeMap;
    }

    public String getUrl()
    {
        return url;
    }

    public String getUsername()
    {
        return username;
    }

    public void setCommand(String s)
        throws SQLException
    {
        command = s;
    }

    public void setConcurrency(int i)
        throws SQLException
    {
        if(i == 1007 || i == 1008)
            concurrency = i;
        else
            throw new SQLException("Invalid concurrancy mode");
    }

    /**
     * @deprecated Method setDataSource is deprecated
     */

    public void setDataSource(String s)
    {
        dataSource = s;
    }

    public void setDataSourceName(String s)
        throws SQLException
    {
        dataSourceName = s;
    }

    public void setEscapeProcessing(boolean flag)
        throws SQLException
    {
        escapeProcessing = flag;
    }

    public void setFetchDirection(int i)
        throws SQLException
    {
        fetchDirection = i;
    }

    public void setFetchSize(int i)
        throws SQLException
    {
        fetchSize = i;
    }

    public void setMaxFieldSize(int i)
        throws SQLException
    {
        maxFieldSize = i;
    }

    public void setMaxRows(int i)
        throws SQLException
    {
        maxRows = i;
    }

    public void setPassword(String s)
        throws SQLException
    {
        password = s;
    }

    public void setQueryTimeout(int i)
        throws SQLException
    {
        queryTimeout = i;
    }

    public void setReadOnly(boolean flag)
        throws SQLException
    {
        readOnly = flag;
    }

    public void setShowDeleted(boolean flag)
        throws SQLException
    {
        showDeleted = flag;
    }

    public void setTransactionIsolation(int i)
        throws SQLException
    {
        transactionIsolation = i;
    }

    public void setType(int i)
        throws SQLException
    {
        if(i == 1003 || i == 1004 || i == 1005)
            rowsetType = i;
        else
            throw new SQLException("Unknown RowSet type");
    }

    public void setTypeMap(Map map)
        throws SQLException
    {
        typeMap = map;
    }

    public void setUrl(String s)
    {
        url = s;
    }

    public void setUsername(String s)
        throws SQLException
    {
        username = s;
    }

    public void addRowSetListener(RowSetListener rowsetlistener)
    {
        for(int i = 0; i < listener.size(); i++)
            if(listener.elementAt(i).equals(rowsetlistener))
                return;

        listener.add(rowsetlistener);
    }

    public void removeRowSetListener(RowSetListener rowsetlistener)
    {
        for(int i = 0; i < listener.size(); i++)
            if(listener.elementAt(i).equals(rowsetlistener))
                listener.remove(i);

    }

    protected synchronized void notifyCursorMoved()
    {
        int i = listener.size();
        if(i > 0)
        {
            for(int j = 0; j < i; j++)
                ((RowSetListener)listener.elementAt(j)).cursorMoved(rowsetEvent);

        }
    }

    protected void notifyRowChanged()
    {
        int i = listener.size();
        if(i > 0)
        {
            for(int j = 0; j < i; j++)
                ((RowSetListener)listener.elementAt(j)).rowChanged(rowsetEvent);

        }
    }

    protected void notifyRowSetChanged()
    {
        int i = listener.size();
        if(i > 0)
        {
            for(int j = 0; j < i; j++)
                ((RowSetListener)listener.elementAt(j)).rowSetChanged(rowsetEvent);

        }
    }

    public int[] getMatchColumnIndexes()
        throws SQLException
    {
        if(matchColumnIndexes.size() == 0 && matchColumnNames.size() == 0)
            throw new SQLException("No match column indexes were set");
        int ai[];
        if(matchColumnNames.size() > 0)
        {
            String as[] = getMatchColumnNames();
            int i = as.length;
            ai = new int[i];
            for(int l = 0; l < i; l++)
                ai[l] = findColumn(as[l]);

        } else
        {
            int j = matchColumnIndexes.size();
            ai = new int[j];
            byte byte0 = -1;
            for(int i1 = 0; i1 < j; i1++)
            {
                int k;
                try
                {
                    k = ((Integer)matchColumnIndexes.get(i1)).intValue();
                }
                catch(Exception exception)
                {
                    throw new SQLException("Invalid match column index");
                }
                if(k <= 0)
                    throw new SQLException("Invalid match column index");
                ai[i1] = k;
            }

        }
        return ai;
    }

    public String[] getMatchColumnNames()
        throws SQLException
    {
        checkIfMatchColumnNamesSet();
        int i = matchColumnNames.size();
        String as[] = new String[i];
        Object obj = null;
        for(int j = 0; j < i; j++)
        {
            String s;
            try
            {
                s = (String)matchColumnNames.get(j);
            }
            catch(Exception exception)
            {
                throw new SQLException("Invalid match column name");
            }
            if(s == null || s.equals(""))
                throw new SQLException("Invalid match column name");
            as[j] = s;
        }

        return as;
    }

    public void setMatchColumn(int i)
        throws SQLException
    {
        if(i <= 0)
            throw new SQLException("The match column index should be greater than 0");
        try
        {
            matchColumnIndexes.clear();
            matchColumnNames.clear();
            matchColumnIndexes.add(0, new Integer(i));
        }
        catch(Exception exception)
        {
            throw new SQLException("The match column index could not be set");
        }
    }

    public void setMatchColumn(int ai[])
        throws SQLException
    {
        matchColumnIndexes.clear();
        matchColumnNames.clear();
        if(ai == null)
            throw new SQLException("The match column parameter is null");
        for(int i = 0; i < ai.length; i++)
        {
            if(ai[i] <= 0)
                throw new SQLException("The match column index should be greater than 0");
            try
            {
                matchColumnIndexes.add(i, new Integer(ai[i]));
            }
            catch(Exception exception)
            {
                throw new SQLException("The match column index could not be set");
            }
        }

    }

    public void setMatchColumn(String s)
        throws SQLException
    {
        if(s == null || s.equals(""))
            throw new SQLException("The match column name should be non-empty");
        try
        {
            matchColumnIndexes.clear();
            matchColumnNames.clear();
            matchColumnNames.add(0, s.trim());
        }
        catch(Exception exception)
        {
            throw new SQLException("The match column name could not be set");
        }
    }

    public void setMatchColumn(String as[])
        throws SQLException
    {
        matchColumnIndexes.clear();
        matchColumnNames.clear();
        for(int i = 0; i < as.length; i++)
        {
            if(as[i] == null || as[i].equals(""))
                throw new SQLException("The match column name should be non-empty");
            try
            {
                matchColumnNames.add(i, as[i].trim());
            }
            catch(Exception exception)
            {
                throw new SQLException("The match column name could not be set");
            }
        }

    }

    public void unsetMatchColumn(int i)
        throws SQLException
    {
        checkIfMatchColumnIndexesSet();
        if(i <= 0)
            throw new SQLException("The match column index should be greater than 0");
        int j = -1;
        try
        {
            j = ((Integer)matchColumnIndexes.get(0)).intValue();
        }
        catch(Exception exception)
        {
            throw new SQLException("No match column indexes were set");
        }
        if(j != i)
        {
            throw new SQLException("The column index being unset has not been set");
        } else
        {
            matchColumnIndexes.clear();
            matchColumnNames.clear();
            return;
        }
    }

    public void unsetMatchColumn(int ai[])
        throws SQLException
    {
        checkIfMatchColumnIndexesSet();
        if(ai == null)
            throw new SQLException("The match column parameter is null");
        byte byte0 = -1;
        for(int j = 0; j < ai.length; j++)
        {
            if(ai[j] <= 0)
                throw new SQLException("The match column index should be greater than 0");
            int i;
            try
            {
                i = ((Integer)matchColumnIndexes.get(j)).intValue();
            }
            catch(Exception exception)
            {
                throw new SQLException("No match column indexes were set");
            }
            if(i != ai[j])
                throw new SQLException("The column index being unset has not been set");
        }

        matchColumnIndexes.clear();
        matchColumnNames.clear();
    }

    public void unsetMatchColumn(String s)
        throws SQLException
    {
        checkIfMatchColumnNamesSet();
        if(s == null || s.equals(""))
            throw new SQLException("The match column name should be non-empty");
        String s1 = null;
        try
        {
            s1 = (String)matchColumnNames.get(0);
        }
        catch(Exception exception)
        {
            throw new SQLException("No match column names were set");
        }
        if(!s1.equals(s.trim()))
        {
            throw new SQLException("The column name being unset has not been set");
        } else
        {
            matchColumnIndexes.clear();
            matchColumnNames.clear();
            return;
        }
    }

    public void unsetMatchColumn(String as[])
        throws SQLException
    {
        checkIfMatchColumnNamesSet();
        if(as == null)
            throw new SQLException("The match column parameter is null");
        Object obj = null;
        for(int i = 0; i < as.length; i++)
        {
            if(as[i] == null || as[i].equals(""))
                throw new SQLException("The match column name should be non-empty");
            String s;
            try
            {
                s = (String)matchColumnNames.get(i);
            }
            catch(Exception exception)
            {
                throw new SQLException("No match column names were set");
            }
            if(!s.equals(as[i]))
                throw new SQLException("The column name being unset has not been set");
        }

        matchColumnIndexes.clear();
        matchColumnNames.clear();
    }

    protected void checkIfMatchColumnIndexesSet()
        throws SQLException
    {
        if(matchColumnIndexes.size() == 0)
            throw new SQLException("No match column indexes were set");
        else
            return;
    }

    protected void checkIfMatchColumnNamesSet()
        throws SQLException
    {
        if(matchColumnNames.size() == 0)
            throw new SQLException("No match column names were set");
        else
            return;
    }

    public abstract int findColumn(String s)
        throws SQLException;

    public abstract ResultSetMetaData getMetaData()
        throws SQLException;

    abstract String getTableName()
        throws SQLException;

    protected String dataSource;
    protected String dataSourceName;
    protected String url;
    protected String username;
    protected String password;
    protected Map typeMap;
    protected int maxFieldSize;
    protected int maxRows;
    protected int queryTimeout;
    protected int fetchSize;
    protected int transactionIsolation;
    protected boolean escapeProcessing;
    protected String command;
    protected int concurrency;
    protected boolean readOnly;
    protected int fetchDirection;
    protected int rowsetType;
    protected boolean showDeleted;
    protected Vector listener;
    protected RowSetEvent rowsetEvent;
    protected Vector matchColumnIndexes;
    protected Vector matchColumnNames;
}
