// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleWebRowSetXmlWriterImpl.java

package oracle.jdbc.rowset;

import java.io.IOException;
import java.io.Writer;
import java.math.BigDecimal;
import java.sql.*;
import java.util.*;
import javax.sql.RowSet;
import javax.sql.RowSetInternal;
import javax.sql.rowset.WebRowSet;
import javax.sql.rowset.spi.SyncProvider;

// Referenced classes of package oracle.jdbc.rowset:
//            OracleWebRowSet, OracleWebRowSetXmlWriter

class OracleWebRowSetXmlWriterImpl
    implements OracleWebRowSetXmlWriter
{

    OracleWebRowSetXmlWriterImpl()
    {
    }

    public void writeXML(WebRowSet webrowset, Writer writer)
        throws SQLException
    {
        if(!(webrowset instanceof OracleWebRowSet))
        {
            throw new SQLException("Invalid WebRowSet argument");
        } else
        {
            xmlTagStack = new Stack();
            xmlWriter = writer;
            writeRowSet((OracleWebRowSet)webrowset);
            return;
        }
    }

    public boolean writeData(RowSetInternal rowsetinternal)
        throws SQLException
    {
        return false;
    }

    private void writeRowSet(OracleWebRowSet oraclewebrowset)
        throws SQLException
    {
        try
        {
            writeHeaderAndStartWebRowSetElement();
            writeProperties(oraclewebrowset);
            writeMetaData(oraclewebrowset);
            writeData(oraclewebrowset);
            endWebRowSetElement();
        }
        catch(IOException ioexception)
        {
            throw new SQLException("IOException: " + ioexception.getMessage());
        }
    }

    private void writeHeaderAndStartWebRowSetElement()
        throws IOException
    {
        xmlWriter.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
        xmlWriter.write("\n");
        setCurrentTag("webRowSet");
        xmlWriter.write("<webRowSet xmlns=\"http://java.sun.com/xml/ns/jdbc\"\n");
        xmlWriter.write("           xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n");
        xmlWriter.write("           xsi:schemaLocation=\"http://java.sun.com/xml/ns/jdbc ");
        xmlWriter.write("http://java.sun.com/xml/ns/jdbc/webrowset.xsd");
        xmlWriter.write("\">\n");
    }

    private void endWebRowSetElement()
        throws IOException
    {
        endTag("webRowSet");
    }

    private void startElement(String s)
        throws IOException
    {
        startTag(s);
        xmlWriter.write("\n");
    }

    private void endElement(String s)
        throws IOException
    {
        writeIndent(xmlTagStack.size());
        endTag(s);
    }

    private void endElement()
        throws IOException
    {
        writeIndent(xmlTagStack.size());
        String s = getCurrentTag();
        xmlWriter.write("</" + s + ">\n");
        xmlWriter.flush();
    }

    private void startTag(String s)
        throws IOException
    {
        setCurrentTag(s);
        writeIndent(xmlTagStack.size());
        xmlWriter.write("<" + s + ">");
    }

    private void endTag(String s)
        throws IOException
    {
        String s1 = getCurrentTag();
        if(s.equals(s1))
            xmlWriter.write("</" + s1 + ">\n");
        xmlWriter.flush();
    }

    private void setCurrentTag(String s)
    {
        xmlTagStack.push(s);
    }

    private String getCurrentTag()
    {
        return (String)xmlTagStack.pop();
    }

    private void writeEmptyElement(String s)
        throws IOException
    {
        xmlWriter.write("<" + s + "/>");
    }

    private void writeProperties(OracleWebRowSet oraclewebrowset)
        throws IOException
    {
        startElement("properties");
        try
        {
            writeElementString("command", oraclewebrowset.getCommand());
            writeElementInteger("concurrency", oraclewebrowset.getConcurrency());
            writeElementString("datasource", oraclewebrowset.getDataSourceName());
            writeElementBoolean("escape-processing", oraclewebrowset.getEscapeProcessing());
            writeElementInteger("fetch-direction", oraclewebrowset.getFetchDirection());
            writeElementInteger("fetch-size", oraclewebrowset.getFetchSize());
            writeElementInteger("isolation-level", oraclewebrowset.getTransactionIsolation());
            startElement("key-columns");
            int ai[] = oraclewebrowset.getKeyColumns();
            for(int i = 0; ai != null && i < ai.length; i++)
                writeElementInteger("column", ai[i]);

            endElement("key-columns");
            startElement("map");
            Map map = oraclewebrowset.getTypeMap();
            if(map != null)
            {
                Class class1;
                for(Iterator iterator = map.keySet().iterator(); iterator.hasNext(); writeElementString("class", class1.getName()))
                {
                    String s = (String)iterator.next();
                    class1 = (Class)map.get(s);
                    writeElementString("type", s);
                }

            }
            endElement("map");
            writeElementInteger("max-field-size", oraclewebrowset.getMaxFieldSize());
            writeElementInteger("max-rows", oraclewebrowset.getMaxRows());
            writeElementInteger("query-timeout", oraclewebrowset.getQueryTimeout());
            writeElementBoolean("read-only", oraclewebrowset.isReadOnly());
            writeElementInteger("rowset-type", oraclewebrowset.getType());
            writeElementBoolean("show-deleted", oraclewebrowset.getShowDeleted());
            writeElementString("table-name", oraclewebrowset.getTableName());
            writeElementString("url", oraclewebrowset.getUrl());
            startElement("sync-provider");
            SyncProvider syncprovider = oraclewebrowset.getSyncProvider();
            writeElementString("sync-provider-name", syncprovider.getProviderID());
            writeElementString("sync-provider-vendor", syncprovider.getVendor());
            writeElementString("sync-provider-version", syncprovider.getVersion());
            writeElementInteger("sync-provider-grade", syncprovider.getProviderGrade());
            writeElementInteger("data-source-lock", syncprovider.getDataSourceLock());
            endElement("sync-provider");
        }
        catch(SQLException sqlexception)
        {
            throw new IOException("SQLException: " + sqlexception.getMessage());
        }
        endElement("properties");
    }

    private void writeMetaData(OracleWebRowSet oraclewebrowset)
        throws IOException
    {
        startElement("metadata");
        try
        {
            ResultSetMetaData resultsetmetadata = oraclewebrowset.getMetaData();
            int i = resultsetmetadata.getColumnCount();
            writeElementInteger("column-count", i);
            for(int j = 1; j <= i; j++)
            {
                startElement("column-definition");
                writeElementInteger("column-index", j);
                writeElementBoolean("auto-increment", resultsetmetadata.isAutoIncrement(j));
                writeElementBoolean("case-sensitive", resultsetmetadata.isCaseSensitive(j));
                writeElementBoolean("currency", resultsetmetadata.isCurrency(j));
                writeElementInteger("nullable", resultsetmetadata.isNullable(j));
                writeElementBoolean("signed", resultsetmetadata.isSigned(j));
                writeElementBoolean("searchable", resultsetmetadata.isSearchable(j));
                writeElementInteger("column-display-size", resultsetmetadata.getColumnDisplaySize(j));
                writeElementString("column-label", resultsetmetadata.getColumnLabel(j));
                writeElementString("column-name", resultsetmetadata.getColumnName(j));
                writeElementString("schema-name", resultsetmetadata.getSchemaName(j));
                writeElementInteger("column-precision", resultsetmetadata.getPrecision(j));
                writeElementInteger("column-scale", resultsetmetadata.getScale(j));
                writeElementString("table-name", resultsetmetadata.getTableName(j));
                writeElementString("catalog-name", resultsetmetadata.getCatalogName(j));
                writeElementInteger("column-type", resultsetmetadata.getColumnType(j));
                writeElementString("column-type-name", resultsetmetadata.getColumnTypeName(j));
                endElement("column-definition");
            }

        }
        catch(SQLException sqlexception)
        {
            throw new IOException("SQLException: " + sqlexception.getMessage());
        }
        endElement("metadata");
    }

    private void writeElementBoolean(String s, boolean flag)
        throws IOException
    {
        startTag(s);
        writeBoolean(flag);
        endTag(s);
    }

    private void writeElementInteger(String s, int i)
        throws IOException
    {
        startTag(s);
        writeInteger(i);
        endTag(s);
    }

    private void writeElementString(String s, String s1)
        throws IOException
    {
        startTag(s);
        writeString(s1);
        endTag(s);
    }

    private void writeData(OracleWebRowSet oraclewebrowset)
        throws IOException
    {
        try
        {
            ResultSetMetaData resultsetmetadata = oraclewebrowset.getMetaData();
            int i = resultsetmetadata.getColumnCount();
            startElement("data");
            oraclewebrowset.beforeFirst();
            oraclewebrowset.setShowDeleted(true);
            for(; oraclewebrowset.next(); endElement())
            {
                if(oraclewebrowset.rowDeleted() && oraclewebrowset.rowInserted())
                    startElement("modifyRow");
                else
                if(oraclewebrowset.rowDeleted())
                    startElement("deleteRow");
                else
                if(oraclewebrowset.rowInserted())
                    startElement("insertRow");
                else
                    startElement("currentRow");
                for(int j = 1; j <= i; j++)
                    if(oraclewebrowset.columnUpdated(j))
                    {
                        ResultSet resultset = oraclewebrowset.getOriginalRow();
                        resultset.next();
                        startTag("columnValue");
                        writeValue(j, (RowSet)resultset);
                        endTag("columnValue");
                        startTag("updateValue");
                        writeValue(j, oraclewebrowset);
                        endTag("updateValue");
                    } else
                    {
                        startTag("columnValue");
                        writeValue(j, oraclewebrowset);
                        endTag("columnValue");
                    }

            }

            endElement("data");
        }
        catch(SQLException sqlexception)
        {
            throw new IOException("SQLException: " + sqlexception.getMessage());
        }
    }

    private void writeBigDecimal(BigDecimal bigdecimal)
        throws IOException
    {
        if(bigdecimal != null)
            xmlWriter.write(bigdecimal.toString());
        else
            writeEmptyElement("null");
    }

    private void writeBoolean(boolean flag)
        throws IOException
    {
        xmlWriter.write((new Boolean(flag)).toString());
    }

    private void writeDouble(double d)
        throws IOException
    {
        xmlWriter.write(Double.toString(d));
    }

    private void writeFloat(float f)
        throws IOException
    {
        xmlWriter.write(Float.toString(f));
    }

    private void writeInteger(int i)
        throws IOException
    {
        xmlWriter.write(Integer.toString(i));
    }

    private void writeLong(long l)
        throws IOException
    {
        xmlWriter.write(Long.toString(l));
    }

    private void writeNull()
        throws IOException
    {
        writeEmptyElement("null");
    }

    private void writeShort(short word0)
        throws IOException
    {
        xmlWriter.write(Short.toString(word0));
    }

    private void writeBytes(byte abyte0[])
        throws IOException
    {
        xmlWriter.write(new String(abyte0));
    }

    private void writeString(String s)
        throws IOException
    {
        if(s != null)
            xmlWriter.write(s);
        else
            xmlWriter.write("");
    }

    private void writeIndent(int i)
        throws IOException
    {
        for(int j = 1; j < i; j++)
            xmlWriter.write("  ");

    }

    private void writeValue(int i, RowSet rowset)
        throws IOException
    {
        try
        {
            int j = rowset.getMetaData().getColumnType(i);
            switch(j)
            {
            case -7: 
            case 5: // '\005'
                short word0 = rowset.getShort(i);
                if(rowset.wasNull())
                    writeNull();
                else
                    writeShort(word0);
                break;

            case 4: // '\004'
                int k = rowset.getInt(i);
                if(rowset.wasNull())
                    writeNull();
                else
                    writeInteger(k);
                break;

            case -5: 
                long l = rowset.getLong(i);
                if(rowset.wasNull())
                    writeNull();
                else
                    writeLong(l);
                break;

            case 6: // '\006'
            case 7: // '\007'
                float f = rowset.getFloat(i);
                if(rowset.wasNull())
                    writeNull();
                else
                    writeFloat(f);
                break;

            case 8: // '\b'
                double d = rowset.getDouble(i);
                if(rowset.wasNull())
                    writeNull();
                else
                    writeDouble(d);
                break;

            case 2: // '\002'
            case 3: // '\003'
                BigDecimal bigdecimal = rowset.getBigDecimal(i);
                if(rowset.wasNull())
                    writeNull();
                else
                    writeBigDecimal(bigdecimal);
                break;

            case 91: // '['
                Date date = rowset.getDate(i);
                if(rowset.wasNull())
                    writeNull();
                else
                    writeLong(date.getTime());
                break;

            case 92: // '\\'
                Time time = rowset.getTime(i);
                if(rowset.wasNull())
                    writeNull();
                else
                    writeLong(time.getTime());
                break;

            case 93: // ']'
                Timestamp timestamp = rowset.getTimestamp(i);
                if(rowset.wasNull())
                    writeNull();
                else
                    writeLong(timestamp.getTime());
                break;

            case -4: 
            case -3: 
            case -2: 
            case 2004: 
                byte abyte0[] = rowset.getBytes(i);
                if(rowset.wasNull())
                    writeNull();
                else
                    writeBytes(abyte0);
                break;

            case -1: 
            case 1: // '\001'
            case 12: // '\f'
            case 2005: 
                String s = rowset.getString(i);
                if(rowset.wasNull())
                    writeNull();
                else
                    writeString(s);
                break;

            default:
                throw new SQLException("The type " + j + " is not supported currently.");
            }
        }
        catch(SQLException sqlexception)
        {
            throw new IOException("Failed to writeValue: " + sqlexception.getMessage());
        }
    }

    private Writer xmlWriter;
    private Stack xmlTagStack;
    private static final String WEBROWSET_ELEMENT = "webRowSet";
    private static final String PROPERTIES_ELEMENT = "properties";
    private static final String METADATA_ELEMENT = "metadata";
    private static final String DATA_ELEMENT = "data";
    private static final String PROPERTY_COMMAND = "command";
    private static final String PROPERTY_CONCURRENCY = "concurrency";
    private static final String PROPERTY_DATASOURCE = "datasource";
    private static final String PROPERTY_ESCAPEPROCESSING = "escape-processing";
    private static final String PROPERTY_FETCHDIRECTION = "fetch-direction";
    private static final String PROPERTY_FETCHSIZE = "fetch-size";
    private static final String PROPERTY_ISOLATIONLEVEL = "isolation-level";
    private static final String PROPERTY_KEYCOLUMNS = "key-columns";
    private static final String PROPERTY_MAP = "map";
    private static final String PROPERTY_MAXFIELDSIZE = "max-field-size";
    private static final String PROPERTY_MAXROWS = "max-rows";
    private static final String PROPERTY_QUERYTIMEOUT = "query-timeout";
    private static final String PROPERTY_READONLY = "read-only";
    private static final String PROPERTY_ROWSETTYPE = "rowset-type";
    private static final String PROPERTY_SHOWDELETED = "show-deleted";
    private static final String PROPERTY_TABLENAME = "table-name";
    private static final String PROPERTY_URL = "url";
    private static final String PROPERTY_SYNCPROVIDER = "sync-provider";
    private static final String PROPERTY_NULL = "null";
    private static final String PROPERTY_KC_COLUMN = "column";
    private static final String PROPERTY_MAP_TYPE = "type";
    private static final String PROPERTY_MAP_CLASS = "class";
    private static final String PROPERTY_S_PROVIDERNAME = "sync-provider-name";
    private static final String PROPERTY_S_PROVIDERVENDOR = "sync-provider-vendor";
    private static final String PROPERTY_S_PROVIDERVERSION = "sync-provider-version";
    private static final String PROPERTY_S_PROVIDERGRADE = "sync-provider-grade";
    private static final String PROPERTY_S_DATASOURCELOCK = "data-source-lock";
    private static final String METADATA_COLUMNCOUNT = "column-count";
    private static final String METADATA_COLUMNDEFINITION = "column-definition";
    private static final String METADATA_COLUMNINDEX = "column-index";
    private static final String METADATA_AUTOINCREMENT = "auto-increment";
    private static final String METADATA_CASESENSITIVE = "case-sensitive";
    private static final String METADATA_CURRENCY = "currency";
    private static final String METADATA_NULLABLE = "nullable";
    private static final String METADATA_SIGNED = "signed";
    private static final String METADATA_SEARCHABLE = "searchable";
    private static final String METADATA_COLUMNDISPLAYSIZE = "column-display-size";
    private static final String METADATA_COLUMNLABEL = "column-label";
    private static final String METADATA_COLUMNNAME = "column-name";
    private static final String METADATA_SCHEMANAME = "schema-name";
    private static final String METADATA_COLUMNPRECISION = "column-precision";
    private static final String METADATA_COLUMNSCALE = "column-scale";
    private static final String METADATA_TABLENAME = "table-name";
    private static final String METADATA_CATALOGNAME = "catalog-name";
    private static final String METADATA_COLUMNTYPE = "column-type";
    private static final String METADATA_COLUMNTYPENAME = "column-type-name";
    private static final String METADATA_NULL = "null";
    private static final String DATA_CURRENTROW = "currentRow";
    private static final String DATA_INSERTROW = "insertRow";
    private static final String DATA_DELETEROW = "deleteRow";
    private static final String DATA_MODIFYROW = "modifyRow";
    private static final String DATA_COLUMNVALUE = "columnValue";
    private static final String DATA_UPDATEVALUE = "updateValue";
    private static final String DATA_NULL = "null";
}
