// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OracleXAResource.java

package oracle.jdbc.xa;

import java.sql.*;
import java.util.ArrayList;
import java.util.Vector;
import javax.transaction.xa.*;
import oracle.jdbc.internal.OracleConnection;

// Referenced classes of package oracle.jdbc.xa:
//            OracleXid, OracleXAException, OracleXAConnection

public abstract class OracleXAResource
    implements XAResource
{
    class XidListEntry
    {

        Xid xid;
        boolean isSuspended;
        XidListEntry next;

        XidListEntry(Xid xid1, boolean flag)
        {
            next = null;
            xid = xid1;
            isSuspended = flag;
        }
    }


    public OracleXAResource()
    {
        savedConnectionAutoCommit = false;
        savedXAConnectionAutoCommit = false;
        connection = null;
        xaconnection = null;
        timeout = 60;
        dblink = null;
        logicalConnection = null;
        synchronizeBeforeRecoverNewCall = "BEGIN sys.dbms_xa.dist_txn_sync \n; END;";
        synchronizeBeforeRecoverOldCall = "BEGIN sys.dbms_system.dist_txn_sync(0) \n; END;";
        recoverySqlRows = "SELECT formatid, globalid, branchid FROM SYS.DBA_PENDING_TRANSACTIONS";
        locallySuspendedTransactions = new Vector();
        canBeMigratablySuspended = false;
        xidHead = null;
        xidTail = null;
        currentXidListEntry = null;
    }

    public OracleXAResource(Connection connection1, OracleXAConnection oraclexaconnection)
        throws XAException
    {
        savedConnectionAutoCommit = false;
        savedXAConnectionAutoCommit = false;
        connection = null;
        xaconnection = null;
        timeout = 60;
        dblink = null;
        logicalConnection = null;
        synchronizeBeforeRecoverNewCall = "BEGIN sys.dbms_xa.dist_txn_sync \n; END;";
        synchronizeBeforeRecoverOldCall = "BEGIN sys.dbms_system.dist_txn_sync(0) \n; END;";
        recoverySqlRows = "SELECT formatid, globalid, branchid FROM SYS.DBA_PENDING_TRANSACTIONS";
        locallySuspendedTransactions = new Vector();
        canBeMigratablySuspended = false;
        xidHead = null;
        xidTail = null;
        currentXidListEntry = null;
        connection = connection1;
        xaconnection = oraclexaconnection;
        if(connection == null)
            throw new XAException(-7);
        else
            return;
    }

    public synchronized void setConnection(Connection connection1)
        throws XAException
    {
        connection = connection1;
        if(connection == null)
            throw new XAException(-7);
        else
            return;
    }

    final XidListEntry getMatchingXidListEntry(Xid xid)
    {
        XidListEntry xidlistentry;
        for(xidlistentry = xidHead; xidlistentry != null && !isSameXid(xidlistentry.xid, xid); xidlistentry = xidlistentry.next);
        return xidlistentry;
    }

    protected final boolean removeXidFromList(Xid xid)
    {
        if(!isXidListEmpty())
        {
            if(isSameXid(xidHead.xid, xid))
            {
                xidHead = xidHead.next;
                if(xidHead == null)
                    xidTail = xidHead;
                return true;
            }
            XidListEntry xidlistentry = xidHead.next;
            XidListEntry xidlistentry1 = xidHead;
            for(; xidlistentry != null; xidlistentry = xidlistentry.next)
            {
                if(isSameXid(xidlistentry.xid, xid))
                {
                    xidlistentry1.next = xidlistentry.next;
                    if(xidTail == xidlistentry)
                        xidTail = xidlistentry1;
                    return true;
                }
                xidlistentry1 = xidlistentry;
            }

        }
        return false;
    }

    final boolean isSameXid(Xid xid, Xid xid1)
    {
        if(xid == xid1)
            return true;
        byte abyte0[] = xid.getGlobalTransactionId();
        byte abyte1[] = xid1.getGlobalTransactionId();
        byte abyte2[] = xid.getBranchQualifier();
        byte abyte3[] = xid1.getBranchQualifier();
        if(xid.getFormatId() != xid1.getFormatId() || abyte0 == null || abyte1 == null || abyte2 == null || abyte3 == null || abyte0.length != abyte1.length || abyte2.length != abyte3.length)
            return false;
        for(int i = 0; i < abyte0.length; i++)
            if(abyte0[i] != abyte1[i])
                return false;

        for(int j = 0; j < abyte2.length; j++)
            if(abyte2[j] != abyte3[j])
                return false;

        return true;
    }

    protected final boolean isXidListEmpty()
    {
        return xidHead == null;
    }

    protected final boolean isCurrentXidSuspended(Xid xid)
    {
        return currentXidListEntry != null && isSameXid(currentXidListEntry.xid, xid) && currentXidListEntry.isSuspended;
    }

    protected void createOrUpdateXid(Xid xid, boolean flag, boolean aflag[])
    {
        XidListEntry xidlistentry = getMatchingXidListEntry(xid);
        if(xidlistentry != null)
        {
            aflag[0] = true;
            xidlistentry.isSuspended = flag;
        } else
        {
            xidlistentry = new XidListEntry(xid, flag);
            if(xidTail == null)
            {
                xidHead = xidTail = xidlistentry;
            } else
            {
                xidTail.next = xidlistentry;
                xidTail = xidlistentry;
            }
        }
        if(!flag)
            enterGlobalTxnMode();
        currentXidListEntry = xidlistentry;
    }

    protected boolean updateXidList(Xid xid, boolean aflag[])
    {
        boolean flag = false;
        XidListEntry xidlistentry = getMatchingXidListEntry(xid);
        if(xidlistentry != null)
        {
            flag = true;
            aflag[0] = true;
            aflag[1] = xidlistentry.isSuspended;
            if(xidlistentry.isSuspended)
                enterGlobalTxnMode();
            else
                exitGlobalTxnMode();
        }
        return flag;
    }

    protected Xid suspendStacked(Xid xid)
        throws XAException
    {
        Xid xid1 = null;
        if(!isXidListEmpty() && currentXidListEntry != null && !isSameXid(currentXidListEntry.xid, xid))
        {
            xid1 = xidTail.xid;
            end(xid1, 0x2000000);
        }
        return xid1;
    }

    protected Xid suspendStacked(Xid xid, int i)
        throws XAException
    {
        Xid xid1 = null;
        if(i == 0x4000000 && xidTail != null && currentXidListEntry != null && !isSameXid(currentXidListEntry.xid, xid))
        {
            allowGlobalTxnModeOnly(-3);
            xid1 = xidTail.xid;
            end(xid1, 0x2000000);
            start(xid, 0x8000000);
        }
        return xid1;
    }

    protected void resumeStacked(Xid xid)
        throws XAException
    {
        if(xid != null)
            start(xid, 0x8000000);
    }

    public abstract void start(Xid xid, int i)
        throws XAException;

    public abstract void end(Xid xid, int i)
        throws XAException;

    public abstract void commit(Xid xid, boolean flag)
        throws XAException;

    public abstract int prepare(Xid xid)
        throws XAException;

    public abstract void forget(Xid xid)
        throws XAException;

    public abstract void rollback(Xid xid)
        throws XAException;

    public Xid[] recover(int i)
        throws XAException
    {
        if((i & 0x1800000) != i)
            throw new XAException(-5);
        Statement statement = null;
        ResultSet resultset = null;
        ArrayList arraylist = new ArrayList(50);
        try
        {
            statement = connection.createStatement();
            try
            {
                statement.execute(synchronizeBeforeRecoverNewCall);
            }
            catch(Exception exception)
            {
                statement.execute(synchronizeBeforeRecoverOldCall);
            }
            for(resultset = statement.executeQuery(recoverySqlRows); resultset.next(); arraylist.add(new OracleXid(resultset.getInt(1), resultset.getBytes(2), resultset.getBytes(3))));
        }
        catch(SQLException sqlexception)
        {
            throw new XAException(-3);
        }
        finally
        {
            try
            {
                if(statement != null)
                    statement.close();
                if(resultset != null)
                    resultset.close();
            }
            catch(Exception exception2) { }
        }
        int j = arraylist.size();
        Xid axid[] = new Xid[j];
        System.arraycopy(((Object) (arraylist.toArray())), 0, axid, 0, j);
        return axid;
    }

    protected void restoreAutoCommitModeForGlobalTransaction()
        throws XAException
    {
        if(savedConnectionAutoCommit && ((OracleConnection)connection).getTxnMode() != 1)
            try
            {
                connection.setAutoCommit(savedConnectionAutoCommit);
                xaconnection.setAutoCommit(savedXAConnectionAutoCommit);
            }
            catch(SQLException sqlexception) { }
    }

    protected void saveAndAlterAutoCommitModeForGlobalTransaction()
        throws XAException
    {
        try
        {
            savedConnectionAutoCommit = connection.getAutoCommit();
            connection.setAutoCommit(false);
            savedXAConnectionAutoCommit = xaconnection.getAutoCommit();
            xaconnection.setAutoCommit(false);
        }
        catch(SQLException sqlexception) { }
    }

    public void resume(Xid xid)
        throws XAException
    {
        start(xid, 0x8000000);
    }

    public void join(Xid xid)
        throws XAException
    {
        start(xid, 0x200000);
    }

    public void suspend(Xid xid)
        throws XAException
    {
        end(xid, 0x2000000);
    }

    public void join(Xid xid, int i)
        throws XAException
    {
        timeout = i;
        start(xid, 0x200000);
    }

    public void resume(Xid xid, int i)
        throws XAException
    {
        timeout = i;
        start(xid, 0x8000000);
    }

    public Connection getConnection()
    {
        return connection;
    }

    public int getTransactionTimeout()
        throws XAException
    {
        return timeout;
    }

    public boolean isSameRM(XAResource xaresource)
        throws XAException
    {
        Connection connection1;
        connection1 = null;
        if(xaresource instanceof OracleXAResource)
            connection1 = ((OracleXAResource)xaresource).getConnection();
        else
            return false;
        if(connection == null || ((OracleConnection)connection).isClosed())
            return false;
        boolean flag;
        String s = ((OracleConnection)connection).getURL();
        String s1 = ((OracleConnection)connection).getProtocolType();
        if(connection1 == null)
            break MISSING_BLOCK_LABEL_155;
        flag = connection1.equals(connection) || ((OracleConnection)connection1).getURL().equals(s) || ((OracleConnection)connection1).getProtocolType().equals(s1) && s1.equals("kprb");
        return flag;
        SQLException sqlexception;
        sqlexception;
        throw new XAException(-3);
        return false;
    }

    public boolean setTransactionTimeout(int i)
        throws XAException
    {
        if(i < 0)
        {
            throw new XAException(-5);
        } else
        {
            timeout = i;
            return true;
        }
    }

    public String getDBLink()
    {
        return dblink;
    }

    public void setDBLink(String s)
    {
        dblink = s;
    }

    public void setLogicalConnection(Connection connection1)
    {
        logicalConnection = connection1;
    }

    protected void allowGlobalTxnModeOnly(int i)
        throws XAException
    {
        if(((OracleConnection)connection).getTxnMode() != 1)
            throw new XAException(i);
        else
            return;
    }

    protected void exitGlobalTxnMode()
    {
        ((OracleConnection)connection).setTxnMode(0);
    }

    protected void enterGlobalTxnMode()
    {
        ((OracleConnection)connection).setTxnMode(1);
    }

    protected void checkError(int i)
        throws OracleXAException
    {
        if((i & 0xffff) != 0)
            throw new OracleXAException(i);
        else
            return;
    }

    protected void checkError(int i, int j)
        throws OracleXAException
    {
        if((i & 0xffff) != 0)
            throw new OracleXAException(i, j);
        else
            return;
    }

    public static final int XA_OK = 0;
    public static final short DEFAULT_XA_TIMEOUT = 60;
    protected boolean savedConnectionAutoCommit;
    protected boolean savedXAConnectionAutoCommit;
    public static final int TMNOFLAGS = 0;
    public static final int TMNOMIGRATE = 2;
    public static final int TMENDRSCAN = 0x800000;
    public static final int TMFAIL = 0x20000000;
    public static final int TMMIGRATE = 0x100000;
    public static final int TMJOIN = 0x200000;
    public static final int TMONEPHASE = 0x40000000;
    public static final int TMRESUME = 0x8000000;
    public static final int TMSTARTRSCAN = 0x1000000;
    public static final int TMSUCCESS = 0x4000000;
    public static final int TMSUSPEND = 0x2000000;
    public static final int ORATMREADONLY = 256;
    public static final int ORATMREADWRITE = 512;
    public static final int ORATMSERIALIZABLE = 1024;
    public static final int ORAISOLATIONMASK = 65280;
    public static final int ORATRANSLOOSE = 0x10000;
    protected Connection connection;
    protected OracleXAConnection xaconnection;
    protected int timeout;
    protected String dblink;
    private Connection logicalConnection;
    private String synchronizeBeforeRecoverNewCall;
    private String synchronizeBeforeRecoverOldCall;
    private String recoverySqlRows;
    protected Vector locallySuspendedTransactions;
    protected boolean canBeMigratablySuspended;
    protected XidListEntry xidHead;
    protected XidListEntry xidTail;
    protected XidListEntry currentXidListEntry;
    private static final String _Copyright_2004_Oracle_All_Rights_Reserved_ = null;
    public static final boolean TRACE = false;
    public static final boolean PRIVATE_TRACE = false;
    public static final String BUILD_DATE = "Sat_Feb__2_11:39:41_PST_2008";

}
