// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   MutableArray.java

package oracle.jpub.runtime;

import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.Date;
import java.sql.SQLException;
import java.sql.Timestamp;
import oracle.jdbc.OracleConnection;
import oracle.jdbc.driver.OracleLog;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.sql.BFILE;
import oracle.sql.BINARY_DOUBLE;
import oracle.sql.BINARY_FLOAT;
import oracle.sql.BLOB;
import oracle.sql.CHAR;
import oracle.sql.CLOB;
import oracle.sql.CustomDatum;
import oracle.sql.CustomDatumFactory;
import oracle.sql.DATE;
import oracle.sql.Datum;
import oracle.sql.INTERVALDS;
import oracle.sql.INTERVALYM;
import oracle.sql.NUMBER;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.RAW;
import oracle.sql.TIMESTAMP;
import oracle.sql.TIMESTAMPLTZ;
import oracle.sql.TIMESTAMPTZ;

// Referenced classes of package oracle.jpub.runtime:
//            Util

public class MutableArray
{

    public MutableArray(int i, ARRAY array, ORADataFactory oradatafactory)
    {
        length = -1;
        elements = null;
        datums = null;
        pickled = array;
        pickledCorrect = true;
        sqlType = i;
        factory = oradatafactory;
    }

    public MutableArray(int i, Datum adatum[], ORADataFactory oradatafactory)
    {
        sqlType = i;
        factory = oradatafactory;
        setDatumArray(adatum);
    }

    public MutableArray(int i, Object aobj[], ORADataFactory oradatafactory)
    {
        sqlType = i;
        factory = oradatafactory;
        setObjectArray(aobj);
    }

    public MutableArray(int i, double ad[], ORADataFactory oradatafactory)
    {
        sqlType = i;
        factory = oradatafactory;
        setArray(ad);
    }

    public MutableArray(int i, int ai[], ORADataFactory oradatafactory)
    {
        sqlType = i;
        factory = oradatafactory;
        setArray(ai);
    }

    public MutableArray(int i, float af[], ORADataFactory oradatafactory)
    {
        sqlType = i;
        factory = oradatafactory;
        setArray(af);
    }

    public MutableArray(int i, short aword0[], ORADataFactory oradatafactory)
    {
        sqlType = i;
        factory = oradatafactory;
        setArray(aword0);
    }

    public MutableArray(ARRAY array, int i, CustomDatumFactory customdatumfactory)
    {
        length = -1;
        elements = null;
        datums = null;
        pickled = array;
        pickledCorrect = true;
        sqlType = i;
        old_factory = customdatumfactory;
    }

    public MutableArray(Datum adatum[], int i, CustomDatumFactory customdatumfactory)
    {
        sqlType = i;
        old_factory = customdatumfactory;
        setDatumArray(adatum);
    }

    public MutableArray(Object aobj[], int i, CustomDatumFactory customdatumfactory)
    {
        sqlType = i;
        old_factory = customdatumfactory;
        setObjectArray(aobj);
    }

    public MutableArray(double ad[], int i, CustomDatumFactory customdatumfactory)
    {
        sqlType = i;
        old_factory = customdatumfactory;
        setArray(ad);
    }

    public MutableArray(int ai[], int i, CustomDatumFactory customdatumfactory)
    {
        sqlType = i;
        old_factory = customdatumfactory;
        setArray(ai);
    }

    public MutableArray(float af[], int i, CustomDatumFactory customdatumfactory)
    {
        sqlType = i;
        old_factory = customdatumfactory;
        setArray(af);
    }

    public MutableArray(short aword0[], int i, CustomDatumFactory customdatumfactory)
    {
        sqlType = i;
        old_factory = customdatumfactory;
        setArray(aword0);
    }

    public Datum toDatum(Connection connection, String s)
        throws SQLException
    {
        if(!pickledCorrect)
        {
            pickled = new ARRAY(ArrayDescriptor.createDescriptor(s, connection), connection, getDatumArray(connection));
            pickledCorrect = true;
        }
        return pickled;
    }

    public Datum toDatum(OracleConnection oracleconnection, String s)
        throws SQLException
    {
        return toDatum(((Connection) (oracleconnection)), s);
    }

    /**
     * @deprecated Method toDatum is deprecated
     */

    public Datum toDatum(oracle.jdbc.driver.OracleConnection oracleconnection, String s)
        throws SQLException
    {
        return toDatum(((Connection) (oracleconnection)), s);
    }

    public Object[] getOracleArray()
        throws SQLException
    {
        return getOracleArray(0L, 0x7fffffff);
    }

    public Object[] getOracleArray(long l, int i)
        throws SQLException
    {
        int j = sliceLength(l, i);
        if(j < 0)
            return null;
        Object aobj[];
        switch(sqlType)
        {
        case -13: 
            aobj = new BFILE[j];
            break;

        case 2004: 
            aobj = new BLOB[j];
            break;

        case 1: // '\001'
        case 12: // '\f'
            aobj = new CHAR[j];
            break;

        case 2005: 
            aobj = new CLOB[j];
            break;

        case 91: // '['
            aobj = new DATE[j];
            break;

        case 93: // ']'
            aobj = new TIMESTAMP[j];
            break;

        case -101: 
            aobj = new TIMESTAMPTZ[j];
            break;

        case -102: 
            aobj = new TIMESTAMPLTZ[j];
            break;

        case -104: 
            aobj = new INTERVALDS[j];
            break;

        case -103: 
            aobj = new INTERVALYM[j];
            break;

        case 2: // '\002'
        case 3: // '\003'
        case 4: // '\004'
        case 5: // '\005'
        case 6: // '\006'
        case 7: // '\007'
        case 8: // '\b'
            aobj = new NUMBER[j];
            break;

        case -2: 
            aobj = new RAW[j];
            break;

        case 100: // 'd'
            aobj = new BINARY_FLOAT[j];
            break;

        case 101: // 'e'
            aobj = new BINARY_DOUBLE[j];
            break;

        case 0: // '\0'
        case 2002: 
        case 2003: 
        case 2006: 
        case 2007: 
            if(old_factory == null)
                aobj = new ORAData[j];
            else
                aobj = new CustomDatum[j];
            break;

        default:
            throw new SQLException("Unexpected OracleTypes type code: " + sqlType);
        }
        return getOracleArray(l, aobj);
    }

    public Object[] getOracleArray(long l, Object aobj[])
        throws SQLException
    {
        if(aobj == null)
            return null;
        int i = sliceLength(l, aobj.length);
        int j = (int)l;
        if(i != aobj.length)
            return null;
        if(sqlType == 2002 || sqlType == 2007 || sqlType == 2003 || sqlType == 2006 || sqlType == 0)
        {
            if(old_factory == null)
            {
                for(int k = 0; k < i; k++)
                    aobj[k] = factory.create(getDatumElement(j++, null), sqlType);

            } else
            {
                for(int i1 = 0; i1 < i; i1++)
                    aobj[i1] = old_factory.create(getDatumElement(j++, null), sqlType);

            }
        } else
        {
            for(int j1 = 0; j1 < i; j1++)
                aobj[j1] = getDatumElement(j++, null);

        }
        return aobj;
    }

    public Object[] getOracleArray(Object aobj[])
        throws SQLException
    {
        return getOracleArray(0L, aobj);
    }

    public Object[] getObjectArray()
        throws SQLException
    {
        return getObjectArray(0L, 0x7fffffff);
    }

    public Object[] getObjectArray(long l, int i)
        throws SQLException
    {
        int j = sliceLength(l, i);
        if(j < 0)
            return null;
        Object obj;
        switch(sqlType)
        {
        case 1: // '\001'
        case 12: // '\f'
            obj = new String[j];
            break;

        case 91: // '['
            obj = new Date[j];
            break;

        case 93: // ']'
            obj = new Timestamp[j];
            break;

        case 2: // '\002'
        case 3: // '\003'
            obj = new BigDecimal[j];
            break;

        case 6: // '\006'
        case 8: // '\b'
            obj = new Double[j];
            break;

        case 4: // '\004'
        case 5: // '\005'
            obj = new Integer[j];
            break;

        case 7: // '\007'
            obj = new Float[j];
            break;

        case -2: 
            obj = new byte[j][];
            break;

        default:
            return getOracleArray(l, i);
        }
        return getObjectArray(l, ((Object []) (obj)));
    }

    public Object[] getObjectArray(long l, Object aobj[])
        throws SQLException
    {
        if(aobj == null)
            return null;
        int i = sliceLength(l, aobj.length);
        int j = (int)l;
        if(i != aobj.length)
            return null;
        switch(sqlType)
        {
        case -2: 
        case 1: // '\001'
        case 2: // '\002'
        case 3: // '\003'
        case 4: // '\004'
        case 5: // '\005'
        case 6: // '\006'
        case 7: // '\007'
        case 8: // '\b'
        case 12: // '\f'
        case 91: // '['
        case 93: // ']'
            for(int k = 0; k < i; k++)
                aobj[k] = getObjectElement(j++);

            return aobj;
        }
        return getOracleArray(l, aobj);
    }

    public Object[] getObjectArray(Object aobj[])
        throws SQLException
    {
        return getObjectArray(0L, aobj);
    }

    public Object getArray()
        throws SQLException
    {
        return getArray(0L, 0x7fffffff);
    }

    public Object getArray(long l, int i)
        throws SQLException
    {
        int j = sliceLength(l, i);
        int k = (int)l;
        if(j < 0)
            return null;
        switch(sqlType)
        {
        case 6: // '\006'
        case 8: // '\b'
        case 101: // 'e'
            double ad[] = new double[j];
            for(int i1 = 0; i1 < j; i1++)
                ad[i1] = ((Double)getObjectElement(k++)).doubleValue();

            return ad;

        case 100: // 'd'
            float af[] = new float[j];
            for(int j1 = 0; j1 < j; j1++)
                af[j1] = ((Float)getObjectElement(k++)).floatValue();

            return af;

        case 4: // '\004'
            int ai[] = new int[j];
            for(int k1 = 0; k1 < j; k1++)
                ai[k1] = ((Integer)getObjectElement(k++)).intValue();

            return ai;

        case 5: // '\005'
            short aword0[] = new short[j];
            for(int l1 = 0; l1 < j; l1++)
                aword0[l1] = (short)((Integer)getObjectElement(k++)).intValue();

            return aword0;

        case 7: // '\007'
            float af1[] = new float[j];
            for(int i2 = 0; i2 < j; i2++)
                af1[i2] = ((Float)getObjectElement(k++)).floatValue();

            return af1;
        }
        return ((Object) (getObjectArray(l, i)));
    }

    public void setOracleArray(Object aobj[])
    {
        if(factory == null && old_factory == null)
            setDatumArray((Datum[])aobj);
        else
            setObjectArray(aobj);
    }

    public void setOracleArray(Object aobj[], long l)
        throws SQLException
    {
        if(factory == null && old_factory == null)
            setDatumArray((Datum[])aobj, l);
        else
            setObjectArray(aobj, l);
    }

    public void setObjectArray(Object aobj[])
    {
        if(aobj == null)
        {
            setNullArray();
        } else
        {
            setArrayGeneric(aobj.length);
            elements = new Object[length];
            for(int i = 0; i < length; i++)
                elements[i] = aobj[i];

        }
    }

    public void setObjectArray(Object aobj[], long l)
        throws SQLException
    {
        if(aobj == null)
            return;
        int i = sliceLength(l, aobj.length);
        int j = (int)l;
        for(int k = 0; k < i; k++)
            setObjectElement(aobj[k], j++);

    }

    public void setArray(double ad[])
    {
        if(ad == null)
        {
            setNullArray();
        } else
        {
            setArrayGeneric(ad.length);
            elements = new Object[length];
            for(int i = 0; i < length; i++)
                elements[i] = new Double(ad[i]);

        }
    }

    public void setArray(double ad[], long l)
        throws SQLException
    {
        if(ad == null)
            return;
        int i = sliceLength(l, ad.length);
        int j = (int)l;
        for(int k = 0; k < i; k++)
            setObjectElement(new Double(ad[k]), j++);

    }

    public void setArray(int ai[])
    {
        if(ai == null)
        {
            setNullArray();
        } else
        {
            setArrayGeneric(ai.length);
            elements = new Object[length];
            for(int i = 0; i < length; i++)
                elements[i] = new Integer(ai[i]);

        }
    }

    public void setArray(int ai[], long l)
        throws SQLException
    {
        if(ai == null)
            return;
        int i = sliceLength(l, ai.length);
        int j = (int)l;
        for(int k = 0; k < i; k++)
            setObjectElement(new Integer(ai[k]), j++);

    }

    public void setArray(float af[])
    {
        if(af == null)
        {
            setNullArray();
        } else
        {
            setArrayGeneric(af.length);
            elements = new Object[length];
            for(int i = 0; i < length; i++)
                elements[i] = new Float(af[i]);

        }
    }

    public void setArray(float af[], long l)
        throws SQLException
    {
        if(af == null)
            return;
        int i = sliceLength(l, af.length);
        int j = (int)l;
        for(int k = 0; k < i; k++)
            setObjectElement(new Float(af[k]), j++);

    }

    public void setArray(short aword0[])
    {
        if(aword0 == null)
        {
            setNullArray();
        } else
        {
            setArrayGeneric(aword0.length);
            elements = new Object[length];
            for(int i = 0; i < length; i++)
                elements[i] = new Integer(aword0[i]);

        }
    }

    public void setArray(short aword0[], long l)
        throws SQLException
    {
        if(aword0 == null)
            return;
        int i = sliceLength(l, aword0.length);
        int j = (int)l;
        for(int k = 0; k < i; k++)
            setObjectElement(new Integer(aword0[k]), j++);

    }

    public Object getObjectElement(long l)
        throws SQLException
    {
        Object obj = getLazyArray()[(int)l];
        if(obj == null)
            if(old_factory == null)
            {
                Datum datum = getLazyOracleArray()[(int)l];
                obj = Util.convertToObject(datum, sqlType, factory);
                elements[(int)l] = obj;
                if(Util.isMutable(datum, factory))
                    resetOracleElement(l);
            } else
            {
                Datum datum1 = getLazyOracleArray()[(int)l];
                obj = Util.convertToObject(datum1, sqlType, old_factory);
                elements[(int)l] = obj;
                if(Util.isMutable(datum1, old_factory))
                    resetOracleElement(l);
            }
        return obj;
    }

    public Object getOracleElement(long l)
        throws SQLException
    {
        if(factory == null && old_factory == null)
        {
            Datum datum = getDatumElement(l, null);
            if(Util.isMutable(datum, factory))
                pickledCorrect = false;
            return datum;
        } else
        {
            return getObjectElement(l);
        }
    }

    public void setObjectElement(Object obj, long l)
        throws SQLException
    {
        OracleLog.print(this, 2048, 2, 64, "MutableArray.setObjectElement( element = " + obj + ",  n = " + l + ")");
        if(obj == null)
            getLazyOracleArray();
        resetOracleElement(l);
        getLazyArray()[(int)l] = obj;
    }

    public void setOracleElement(Object obj, long l)
        throws SQLException
    {
        if(factory == null && old_factory == null)
            setDatumElement((Datum)obj, l);
        else
            setObjectElement(obj, l);
    }

    public String getBaseTypeName()
        throws SQLException
    {
        return pickled.getBaseTypeName();
    }

    public int getBaseType()
        throws SQLException
    {
        return pickled.getBaseType();
    }

    public ArrayDescriptor getDescriptor()
        throws SQLException
    {
        return pickled.getDescriptor();
    }

    Datum[] getDatumArray(Connection connection)
        throws SQLException
    {
        if(length < 0)
            getLazyOracleArray();
        if(datums == null)
            return null;
        Datum adatum[] = new Datum[length];
        for(int i = 0; i < length; i++)
            adatum[i] = getDatumElement(i, connection);

        return adatum;
    }

    void setDatumArray(Datum adatum[])
    {
        if(adatum == null)
        {
            setNullArray();
        } else
        {
            length = adatum.length;
            elements = null;
            datums = (Datum[])adatum.clone();
            pickled = null;
            pickledCorrect = false;
        }
    }

    void setDatumArray(Datum adatum[], long l)
        throws SQLException
    {
        if(adatum == null)
            return;
        int i = sliceLength(l, adatum.length);
        int j = (int)l;
        for(int k = 0; k < i; k++)
            setDatumElement(adatum[k], j++);

    }

    Datum getDatumElement(long l, Connection connection)
        throws SQLException
    {
        Datum datum = getLazyOracleArray()[(int)l];
        if(datum == null)
        {
            Object obj = getLazyArray()[(int)l];
            datum = Util.convertToOracle(obj, connection);
            datums[(int)l] = datum;
        }
        return datum;
    }

    void setDatumElement(Datum datum, long l)
        throws SQLException
    {
        resetElement(l);
        getLazyOracleArray()[(int)l] = datum;
        pickledCorrect = false;
    }

    void resetElement(long l)
        throws SQLException
    {
        if(elements != null)
            elements[(int)l] = null;
    }

    void setNullArray()
    {
        length = -1;
        elements = null;
        datums = null;
        pickled = null;
        pickledCorrect = false;
    }

    void setArrayGeneric(int i)
    {
        length = i;
        datums = new Datum[i];
        pickled = null;
        pickledCorrect = false;
    }

    public int length()
        throws SQLException
    {
        if(length < 0)
            getLazyOracleArray();
        return length;
    }

    public int sliceLength(long l, int i)
        throws SQLException
    {
        if(length < 0)
            getLazyOracleArray();
        if(l < 0L)
            return (int)l;
        else
            return Math.min(length - (int)l, i);
    }

    void resetOracleElement(long l)
        throws SQLException
    {
        if(datums != null)
            datums[(int)l] = null;
        pickledCorrect = false;
    }

    Object[] getLazyArray()
        throws SQLException
    {
        if(length == -1)
            getLazyOracleArray();
        if(elements == null)
            elements = new Object[length];
        return elements;
    }

    Datum[] getLazyOracleArray()
        throws SQLException
    {
        if(datums == null)
            if(pickled != null)
            {
                datums = (Datum[])pickled.getOracleArray();
                length = datums.length;
                pickledCorrect = true;
                if(elements != null)
                {
                    for(int i = 0; i < length; i++)
                        if(elements[i] != null)
                        {
                            datums[i] = null;
                            pickledCorrect = false;
                        }

                }
            } else
            if(length >= 0)
                datums = new Datum[length];
        return datums;
    }

    int length;
    Object elements[];
    Datum datums[];
    ARRAY pickled;
    boolean pickledCorrect;
    int sqlType;
    ORADataFactory factory;
    CustomDatumFactory old_factory;
    private static final String _Copyright_2004_Oracle_All_Rights_Reserved_ = null;
    public static final boolean TRACE = false;
    public static final boolean PRIVATE_TRACE = false;
    public static final String BUILD_DATE = "Sat_Feb__2_11:39:41_PST_2008";

}
