// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   MutableStruct.java

package oracle.jpub.runtime;

import java.sql.Connection;
import java.sql.SQLException;
import oracle.jdbc.OracleConnection;
import oracle.sql.CustomDatumFactory;
import oracle.sql.Datum;
import oracle.sql.ORADataFactory;
import oracle.sql.STRUCT;
import oracle.sql.StructDescriptor;

// Referenced classes of package oracle.jpub.runtime:
//            Util

public class MutableStruct
{

    public MutableStruct(STRUCT struct, int ai[], ORADataFactory aoradatafactory[])
    {
        length = aoradatafactory.length;
        pickled = struct;
        factories = aoradatafactory;
        sqlTypes = ai;
        pickledCorrect = true;
    }

    public MutableStruct(Object aobj[], int ai[], ORADataFactory aoradatafactory[])
    {
        length = aoradatafactory.length;
        attributes = aobj;
        factories = aoradatafactory;
        sqlTypes = ai;
        pickledCorrect = false;
    }

    public MutableStruct(STRUCT struct, int ai[], CustomDatumFactory acustomdatumfactory[])
    {
        length = acustomdatumfactory.length;
        pickled = struct;
        old_factories = acustomdatumfactory;
        sqlTypes = ai;
        pickledCorrect = true;
    }

    public MutableStruct(Object aobj[], int ai[], CustomDatumFactory acustomdatumfactory[])
    {
        length = acustomdatumfactory.length;
        attributes = aobj;
        old_factories = acustomdatumfactory;
        sqlTypes = ai;
        pickledCorrect = false;
    }

    public Datum toDatum(Connection connection, String s)
        throws SQLException
    {
        if(!pickledCorrect)
        {
            pickled = new STRUCT(StructDescriptor.createDescriptor(s, connection), connection, getDatumAttributes(connection));
            pickledCorrect = true;
        }
        return pickled;
    }

    public Datum toDatum(OracleConnection oracleconnection, String s)
        throws SQLException
    {
        return toDatum(((Connection) (oracleconnection)), s);
    }

    /**
     * @deprecated Method toDatum is deprecated
     */

    public Datum toDatum(oracle.jdbc.driver.OracleConnection oracleconnection, String s)
        throws SQLException
    {
        return toDatum(((Connection) (oracleconnection)), s);
    }

    public Object getAttribute(int i)
        throws SQLException
    {
        Object obj = getLazyAttributes()[i];
        if(obj == null)
        {
            Datum datum = getLazyDatums()[i];
            if(old_factories == null)
            {
                obj = Util.convertToObject(datum, sqlTypes[i], factories[i]);
                attributes[i] = obj;
                if(Util.isMutable(datum, factories[i]))
                    resetDatum(i);
            } else
            {
                obj = Util.convertToObject(datum, sqlTypes[i], old_factories[i]);
                attributes[i] = obj;
                if(Util.isMutable(datum, old_factories[i]))
                    resetDatum(i);
            }
        }
        return obj;
    }

    public Object getOracleAttribute(int i)
        throws SQLException
    {
        Object obj;
        if(old_factories == null)
        {
            if(factories[i] == null)
            {
                obj = getDatumAttribute(i, null);
                Datum datum = getLazyDatums()[i];
                if(Util.isMutable(datum, factories[i]))
                    pickledCorrect = false;
            } else
            {
                obj = getAttribute(i);
            }
        } else
        if(old_factories[i] == null)
        {
            obj = getDatumAttribute(i, null);
            Datum datum1 = getLazyDatums()[i];
            if(Util.isMutable(datum1, old_factories[i]))
                pickledCorrect = false;
        } else
        {
            obj = getAttribute(i);
        }
        return obj;
    }

    public Object[] getAttributes()
        throws SQLException
    {
        for(int i = 0; i < length; i++)
            getAttribute(i);

        return attributes;
    }

    public Object[] getOracleAttributes()
        throws SQLException
    {
        Object aobj[] = new Object[length];
        for(int i = 0; i < length; i++)
            aobj[i] = getOracleAttribute(i);

        return aobj;
    }

    public void setAttribute(int i, Object obj)
        throws SQLException
    {
        if(obj == null)
            getLazyDatums();
        resetDatum(i);
        getLazyAttributes()[i] = obj;
    }

    public void setDoubleAttribute(int i, double d)
        throws SQLException
    {
        setAttribute(i, new Double(d));
    }

    public void setFloatAttribute(int i, float f)
        throws SQLException
    {
        setAttribute(i, new Float(f));
    }

    public void setIntAttribute(int i, int j)
        throws SQLException
    {
        setAttribute(i, new Integer(j));
    }

    public void setOracleAttribute(int i, Object obj)
        throws SQLException
    {
        if(old_factories == null)
        {
            if(factories[i] == null)
                setDatumAttribute(i, (Datum)obj);
            else
                setAttribute(i, obj);
        } else
        if(old_factories[i] == null)
            setDatumAttribute(i, (Datum)obj);
        else
            setAttribute(i, obj);
    }

    Datum getDatumAttribute(int i, Connection connection)
        throws SQLException
    {
        Datum datum = getLazyDatums()[i];
        if(datum == null)
        {
            Object obj = getLazyAttributes()[i];
            datum = Util.convertToOracle(obj, connection);
            datums[i] = datum;
        }
        return datum;
    }

    void setDatumAttribute(int i, Datum datum)
        throws SQLException
    {
        resetAttribute(i);
        getLazyDatums()[i] = datum;
        pickledCorrect = false;
    }

    Datum[] getDatumAttributes(Connection connection)
        throws SQLException
    {
        for(int i = 0; i < length; i++)
            getDatumAttribute(i, connection);

        return (Datum[])datums.clone();
    }

    void resetAttribute(int i)
        throws SQLException
    {
        if(attributes != null)
            attributes[i] = null;
    }

    void resetDatum(int i)
        throws SQLException
    {
        if(datums != null)
            datums[i] = null;
        pickledCorrect = false;
    }

    Object[] getLazyAttributes()
    {
        if(attributes == null)
            attributes = new Object[length];
        return attributes;
    }

    Datum[] getLazyDatums()
        throws SQLException
    {
        if(datums == null)
            if(pickled != null)
            {
                datums = pickled.getOracleAttributes();
                pickledCorrect = true;
                if(attributes != null)
                {
                    for(int i = 0; i < length; i++)
                        if(attributes[i] != null)
                        {
                            datums[i] = null;
                            pickledCorrect = false;
                        }

                }
            } else
            {
                datums = new Datum[length];
            }
        return datums;
    }

    int length;
    STRUCT pickled;
    Datum datums[];
    Object attributes[];
    CustomDatumFactory old_factories[];
    ORADataFactory factories[];
    int sqlTypes[];
    boolean pickledCorrect;
    private static final String _Copyright_2004_Oracle_All_Rights_Reserved_ = null;
    public static final boolean TRACE = false;
    public static final boolean PRIVATE_TRACE = false;
    public static final String BUILD_DATE = "Sat_Feb__2_11:39:41_PST_2008";

}
