// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 

package oracle.net.nt;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.security.Principal;
import java.security.cert.X509Certificate;
import java.util.Properties;
import javax.net.ssl.*;
import oracle.net.nl.NLException;
import oracle.net.ns.NetException;

// Referenced classes of package oracle.net.nt:
//            TcpNTAdapter, CustomSSLSocketFactory, TcpsConfigure

public class TcpsNTAdapter extends TcpNTAdapter
{

    public TcpsNTAdapter(String s, Properties properties)
        throws NLException
    {
        super(s, properties);
    }

    public void connect()
        throws IOException
    {
        SSLSocketFactory sslsocketfactory = CustomSSLSocketFactory.getSSLSocketFactory(socketOptions);
        socket = sslsocketfactory.createSocket();
        InetSocketAddress inetsocketaddress = new InetSocketAddress(host, port);
        String s = (String)socketOptions.get(new Integer(2));
        try
        {
            int i = s != null ? Integer.parseInt(s) : 0;
            socket.connect(inetsocketaddress, i);
            setSSLSocketOptions();
        }
        catch(NumberFormatException numberformatexception)
        {
            throw new NetException(505);
        }
    }

    public void setSSLSocketOptions()
        throws IOException
    {
        super.setSocketOptions();
        SSLSocket sslsocket = (SSLSocket)socket;
        sslsocket.setUseClientMode(true);
        TcpsConfigure.configureVersion(sslsocket, (String)socketOptions.get(new Integer(6)));
        TcpsConfigure.configureCipherSuites(sslsocket, (String)socketOptions.get(new Integer(7)));
    }

    public void setOption(int i, Object obj)
        throws IOException, NetException
    {
        SSLSocket sslsocket = (SSLSocket)socket;
        switch(i)
        {
        case 8: // '\b'
            setServerDNMatchValue((String[])obj);
            break;

        case 7: // '\007'
            if(((String)obj).equalsIgnoreCase("TRUE"))
                fullDNMatch = true;
            else
                fullDNMatch = false;
            break;

        default:
            super.setOption(i, obj);
            break;
        }
    }

    public Object getOption(int i)
        throws IOException, NetException
    {
        SSLSocket sslsocket = (SSLSocket)socket;
        switch(i)
        {
        case 2: // '\002'
            String s = sslsocket.getSession().getCipherSuite();
            if(s != null && s.indexOf("NULL") == -1)
                return "TRUE";
            else
                return "FALSE";

        case 5: // '\005'
            return sslsocket.getSession().getCipherSuite();

        case 3: // '\003'
            X509Certificate x509certificate = (X509Certificate)sslsocket.getSession().getPeerCertificates()[0];
            return x509certificate.getSubjectDN().getName();

        case 4: // '\004'
            return sslsocket.getSession().getPeerCertificateChain();

        case 6: // '\006'
            String s1 = (String)socketOptions.get(new Integer(4));
            if(s1 == null)
                s1 = System.getProperty("oracle.net.ssl_server_dn_match", "false");
            if(s1.equalsIgnoreCase("YES") || s1.equalsIgnoreCase("ON") || s1.equalsIgnoreCase("TRUE"))
            {
                X509Certificate x509certificate1 = (X509Certificate)sslsocket.getSession().getPeerCertificates()[0];
                String s2 = x509certificate1.getSubjectDN().getName();
                if(TcpsConfigure.matchServerDN(s2, matchSSLServerCertDNWith, fullDNMatch))
                    return "TRUE";
                else
                    return "FALSE";
            } else
            {
                return "TRUE";
            }
        }
        return super.getOption(i);
    }

    public void setServerDNMatchValue(String as[])
    {
        String s = as[0];
        String s1 = as[1];
        String s2 = as[2];
        if(s != null)
        {
            matchSSLServerCertDNWith = s;
            fullDNMatch = true;
        } else
        if(s1 != null)
        {
            if(s1.indexOf('.') != -1)
                matchSSLServerCertDNWith = "CN=" + s1.substring(0, s1.indexOf('.'));
            else
                matchSSLServerCertDNWith = "CN=" + s1.trim();
        } else
        if(s2 != null)
            if(s2.indexOf('.') != -1)
                matchSSLServerCertDNWith = "CN=" + s2.substring(0, s2.indexOf('.'));
            else
                matchSSLServerCertDNWith = "CN=" + s2.trim();
    }

    String matchSSLServerCertDNWith;
    boolean fullDNMatch;
}
