// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 

package oracle.net.resolver;

import java.util.ArrayList;
import java.util.Hashtable;
import oracle.net.nl.*;
import oracle.net.ns.NetException;

// Referenced classes of package oracle.net.resolver:
//            HostnameNamingAdapter, NamingAdapterInterface, TNSNamesNamingAdapter

public class NameResolver
{

    protected NameResolver(String s)
        throws NetException
    {
        tnsAdmin = s;
        bootNameResolver();
    }

    public String resolveName(String s)
        throws NetException
    {
        if(s == null)
            throw new NetException(120);
        String s1 = s.trim();
        if(s1.length() == 0)
            throw new NetException(120);
        String s2 = null;
        if(tnsAdmin == null)
        {
            HostnameNamingAdapter hostnamenamingadapter = new HostnameNamingAdapter();
            s2 = hostnamenamingadapter.resolve(s1);
            return s2;
        }
        Object obj = null;
        for(int i = 0; s2 == null && i < readPath.length; i++)
        {
            NamingAdapterInterface namingadapterinterface = (NamingAdapterInterface)adapterHash.get(readPath[i]);
            try
            {
                s2 = namingadapterinterface.resolve(s1);
            }
            catch(NetException netexception) { }
        }

        if(s2 == null)
            throw new NetException(122, "\"" + s + "\"");
        else
            return s2;
    }

    private void addAdapters()
    {
        if(adapterHash == null)
            adapterHash = new Hashtable();
        adapterHash.put("TNSNAMES", new TNSNamesNamingAdapter(tnsAdmin));
        adapterHash.put("HOSTNAME", new HostnameNamingAdapter());
    }

    private void bootNameResolver()
        throws NetException
    {
        if(tnsAdmin != null)
        {
            setReadPath();
            addAdapters();
        }
    }

    private boolean checkForValidAdapter(String s)
    {
        int j = DEFAULT_SEARCH_PATH.length;
        for(int i = 0; i < j; i++)
            if(DEFAULT_SEARCH_PATH[i].equalsIgnoreCase(s))
                return true;

        return false;
    }

    private void setDefaultPath()
    {
        readPath = DEFAULT_SEARCH_PATH;
    }

    private void setReadPath()
        throws NetException
    {
        boolean flag = false;
        String as[] = getUserReadPath();
        if(as == null)
        {
            setDefaultPath();
            return;
        }
        ArrayList arraylist = new ArrayList();
        for(int i = 0; i < as.length; i++)
        {
            if(!checkForValidAdapter(as[i]))
                continue;
            String s = as[i];
            s = s.toUpperCase();
            if(!arraylist.contains(s))
                arraylist.add(as[i].toUpperCase());
        }

        int j = arraylist.size();
        if(j == 0)
        {
            throw new NetException(121, " The Read path did not contain any valid adapters.");
        } else
        {
            readPath = new String[j];
            arraylist.toArray(readPath);
            return;
        }
    }

    private String[] getUserReadPath()
        throws NetException
    {
        String as[] = null;
        String s = System.getProperty("oracle.net.names.directory_path");
        if(s == null)
            return null;
        s = s.trim();
        if(s.length() == 0)
            return null;
        StringBuffer stringbuffer = new StringBuffer(s);
        if(stringbuffer.charAt(0) == '(')
            stringbuffer.insert(0, "(path=").append(')');
        else
            stringbuffer.insert(0, "(path=(").append("))");
        String s1 = stringbuffer.toString();
        NVFactory nvfactory = new NVFactory();
        Object obj = null;
        try
        {
            NVPair nvpair = nvfactory.createNVPair(s1);
            if(nvpair.getRHSType() != NVPair.RHS_LIST || nvpair.getListType() != NVPair.LIST_COMMASEP)
                throw new NetException(121, " Read path specified is " + s);
            int i = nvpair.getListSize();
            String as1[] = new String[i];
            for(int j = 0; j < i; j++)
                as1[j] = nvpair.getListElement(j).getName();

            as = as1;
        }
        catch(InvalidSyntaxException invalidsyntaxexception)
        {
            throw new NetException(121, " Read path specified is " + s);
        }
        catch(NLException nlexception)
        {
            throw new NetException(121, " Read path specified is " + s1);
        }
        return as;
    }

    private String tnsAdmin;
    private String readPath[];
    private Hashtable adapterHash;
    private static final boolean DEBUG = false;
    private static final String DEFAULT_SEARCH_PATH[] = {
        "TNSNAMES", "HOSTNAME"
    };
    private static final String TNS_ADMIN_PROPERTY = "oracle.net.tns_admin";
    private static final String READ_PATH_PROPERTY = "oracle.net.names.directory_path";

}
