// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 

package oracle.net.resolver;

import java.io.File;
import java.io.IOException;
import oracle.net.nl.*;
import oracle.net.ns.NetException;

// Referenced classes of package oracle.net.resolver:
//            NamingAdapterInterface

public class TNSNamesNamingAdapter
    implements NamingAdapterInterface
{

    public TNSNamesNamingAdapter(String s)
    {
        tnsDir = s;
        resetAttr();
    }

    private void resetAttr()
    {
        tnsEntriesHdl = null;
        lastModifiedTime = 0L;
        nextPollTime = 0L;
    }

    public String resolve(String s)
        throws NetException
    {
        NVPair nvpair = null;
        synchronized(this)
        {
            checkAndReload();
            nvpair = tnsEntriesHdl.getNLPListElement(s);
        }
        if(nvpair == null)
            throw new NetException(122, "\"" + s + "\"");
        else
            return nvpair.valueToString();
    }

    private void loadFile()
        throws NetException
    {
        File file = new File(tnsDir, "tnsnames.ora");
        String s = file.getAbsolutePath();
        if(!file.isFile() || !file.canRead())
        {
            resetAttr();
            throw new NetException(123, ": " + s);
        }
        long l = file.lastModified();
        if(lastModifiedTime != l)
            try
            {
                tnsEntriesHdl = new NLParamParser(s, (byte)1);
                lastModifiedTime = l;
            }
            catch(IOException ioexception)
            {
                resetAttr();
                throw new NetException(123, ": " + s);
            }
            catch(NLException nlexception) { }
    }

    private void checkAndReload()
        throws NetException
    {
        long l = System.currentTimeMillis();
        if(l > nextPollTime)
        {
            nextPollTime = l + 0L;
            loadFile();
        }
    }

    private NLParamParser tnsEntriesHdl;
    private String tnsDir;
    private long lastModifiedTime;
    private long nextPollTime;
    private static final String TNSFILE = "tnsnames.ora";
    private static final long REFRESH_INTERVAL = 0L;
}
