// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ArrayDescriptor.java

package oracle.sql;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.Map;
import oracle.jdbc.OracleConnection;
import oracle.jdbc.OraclePreparedStatement;
import oracle.jdbc.OracleResultSet;
import oracle.jdbc.driver.DatabaseError;
import oracle.jdbc.oracore.OracleNamedType;
import oracle.jdbc.oracore.OracleType;
import oracle.jdbc.oracore.OracleTypeADT;
import oracle.jdbc.oracore.OracleTypeCOLLECTION;
import oracle.jdbc.oracore.OracleTypeFLOAT;
import oracle.jdbc.oracore.OracleTypeNUMBER;
import oracle.jdbc.oracore.OracleTypeREF;

// Referenced classes of package oracle.sql:
//            TypeDescriptor, SQLName, Datum, BFILE, 
//            BLOB, CLOB, REF, ARRAY, 
//            STRUCT, NUMBER, StructDescriptor, OpaqueDescriptor

public class ArrayDescriptor extends TypeDescriptor
    implements Serializable
{

    public static ArrayDescriptor createDescriptor(String s, Connection connection)
        throws SQLException
    {
        return createDescriptor(s, connection, false, false);
    }

    public static ArrayDescriptor createDescriptor(String s, Connection connection, boolean flag, boolean flag1)
        throws SQLException
    {
        if(s == null || s.length() == 0 || connection == null)
            DatabaseError.throwSqlException(60, "Invalid arguments");
        SQLName sqlname = new SQLName(s, (OracleConnection)connection);
        return createDescriptor(sqlname, connection);
    }

    public static ArrayDescriptor createDescriptor(SQLName sqlname, Connection connection)
        throws SQLException
    {
        return createDescriptor(sqlname, connection, false, false);
    }

    public static ArrayDescriptor createDescriptor(SQLName sqlname, Connection connection, boolean flag, boolean flag1)
        throws SQLException
    {
        String s = sqlname.getName();
        ArrayDescriptor arraydescriptor = null;
        if(!flag1)
            arraydescriptor = (ArrayDescriptor)((OracleConnection)connection).getDescriptor(s);
        if(arraydescriptor == null)
        {
            arraydescriptor = new ArrayDescriptor(sqlname, connection);
            if(flag)
                arraydescriptor.initNamesRecursively();
            ((OracleConnection)connection).putDescriptor(s, arraydescriptor);
        }
        return arraydescriptor;
    }

    public static ArrayDescriptor createDescriptor(OracleTypeCOLLECTION oracletypecollection)
        throws SQLException
    {
        String s = oracletypecollection.getFullName();
        oracle.jdbc.internal.OracleConnection oracleconnection = oracletypecollection.getConnection();
        ArrayDescriptor arraydescriptor = (ArrayDescriptor)oracleconnection.getDescriptor(s);
        if(arraydescriptor == null)
        {
            SQLName sqlname = new SQLName(oracletypecollection.getSchemaName(), oracletypecollection.getSimpleName(), oracletypecollection.getConnection());
            arraydescriptor = new ArrayDescriptor(sqlname, oracletypecollection, oracleconnection);
            oracleconnection.putDescriptor(s, arraydescriptor);
        }
        return arraydescriptor;
    }

    public ArrayDescriptor(String s, Connection connection)
        throws SQLException
    {
        super(s, connection);
        initPickler();
    }

    public ArrayDescriptor(SQLName sqlname, Connection connection)
        throws SQLException
    {
        super(sqlname, connection);
        initPickler();
    }

    public ArrayDescriptor(SQLName sqlname, OracleTypeCOLLECTION oracletypecollection, Connection connection)
        throws SQLException
    {
        super(sqlname, oracletypecollection, connection);
    }

    public ArrayDescriptor(OracleTypeCOLLECTION oracletypecollection, Connection connection)
        throws SQLException
    {
        super(oracletypecollection, connection);
    }

    static ArrayDescriptor createDescriptor(SQLName sqlname, byte abyte0[], int i, byte abyte1[], byte abyte2[], oracle.jdbc.internal.OracleConnection oracleconnection, byte abyte3[])
        throws SQLException
    {
        OracleTypeCOLLECTION oracletypecollection = new OracleTypeCOLLECTION(sqlname, abyte0, i, abyte1, abyte2, oracleconnection, abyte3);
        return new ArrayDescriptor(sqlname, oracletypecollection, oracleconnection);
    }

    public int getBaseType()
        throws SQLException
    {
        int i = ((OracleTypeCOLLECTION)pickler).getElementType().getTypeCode();
        return i;
    }

    public String getBaseName()
        throws SQLException
    {
        String s = null;
        switch(getBaseType())
        {
        case 12: // '\f'
            s = "VARCHAR";
            break;

        case 1: // '\001'
            s = "CHAR";
            break;

        case -2: 
            s = "RAW";
            break;

        case 6: // '\006'
            s = "FLOAT";
            break;

        case 2: // '\002'
            s = "NUMBER";
            break;

        case 8: // '\b'
            s = "DOUBLE";
            break;

        case 3: // '\003'
            s = "DECIMAL";
            break;

        case 91: // '['
            s = "DATE";
            break;

        case 93: // ']'
            s = "TIMESTAMP";
            break;

        case -101: 
            s = "TIMESTAMPTZ";
            break;

        case -102: 
            s = "TIMESTAMPLTZ";
            break;

        case 2004: 
            s = "BLOB";
            break;

        case 2005: 
            s = "CLOB";
            break;

        case -13: 
            s = "BFILE";
            break;

        case 2002: 
        case 2003: 
        case 2007: 
        case 2008: 
            OracleNamedType oraclenamedtype = (OracleNamedType)((OracleTypeCOLLECTION)pickler).getElementType();
            s = oraclenamedtype.getFullName();
            break;

        case 2006: 
            OracleNamedType oraclenamedtype1 = (OracleNamedType)((OracleTypeCOLLECTION)pickler).getElementType();
            s = "REF " + ((OracleTypeREF)oraclenamedtype1).getFullName();
            break;

        case 1111: 
        default:
            s = null;
            break;
        }
        return s;
    }

    public OracleTypeCOLLECTION getOracleTypeCOLLECTION()
    {
        return (OracleTypeCOLLECTION)pickler;
    }

    public int getArrayType()
        throws SQLException
    {
        int i = ((OracleTypeCOLLECTION)pickler).getUserCode();
        return i;
    }

    public long getMaxLength()
        throws SQLException
    {
        long l = getArrayType() != 3 ? 0L : ((OracleTypeCOLLECTION)pickler).getMaxLength();
        return l;
    }

    public String descType()
        throws SQLException
    {
        String s = null;
        StringBuffer stringbuffer = new StringBuffer();
        s = descType(stringbuffer, 0);
        return s;
    }

    String descType(StringBuffer stringbuffer, int i)
        throws SQLException
    {
        String s = "";
        for(int j = 0; j < i; j++)
            s = s + "  ";

        String s1 = s + "  ";
        stringbuffer.append(s);
        stringbuffer.append(getTypeName());
        stringbuffer.append("\n");
        int k = getBaseType();
        if(k == 2002 || k == 2008)
        {
            StructDescriptor structdescriptor = StructDescriptor.createDescriptor(getBaseName(), connection);
            structdescriptor.descType(stringbuffer, i + 1);
        } else
        if(k == 2003)
        {
            ArrayDescriptor arraydescriptor = createDescriptor(getBaseName(), connection);
            arraydescriptor.descType(stringbuffer, i + 1);
        } else
        if(k == 2007)
        {
            OpaqueDescriptor opaquedescriptor = OpaqueDescriptor.createDescriptor(getBaseName(), connection);
            opaquedescriptor.descType(stringbuffer, i + 1);
        } else
        {
            stringbuffer.append(s1);
            stringbuffer.append(getBaseName());
            stringbuffer.append("\n");
        }
        String s2 = stringbuffer.substring(0, stringbuffer.length());
        return s2;
    }

    int toLength(ARRAY array)
        throws SQLException
    {
        if(array.numElems == -1)
            if(array.datumArray != null)
                array.numElems = array.datumArray.length;
            else
            if(array.objArray != null)
            {
                if(array.objArray instanceof Object[])
                    array.numElems = ((Object[])array.objArray).length;
                else
                if(array.objArray instanceof int[])
                    array.numElems = ((long[])array.objArray).length;
                else
                if(array.objArray instanceof long[])
                    array.numElems = ((float[])array.objArray).length;
                else
                if(array.objArray instanceof float[])
                    array.numElems = ((double[])array.objArray).length;
                else
                if(array.objArray instanceof double[])
                    array.numElems = ((boolean[])array.objArray).length;
                else
                if(array.objArray instanceof boolean[])
                    array.numElems = ((int[])array.objArray).length;
                else
                if(array.objArray instanceof byte[])
                    array.numElems = ((byte[])array.objArray).length;
                else
                if(array.objArray instanceof short[])
                    array.numElems = ((short[])array.objArray).length;
                else
                if(array.objArray instanceof char[])
                    array.numElems = ((char[])array.objArray).length;
            } else
            if(array.locator != null)
                array.numElems = toLengthFromLocator(array.locator);
            else
            if(array.shareBytes() != null)
            {
                pickler.unlinearize(array.shareBytes(), array.imageOffset, array, 0, null);
                if(array.numElems == -1)
                    if(array.locator != null)
                        array.numElems = toLengthFromLocator(array.locator);
                    else
                        DatabaseError.throwSqlException(1, "Unable to get array length");
            } else
            {
                DatabaseError.throwSqlException(1, "Array is in inconsistent status");
            }
        int i = array.numElems;
        return i;
    }

    byte[] toBytes(ARRAY array, boolean flag)
        throws SQLException
    {
        byte abyte0[] = array.shareBytes();
        if(abyte0 == null)
        {
            if(array.datumArray != null || array.locator != null)
            {
                abyte0 = pickler.linearize(array);
                if(!flag)
                    array.setShareBytes(null);
            } else
            if(array.objArray != null)
            {
                array.datumArray = toOracleArray(array.objArray, 1L, -1);
                abyte0 = pickler.linearize(array);
                if(!flag)
                {
                    array.datumArray = null;
                    array.setShareBytes(null);
                }
            } else
            {
                DatabaseError.throwSqlException(1, "Array is in inconsistent status");
            }
        } else
        if(array.imageLength != 0L && (array.imageOffset != 0L || array.imageLength != (long)abyte0.length))
        {
            byte abyte1[] = new byte[(int)array.imageLength];
            System.arraycopy(abyte0, (int)array.imageOffset, abyte1, 0, (int)array.imageLength);
            array.setImage(abyte1, 0L, 0L);
            return abyte1;
        }
        return abyte0;
    }

    Datum[] toOracleArray(ARRAY array, long l, int i, boolean flag)
        throws SQLException
    {
        Datum adatum[] = array.datumArray;
        if(adatum == null)
        {
            if(array.objArray != null)
                adatum = toOracleArray(array.objArray, l, i);
            else
            if(array.locator != null)
                adatum = toOracleArrayFromLocator(array.locator, l, i, null);
            else
            if(array.shareBytes() != null)
            {
                pickler.unlinearize(array.shareBytes(), array.imageOffset, array, l, i, 1, null);
                if(array.locator != null)
                    adatum = toOracleArrayFromLocator(array.locator, l, i, null);
                else
                    adatum = array.datumArray;
                if(!flag)
                    array.datumArray = null;
            } else
            {
                DatabaseError.throwSqlException(1);
            }
        } else
        {
            if(l > (long)adatum.length)
                return new Datum[0];
            int j = (int)(i != -1 ? Math.min(((long)adatum.length - l) + 1L, i) : ((long)adatum.length - l) + 1L);
            adatum = new Datum[j];
            System.arraycopy(array.datumArray, (int)l - 1, adatum, 0, j);
        }
        Datum adatum1[] = null;
        if(flag)
        {
            array.datumArray = adatum;
            adatum1 = (Datum[])adatum.clone();
        } else
        {
            adatum1 = adatum;
        }
        return adatum1;
    }

    Object[] toJavaArray(ARRAY array, long l, int i, Map map, boolean flag)
        throws SQLException
    {
        Object aobj[] = null;
        if(array.objArray != null)
        {
            aobj = (Object[])((Object[])array.objArray).clone();
            int j = aobj.length;
            int k = (int)(i != -1 ? Math.min(((long)j - l) + 1L, i) : ((long)j - l) + 1L);
            if(k <= 0)
            {
                Object aobj1[] = (Object[])makeJavaArray(k, getBaseType());
                return aobj1;
            }
            aobj = (Object[])makeJavaArray(k, getBaseType());
            System.arraycopy(array.objArray, (int)l - 1, ((Object) (aobj)), 0, k);
        } else
        {
            if(array.datumArray != null)
                aobj = (Object[])toJavaArray(array.datumArray, l, i, map);
            else
            if(array.locator != null)
                aobj = toArrayFromLocator(array.locator, l, i, map);
            else
            if(array.shareBytes() != null)
            {
                pickler.unlinearize(array.shareBytes(), array.imageOffset, array, l, i, 2, map);
                if(array.locator != null)
                    aobj = toArrayFromLocator(array.locator, l, i, map);
                else
                    aobj = (Object[])array.objArray;
            } else
            {
                DatabaseError.throwSqlException(1);
            }
            if(flag && getBaseType() != 2002 && getBaseType() != 2008 && aobj != null)
                array.objArray = aobj.clone();
            else
                array.objArray = null;
        }
        return aobj;
    }

    private Datum[] toOracleArrayFromLocator(byte abyte0[], long l, int i, Map map)
        throws SQLException
    {
        int j = toLengthFromLocator(abyte0);
        int k = (int)(i != -1 ? Math.min(((long)j - l) + 1L, i) : ((long)j - l) + 1L);
        Datum adatum[] = null;
        if(k <= 0)
        {
            adatum = new Datum[0];
        } else
        {
            adatum = new Datum[k];
            ResultSet resultset = toResultSetFromLocator(abyte0, l, i, map);
            for(int i1 = 0; resultset.next(); i1++)
                adatum[i1] = ((OracleResultSet)resultset).getOracleObject(2);

            resultset.close();
        }
        return adatum;
    }

    private Object[] toArrayFromLocator(byte abyte0[], long l, int i, Map map)
        throws SQLException
    {
        int j = toLengthFromLocator(abyte0);
        int k = (int)(i != -1 ? Math.min(((long)j - l) + 1L, i) : ((long)j - l) + 1L);
        Object aobj[] = null;
        if(k <= 0)
        {
            aobj = (Object[])makeJavaArray(0, getBaseType());
        } else
        {
            aobj = (Object[])makeJavaArray(k, getBaseType());
            ResultSet resultset = toResultSetFromLocator(abyte0, l, i, map);
            for(int i1 = 0; resultset.next(); i1++)
                aobj[i1] = ((OracleResultSet)resultset).getObject(2, map);

            resultset.close();
        }
        return aobj;
    }

    public ResultSet toResultSet(ARRAY array, long l, int i, Map map, boolean flag)
        throws SQLException
    {
        ResultSet resultset = null;
        if(array.datumArray != null)
            resultset = toResultSet(array.datumArray, l, i, map);
        else
        if(array.locator != null)
            resultset = toResultSetFromLocator(array.locator, l, i, map);
        else
        if(array.objArray != null)
            resultset = toResultSet(toOracleArray(array.objArray, l, i), 1L, -1, map);
        else
        if(array.shareBytes() != null)
            if(((OracleTypeCOLLECTION)pickler).isInlineImage(array.shareBytes(), (int)array.imageOffset))
            {
                resultset = toResultSetFromImage(array, l, i, map);
            } else
            {
                pickler.unlinearize(array.shareBytes(), array.imageOffset, array, 1, null);
                if(array.locator != null)
                    resultset = toResultSetFromLocator(array.locator, l, i, map);
                else
                    DatabaseError.throwSqlException(1);
            }
        if(resultset == null)
            DatabaseError.throwSqlException(1, "Unable to create array ResultSet");
        return resultset;
    }

    public ResultSet toResultSet(Datum adatum[], long l, int i, Map map)
        throws SQLException
    {
        ResultSet resultset = null;
        if(i == -1)
            resultset = connection.newArrayDataResultSet(adatum, l, adatum.length, map);
        else
            resultset = connection.newArrayDataResultSet(adatum, l, i, map);
        return resultset;
    }

    public ResultSet toResultSetFromLocator(byte abyte0[], long l, int i, Map map)
        throws SQLException
    {
        ResultSet resultset = connection.newArrayLocatorResultSet(this, abyte0, l, i, map);
        return resultset;
    }

    public ResultSet toResultSetFromImage(ARRAY array, long l, int i, Map map)
        throws SQLException
    {
        ResultSet resultset = connection.newArrayDataResultSet(array, l, i, map);
        return resultset;
    }

    public static Object[] makeJavaArray(int i, int j)
        throws SQLException
    {
        Object obj = null;
        switch(j)
        {
        case -7: 
        case -6: 
        case -5: 
        case 2: // '\002'
        case 3: // '\003'
        case 4: // '\004'
        case 5: // '\005'
        case 6: // '\006'
        case 7: // '\007'
            obj = new BigDecimal[i];
            break;

        case 1: // '\001'
        case 12: // '\f'
            obj = new String[i];
            break;

        case -102: 
        case -101: 
        case 91: // '['
        case 92: // '\\'
        case 93: // ']'
            obj = new Timestamp[i];
            break;

        case 2002: 
        case 2008: 
            obj = ((Object) (new Object[i]));
            break;

        case -13: 
            obj = new BFILE[i];
            break;

        case 2004: 
            obj = new BLOB[i];
            break;

        case 2005: 
            obj = new CLOB[i];
            break;

        case -3: 
        case -2: 
            obj = new byte[i][];
            break;

        case 2006: 
            obj = new REF[i];
            break;

        case 2003: 
            obj = ((Object) (new Object[i]));
            break;

        default:
            DatabaseError.throwSqlException(1, "makeJavaArray doesn't support type " + j);
            break;
        }
        return ((Object []) (obj));
    }

    private int toLengthFromLocator(byte abyte0[])
        throws SQLException
    {
        ARRAY array = new ARRAY(this, connection, (byte[])null);
        array.setLocator(abyte0);
        int i = 0;
        OraclePreparedStatement oraclepreparedstatement = null;
        OracleResultSet oracleresultset = null;
        oraclepreparedstatement = (OraclePreparedStatement)connection.prepareStatement("SELECT count(*) FROM TABLE( CAST(:1 AS " + getName() + ") )");
        oraclepreparedstatement.setArray(1, array);
        oracleresultset = (OracleResultSet)oraclepreparedstatement.executeQuery();
        if(oracleresultset.next())
            i = oracleresultset.getInt(1);
        else
            DatabaseError.throwSqlException(1, "Fail to access array storage table");
        oracleresultset.close();
        oraclepreparedstatement.close();
        return i;
    }

    Datum[] toOracleArray(Object obj, long l, int i)
        throws SQLException
    {
        Datum adatum[] = null;
        if(obj != null)
        {
            OracleType oracletype = getElementType();
            adatum = oracletype.toDatumArray(obj, connection, l, i);
        }
        return adatum;
    }

    private Object toJavaArray(Datum adatum[], long l, int i, Map map)
        throws SQLException
    {
        int j = (int)(i != -1 ? Math.min(((long)adatum.length - l) + 1L, i) : ((long)adatum.length - l) + 1L);
        if(j < 0)
            j = 0;
        Object aobj[] = (Object[])makeJavaArray(j, getBaseType());
        if(getBaseType() == 2002)
        {
            Object obj = null;
            for(int k = 0; k < j; k++)
            {
                STRUCT struct = (STRUCT)adatum[((int)l + k) - 1];
                aobj[k] = struct == null ? null : struct.toJdbc(map);
            }

        } else
        {
            Object obj1 = null;
            for(int i1 = 0; i1 < j; i1++)
            {
                Datum datum = adatum[((int)l + i1) - 1];
                aobj[i1] = datum == null ? null : datum.toJdbc();
            }

        }
        return ((Object) (aobj));
    }

    private Object toNumericArray(Datum adatum[], long l, int i, int j)
        throws SQLException
    {
        double ad[] = null;
        int k = (int)(i != -1 ? Math.min(((long)adatum.length - l) + 1L, i) : ((long)adatum.length - l) + 1L);
        if(k < 0)
            k = 0;
        switch(j)
        {
        case 4: // '\004'
            int ai[] = new int[k];
            for(int i1 = 0; i1 < k; i1++)
            {
                Datum datum = adatum[((int)l + i1) - 1];
                if(datum != null)
                    ai[i1] = datum.intValue();
            }

            ad = ai;
            break;

        case 5: // '\005'
            double ad1[] = new double[k];
            for(int j1 = 0; j1 < k; j1++)
            {
                Datum datum1 = adatum[((int)l + j1) - 1];
                if(datum1 != null)
                    ad1[j1] = datum1.doubleValue();
            }

            ad = ad1;
            break;

        case 6: // '\006'
            float af[] = new float[k];
            for(int k1 = 0; k1 < k; k1++)
            {
                Datum datum2 = adatum[((int)l + k1) - 1];
                if(datum2 != null)
                    af[k1] = datum2.floatValue();
            }

            ad = af;
            break;

        case 7: // '\007'
            long al[] = new long[k];
            for(int l1 = 0; l1 < k; l1++)
            {
                Datum datum3 = adatum[((int)l + l1) - 1];
                if(datum3 != null)
                    al[l1] = datum3.longValue();
            }

            ad = al;
            break;

        case 8: // '\b'
            short aword0[] = new short[k];
            for(int i2 = 0; i2 < k; i2++)
            {
                Datum datum4 = adatum[((int)l + i2) - 1];
                if(datum4 != null)
                    aword0[i2] = ((NUMBER)datum4).shortValue();
            }

            ad = aword0;
            break;

        default:
            DatabaseError.throwSqlException(23);
            break;
        }
        return ad;
    }

    private Object toNumericArrayFromLocator(byte abyte0[], long l, int i, int j)
        throws SQLException
    {
        double ad[] = null;
        int k = toLengthFromLocator(abyte0);
        ResultSet resultset = toResultSetFromLocator(abyte0, l, i, null);
        int i1 = 0;
        switch(j)
        {
        case 4: // '\004'
            int ai[] = new int[k];
            while(resultset.next() && i1 < k) 
                ai[i1++] = ((OracleResultSet)resultset).getInt(2);
            resultset.close();
            ad = ai;
            break;

        case 5: // '\005'
            double ad1[] = new double[k];
            while(resultset.next() && i1 < k) 
                ad1[i1++] = ((OracleResultSet)resultset).getDouble(2);
            resultset.close();
            ad = ad1;
            break;

        case 6: // '\006'
            float af[] = new float[k];
            while(resultset.next() && i1 < k) 
                af[i1++] = ((OracleResultSet)resultset).getFloat(2);
            resultset.close();
            ad = af;
            break;

        case 7: // '\007'
            long al[] = new long[k];
            while(resultset.next() && i1 < k) 
                al[i1++] = ((OracleResultSet)resultset).getLong(2);
            resultset.close();
            ad = al;
            break;

        case 8: // '\b'
            short aword0[] = new short[k];
            while(resultset.next() && i1 < k) 
                aword0[i1++] = ((OracleResultSet)resultset).getShort(2);
            resultset.close();
            ad = aword0;
            break;

        default:
            DatabaseError.throwSqlException(23);
            break;
        }
        return ad;
    }

    Object toNumericArray(ARRAY array, long l, int i, int j, boolean flag)
        throws SQLException
    {
        if(!(getElementType() instanceof OracleTypeNUMBER) && !(getElementType() instanceof OracleTypeFLOAT))
            DatabaseError.throwSqlException(23);
        double ad[] = null;
        if(array.objArray != null)
        {
            if(j == 4 && (array.objArray instanceof int[]))
            {
                int k = ((int[])array.objArray).length;
                if(l > (long)k)
                    return new int[0];
                k = (int)(i != -1 ? Math.min(((long)k - l) + 1L, i) : ((long)k - l) + 1L);
                int ai[] = new int[k];
                System.arraycopy(array.objArray, (int)l - 1, ai, 0, k);
                ad = ai;
            } else
            if(j == 5 && (array.objArray instanceof double[]))
            {
                int i1 = ((double[])array.objArray).length;
                if(l > (long)i1)
                    return new double[0];
                i1 = (int)(i != -1 ? Math.min(((long)i1 - l) + 1L, i) : ((long)i1 - l) + 1L);
                double ad1[] = new double[i1];
                System.arraycopy(array.objArray, (int)l - 1, ad1, 0, i1);
                ad = ad1;
            } else
            if(j == 6 && (array.objArray instanceof float[]))
            {
                int j1 = ((float[])array.objArray).length;
                if(l > (long)j1)
                    return new float[0];
                j1 = (int)(i != -1 ? Math.min(((long)j1 - l) + 1L, i) : ((long)j1 - l) + 1L);
                float af[] = new float[j1];
                System.arraycopy(array.objArray, (int)l - 1, af, 0, j1);
                ad = af;
            } else
            if(j == 7 && (array.objArray instanceof long[]))
            {
                int k1 = ((long[])array.objArray).length;
                if(l > (long)k1)
                    return new long[0];
                k1 = (int)(i != -1 ? Math.min(((long)k1 - l) + 1L, i) : ((long)k1 - l) + 1L);
                long al[] = new long[k1];
                System.arraycopy(array.objArray, (int)l - 1, al, 0, k1);
                ad = al;
            } else
            if(j == 8 && (array.objArray instanceof short[]))
            {
                int l1 = ((short[])array.objArray).length;
                if(l > (long)l1)
                    return new short[0];
                l1 = (int)(i != -1 ? Math.min(((long)l1 - l) + 1L, i) : ((long)l1 - l) + 1L);
                short aword0[] = new short[l1];
                System.arraycopy(array.objArray, (int)l - 1, aword0, 0, l1);
                ad = aword0;
            }
        } else
        {
            if(array.datumArray != null)
                ad = ((double []) (toNumericArray(array.datumArray, l, i, j)));
            else
            if(array.locator != null)
                ad = ((double []) (toNumericArrayFromLocator(array.locator, l, i, j)));
            else
            if(array.shareBytes() != null)
            {
                pickler.unlinearize(array.shareBytes(), array.imageOffset, array, l, i, j, null);
                if(array.locator != null)
                    ad = ((double []) (toNumericArrayFromLocator(array.locator, l, i, j)));
                else
                    ad = ((double []) (array.objArray));
            } else
            {
                DatabaseError.throwSqlException(1);
            }
            if(!flag)
                array.objArray = null;
        }
        return ad;
    }

    private void initPickler()
        throws SQLException
    {
        try
        {
            OracleTypeADT oracletypeadt = new OracleTypeADT(getName(), connection);
            oracletypeadt.init(connection);
            pickler = (OracleTypeCOLLECTION)oracletypeadt.cleanup();
            pickler.setDescriptor(this);
        }
        catch(Exception exception)
        {
            if(exception instanceof SQLException)
                throw (SQLException)exception;
            DatabaseError.throwSqlException(60, "Unable to resolve type: \"" + getName() + "\"");
        }
    }

    private OracleType getElementType()
        throws SQLException
    {
        OracleType oracletype = ((OracleTypeCOLLECTION)pickler).getElementType();
        return oracletype;
    }

    public int getTypeCode()
        throws SQLException
    {
        char c = '\u07D3';
        return c;
    }

    public byte[] toBytes(Datum adatum[])
        throws SQLException
    {
        ARRAY array = new ARRAY(this, connection, adatum);
        return pickler.linearize(array);
    }

    public byte[] toBytes(Object aobj[])
        throws SQLException
    {
        Datum adatum[] = toArray(((Object) (aobj)));
        byte abyte0[] = toBytes(adatum);
        return abyte0;
    }

    public int length(byte abyte0[])
        throws SQLException
    {
        ARRAY array = new ARRAY(this, connection, abyte0);
        int i = toLength(array);
        return i;
    }

    public Datum[] toArray(byte abyte0[])
        throws SQLException
    {
        Datum adatum[] = null;
        if(abyte0 != null)
        {
            ARRAY array = new ARRAY(this, connection, abyte0);
            adatum = toOracleArray(array, 1L, -1, false);
        }
        return adatum;
    }

    public Datum[] toArray(Object obj)
        throws SQLException
    {
        Datum adatum[] = toOracleArray(obj, 1L, -1);
        return adatum;
    }

    public ResultSet toResultSet(byte abyte0[], Map map)
        throws SQLException
    {
        ResultSet resultset = null;
        if(abyte0 != null)
        {
            ARRAY array = (ARRAY)pickler.unlinearize(abyte0, 0L, null, 1, null);
            resultset = toResultSet(array, 1L, -1, map, false);
        }
        return resultset;
    }

    public ResultSet toResultSet(byte abyte0[], long l, int i, Map map)
        throws SQLException
    {
        ResultSet resultset = null;
        if(abyte0 != null)
        {
            ARRAY array = (ARRAY)pickler.unlinearize(abyte0, 0L, (ARRAY)null, 1, null);
            resultset = toResultSet(array, l, i, map, false);
        }
        return resultset;
    }

    public static int getCacheStyle(ARRAY array)
        throws SQLException
    {
        byte byte0 = 2;
        if(array.getAutoIndexing() && (array.getAccessDirection() == 2 || array.getAccessDirection() == 3))
            byte0 = 1;
        return byte0;
    }

    private void writeObject(ObjectOutputStream objectoutputstream)
        throws IOException
    {
    }

    private void readObject(ObjectInputStream objectinputstream)
        throws IOException, ClassNotFoundException
    {
    }

    public static final int TYPE_VARRAY = 3;
    public static final int TYPE_NESTED_TABLE = 2;
    public static final int CACHE_NONE = 0;
    public static final int CACHE_ALL = 1;
    public static final int CACHE_LAST = 2;
    static final long serialVersionUID = 0x3543b0856088d591L;
    private static final String _Copyright_2004_Oracle_All_Rights_Reserved_ = null;
    public static final boolean TRACE = false;
    public static final boolean PRIVATE_TRACE = false;
    public static final String BUILD_DATE = "Sat_Feb__2_11:39:31_PST_2008";

}
