// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   BLOB.java

package oracle.sql;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.Reader;
import java.sql.Blob;
import java.sql.Connection;
import java.sql.SQLException;
import oracle.jdbc.OracleConnection;
import oracle.jdbc.driver.DatabaseError;

// Referenced classes of package oracle.sql:
//            DatumWithConnection, BlobDBAccess

public class BLOB extends DatumWithConnection
    implements Blob
{

    protected BLOB()
    {
    }

    public BLOB(OracleConnection oracleconnection)
        throws SQLException
    {
        this(oracleconnection, null);
    }

    public BLOB(OracleConnection oracleconnection, byte abyte0[])
        throws SQLException
    {
        super(abyte0);
        assertNotNull(oracleconnection);
        setPhysicalConnectionOf(oracleconnection);
        dbaccess = getPhysicalConnection().createBlobDBAccess();
        dbChunkSize = -1;
    }

    public long length()
        throws SQLException
    {
        return getDBAccess().length(this);
    }

    public byte[] getBytes(long l, int i)
        throws SQLException
    {
        if(i < 0 || l < 1L)
            DatabaseError.throwSqlException(68, "getBytes()");
        byte abyte0[] = null;
        if(i == 0)
        {
            abyte0 = new byte[0];
        } else
        {
            long l1 = 0L;
            byte abyte1[] = new byte[i];
            l1 = getBytes(l, i, abyte1);
            if(l1 > 0L)
                if(l1 == (long)i)
                {
                    abyte0 = abyte1;
                } else
                {
                    abyte0 = new byte[(int)l1];
                    System.arraycopy(abyte1, 0, abyte0, 0, (int)l1);
                }
        }
        return abyte0;
    }

    public InputStream getBinaryStream()
        throws SQLException
    {
        return getDBAccess().newInputStream(this, getBufferSize(), 0L);
    }

    public long position(byte abyte0[], long l)
        throws SQLException
    {
        return getDBAccess().position(this, abyte0, l);
    }

    public long position(Blob blob, long l)
        throws SQLException
    {
        return getDBAccess().position(this, (BLOB)blob, l);
    }

    public int getBytes(long l, int i, byte abyte0[])
        throws SQLException
    {
        return getDBAccess().getBytes(this, l, i, abyte0);
    }

    /**
     * @deprecated Method putBytes is deprecated
     */

    public int putBytes(long l, byte abyte0[])
        throws SQLException
    {
        return setBytes(l, abyte0);
    }

    /**
     * @deprecated Method putBytes is deprecated
     */

    public int putBytes(long l, byte abyte0[], int i)
        throws SQLException
    {
        return setBytes(l, abyte0, 0, i);
    }

    /**
     * @deprecated Method getBinaryOutputStream is deprecated
     */

    public OutputStream getBinaryOutputStream()
        throws SQLException
    {
        return setBinaryStream(0L);
    }

    public byte[] getLocator()
    {
        return getBytes();
    }

    public void setLocator(byte abyte0[])
    {
        setBytes(abyte0);
    }

    public int getChunkSize()
        throws SQLException
    {
        if(dbChunkSize <= 0)
            dbChunkSize = getDBAccess().getChunkSize(this);
        return dbChunkSize;
    }

    public int getBufferSize()
        throws SQLException
    {
        int i = getChunkSize();
        int j = i;
        if(i >= 32768 || i <= 0)
            j = 32768;
        else
            j = (32768 / i) * i;
        return j;
    }

    /**
     * @deprecated Method empty_lob is deprecated
     */

    public static BLOB empty_lob()
        throws SQLException
    {
        return getEmptyBLOB();
    }

    public static BLOB getEmptyBLOB()
        throws SQLException
    {
        byte abyte0[] = new byte[86];
        abyte0[1] = 84;
        abyte0[5] = 24;
        BLOB blob = new BLOB();
        blob.setShareBytes(abyte0);
        return blob;
    }

    public boolean isEmptyLob()
        throws SQLException
    {
        boolean flag = (shareBytes()[5] & 0x10) != 0;
        return flag;
    }

    /**
     * @deprecated Method getBinaryOutputStream is deprecated
     */

    public OutputStream getBinaryOutputStream(long l)
        throws SQLException
    {
        return setBinaryStream(l);
    }

    public InputStream getBinaryStream(long l)
        throws SQLException
    {
        return getDBAccess().newInputStream(this, getBufferSize(), l);
    }

    /**
     * @deprecated Method trim is deprecated
     */

    public void trim(long l)
        throws SQLException
    {
        truncate(l);
    }

    public static BLOB createTemporary(Connection connection, boolean flag, int i)
        throws SQLException
    {
        int j = i;
        if(i == 1)
            j = 10;
        if(i == 2)
            j = 12;
        if(connection == null || j != 10 && j != 12)
            DatabaseError.throwSqlException(68);
        oracle.jdbc.internal.OracleConnection oracleconnection = ((OracleConnection)connection).physicalConnectionWithin();
        return getDBAccess(oracleconnection).createTemporaryBlob(oracleconnection, flag, j);
    }

    public static void freeTemporary(BLOB blob)
        throws SQLException
    {
        if(blob == null)
        {
            return;
        } else
        {
            blob.freeTemporary();
            return;
        }
    }

    public static boolean isTemporary(BLOB blob)
        throws SQLException
    {
        if(blob == null)
            return false;
        else
            return blob.isTemporary();
    }

    public void freeTemporary()
        throws SQLException
    {
        getDBAccess().freeTemporary(this);
    }

    public boolean isTemporary()
        throws SQLException
    {
        return getDBAccess().isTemporary(this);
    }

    public void open(int i)
        throws SQLException
    {
        getDBAccess().open(this, i);
    }

    public void close()
        throws SQLException
    {
        getDBAccess().close(this);
    }

    public boolean isOpen()
        throws SQLException
    {
        return getDBAccess().isOpen(this);
    }

    public int setBytes(long l, byte abyte0[])
        throws SQLException
    {
        return getDBAccess().putBytes(this, l, abyte0, 0, abyte0 == null ? 0 : abyte0.length);
    }

    public int setBytes(long l, byte abyte0[], int i, int j)
        throws SQLException
    {
        return getDBAccess().putBytes(this, l, abyte0, i, j);
    }

    public OutputStream setBinaryStream(long l)
        throws SQLException
    {
        return getDBAccess().newOutputStream(this, getBufferSize(), l);
    }

    public void truncate(long l)
        throws SQLException
    {
        if(l < 0L)
            DatabaseError.throwSqlException(68);
        getDBAccess().trim(this, l);
    }

    public Object toJdbc()
        throws SQLException
    {
        return this;
    }

    public boolean isConvertibleTo(Class class1)
    {
        String s = class1.getName();
        return s.compareTo("java.io.InputStream") == 0 || s.compareTo("java.io.Reader") == 0;
    }

    public Reader characterStreamValue()
        throws SQLException
    {
        getInternalConnection();
        return getDBAccess().newConversionReader(this, 8);
    }

    public InputStream asciiStreamValue()
        throws SQLException
    {
        getInternalConnection();
        return getDBAccess().newConversionInputStream(this, 2);
    }

    public InputStream binaryStreamValue()
        throws SQLException
    {
        return getBinaryStream();
    }

    public Object makeJdbcArray(int i)
    {
        return new BLOB[i];
    }

    public BlobDBAccess getDBAccess()
        throws SQLException
    {
        if(dbaccess == null)
        {
            if(isEmptyLob())
                DatabaseError.throwSqlException(98);
            dbaccess = getInternalConnection().createBlobDBAccess();
        }
        if(getPhysicalConnection().isClosed())
            DatabaseError.throwSqlException(8);
        return dbaccess;
    }

    public static BlobDBAccess getDBAccess(Connection connection)
        throws SQLException
    {
        return ((OracleConnection)connection).physicalConnectionWithin().createBlobDBAccess();
    }

    public Connection getJavaSqlConnection()
        throws SQLException
    {
        return super.getJavaSqlConnection();
    }

    public static final int MAX_CHUNK_SIZE = 32768;
    public static final int DURATION_SESSION = 10;
    public static final int DURATION_CALL = 12;
    static final int OLD_WRONG_DURATION_SESSION = 1;
    static final int OLD_WRONG_DURATION_CALL = 2;
    public static final int MODE_READONLY = 0;
    public static final int MODE_READWRITE = 1;
    BlobDBAccess dbaccess;
    int dbChunkSize;
    private static final String _Copyright_2004_Oracle_All_Rights_Reserved_ = null;
    public static final boolean TRACE = false;
    public static final boolean PRIVATE_TRACE = false;
    public static final String BUILD_DATE = "Sat_Feb__2_11:39:32_PST_2008";

}
