// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   OpaqueDescriptor.java

package oracle.sql;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.Map;
import oracle.jdbc.OracleConnection;
import oracle.jdbc.driver.DatabaseError;
import oracle.jdbc.oracore.OracleNamedType;
import oracle.jdbc.oracore.OracleTypeADT;
import oracle.jdbc.oracore.OracleTypeOPAQUE;

// Referenced classes of package oracle.sql:
//            TypeDescriptor, SQLName, OPAQUE

public class OpaqueDescriptor extends TypeDescriptor
    implements Serializable
{

    public static OpaqueDescriptor createDescriptor(String s, Connection connection)
        throws SQLException
    {
        if(s == null || s.length() == 0 || connection == null)
            DatabaseError.throwSqlException(60, "Invalid arguments");
        SQLName sqlname = new SQLName(s, (OracleConnection)connection);
        return createDescriptor(sqlname, connection);
    }

    public static OpaqueDescriptor createDescriptor(SQLName sqlname, Connection connection)
        throws SQLException
    {
        String s = sqlname.getName();
        OpaqueDescriptor opaquedescriptor = (OpaqueDescriptor)((OracleConnection)connection).getDescriptor(s);
        if(opaquedescriptor == null)
        {
            opaquedescriptor = new OpaqueDescriptor(sqlname, connection);
            ((OracleConnection)connection).putDescriptor(s, opaquedescriptor);
        }
        return opaquedescriptor;
    }

    public OpaqueDescriptor(String s, Connection connection)
        throws SQLException
    {
        super(s, connection);
        initPickler();
    }

    public OpaqueDescriptor(SQLName sqlname, Connection connection)
        throws SQLException
    {
        super(sqlname, connection);
        initPickler();
    }

    public OpaqueDescriptor(SQLName sqlname, OracleTypeOPAQUE oracletypeopaque, Connection connection)
        throws SQLException
    {
        super(sqlname, oracletypeopaque, connection);
    }

    private void initPickler()
        throws SQLException
    {
        try
        {
            pickler = new OracleTypeADT(getName(), connection);
            ((OracleTypeADT)pickler).init(connection);
            pickler = (OracleTypeOPAQUE)((OracleTypeADT)pickler).cleanup();
            pickler.setDescriptor(this);
        }
        catch(Exception exception)
        {
            if(exception instanceof SQLException)
                throw (SQLException)exception;
            DatabaseError.throwSqlException(60, "Unable to resolve type \"" + getName() + "\"");
        }
    }

    public OpaqueDescriptor(OracleTypeADT oracletypeadt, Connection connection)
        throws SQLException
    {
        super(oracletypeadt, connection);
    }

    byte[] toBytes(OPAQUE opaque, boolean flag)
        throws SQLException
    {
        byte abyte0[];
        abyte0 = null;
        if(opaque.shareBytes() != null)
        {
            abyte0 = opaque.shareBytes();
            break MISSING_BLOCK_LABEL_52;
        }
        abyte0 = pickler.linearize(opaque);
        if(!flag)
            opaque.setShareBytes(null);
        break MISSING_BLOCK_LABEL_52;
        Exception exception;
        exception;
        if(!flag)
            opaque.setShareBytes(null);
        throw exception;
        return abyte0;
    }

    byte[] toValue(OPAQUE opaque, boolean flag)
        throws SQLException
    {
        byte abyte0[];
        abyte0 = null;
        if(opaque.value != null)
        {
            abyte0 = opaque.value;
            break MISSING_BLOCK_LABEL_64;
        }
        pickler.unlinearize(opaque.shareBytes(), 0L, opaque, 1, null);
        abyte0 = opaque.value;
        if(!flag)
            opaque.value = null;
        break MISSING_BLOCK_LABEL_64;
        Exception exception;
        exception;
        if(!flag)
            opaque.value = null;
        throw exception;
        return abyte0;
    }

    public int getTypeCode()
    {
        return 2007;
    }

    public long getMaxLength()
        throws SQLException
    {
        long l = hasUnboundedSize() ? 0L : ((OracleTypeOPAQUE)pickler).getMaxLength();
        return l;
    }

    public boolean isTrustedLibrary()
        throws SQLException
    {
        return ((OracleTypeOPAQUE)pickler).isTrustedLibrary();
    }

    public boolean isModeledInC()
        throws SQLException
    {
        return ((OracleTypeOPAQUE)pickler).isModeledInC();
    }

    public boolean hasUnboundedSize()
        throws SQLException
    {
        return ((OracleTypeOPAQUE)pickler).isUnboundedSized();
    }

    public boolean hasFixedSize()
        throws SQLException
    {
        return ((OracleTypeOPAQUE)pickler).isFixedSized();
    }

    public String descType()
        throws SQLException
    {
        StringBuffer stringbuffer = new StringBuffer();
        String s = descType(stringbuffer, 0);
        return s;
    }

    String descType(StringBuffer stringbuffer, int i)
        throws SQLException
    {
        String s = "";
        for(int j = 0; j < i; j++)
            s = s + "  ";

        String s1 = s + "  ";
        stringbuffer.append(s);
        stringbuffer.append(getTypeName());
        stringbuffer.append(" maxLen=" + getMaxLength() + " isTrusted=" + isTrustedLibrary() + " hasUnboundedSize=" + hasUnboundedSize() + " hasFixedSize=" + hasFixedSize());
        stringbuffer.append("\n");
        String s2 = stringbuffer.toString();
        return s2;
    }

    public Class getClass(Map map)
        throws SQLException
    {
        Class class1 = null;
        String s = getName();
        Class class2 = (Class)map.get(s);
        String s1 = getSchemaName();
        String s2 = getTypeName();
        if(class2 == null && connection.getDefaultSchemaNameForNamedTypes().equals(s1))
            class2 = (Class)map.get(s2);
        if(!SQLName.s_parseAllFormat)
        {
            class1 = class2;
        } else
        {
            if(class2 == null && connection.getDefaultSchemaNameForNamedTypes().equals(s1))
                class2 = (Class)map.get("\"" + s2 + "\"");
            if(class2 == null)
                class2 = (Class)map.get("\"" + s1 + "\"" + "." + "\"" + s2 + "\"");
            if(class2 == null)
                class2 = (Class)map.get("\"" + s1 + "\"" + "." + s2);
            if(class2 == null)
                class2 = (Class)map.get(s1 + "." + "\"" + s2 + "\"");
            class1 = class2;
        }
        return class1;
    }

    private void writeObject(ObjectOutputStream objectoutputstream)
        throws IOException
    {
    }

    private void readObject(ObjectInputStream objectinputstream)
        throws IOException, ClassNotFoundException
    {
    }

    static final boolean DEBUG = false;
    static final long serialVersionUID = 0xe122c1707c9af97L;
    private static final String _Copyright_2004_Oracle_All_Rights_Reserved_ = null;
    public static final boolean TRACE = false;
    public static final boolean PRIVATE_TRACE = false;
    public static final String BUILD_DATE = "Sat_Feb__2_11:39:33_PST_2008";

}
