// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   StructDescriptor.java

package oracle.sql;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.SQLInput;
import java.sql.SQLOutput;
import java.util.Map;
import java.util.Vector;
import oracle.jdbc.OracleCallableStatement;
import oracle.jdbc.OracleConnection;
import oracle.jdbc.driver.DatabaseError;
import oracle.jdbc.oracore.OracleNamedType;
import oracle.jdbc.oracore.OracleType;
import oracle.jdbc.oracore.OracleTypeADT;

// Referenced classes of package oracle.sql:
//            TypeDescriptor, SQLName, STRUCT, OracleJdbc2SQLInput, 
//            OracleSQLOutput, Datum, ArrayDescriptor, OpaqueDescriptor

public class StructDescriptor extends TypeDescriptor
    implements Serializable
{

    public static StructDescriptor createDescriptor(String s, Connection connection)
        throws SQLException
    {
        return createDescriptor(s, connection, false, false);
    }

    public static StructDescriptor createDescriptor(String s, Connection connection, boolean flag, boolean flag1)
        throws SQLException
    {
        if(s == null || s.length() == 0 || connection == null)
            DatabaseError.throwSqlException(60, "Invalid arguments");
        SQLName sqlname = new SQLName(s, (OracleConnection)connection);
        return createDescriptor(sqlname, connection, flag, flag1);
    }

    public static StructDescriptor createDescriptor(SQLName sqlname, Connection connection, boolean flag, boolean flag1)
        throws SQLException
    {
        String s = sqlname.getName();
        StructDescriptor structdescriptor = null;
        if(!flag1)
        {
            structdescriptor = (StructDescriptor)((OracleConnection)connection).getDescriptor(s);
            if(structdescriptor == null)
            {
                structdescriptor = new StructDescriptor(sqlname, connection);
                if(flag)
                    structdescriptor.initNamesRecursively();
                ((OracleConnection)connection).putDescriptor(s, structdescriptor);
            }
        }
        return structdescriptor;
    }

    public static StructDescriptor createDescriptor(SQLName sqlname, Connection connection)
        throws SQLException
    {
        return createDescriptor(sqlname, connection, false, false);
    }

    public static StructDescriptor createDescriptor(OracleTypeADT oracletypeadt)
        throws SQLException
    {
        String s = oracletypeadt.getFullName();
        oracle.jdbc.internal.OracleConnection oracleconnection = oracletypeadt.getConnection();
        StructDescriptor structdescriptor = (StructDescriptor)oracleconnection.getDescriptor(s);
        if(structdescriptor == null)
        {
            SQLName sqlname = new SQLName(oracletypeadt.getSchemaName(), oracletypeadt.getSimpleName(), oracletypeadt.getConnection());
            structdescriptor = new StructDescriptor(sqlname, oracletypeadt, oracleconnection);
            structdescriptor.initNamesRecursively();
            oracleconnection.putDescriptor(s, structdescriptor);
        }
        return structdescriptor;
    }

    public StructDescriptor(String s, Connection connection)
        throws SQLException
    {
        super(s, connection);
        isInstanciable = null;
        supertype = null;
        numLocalAttrs = -1;
        subtypes = null;
        attrJavaNames = null;
        initPickler();
    }

    public StructDescriptor(SQLName sqlname, Connection connection)
        throws SQLException
    {
        super(sqlname, connection);
        isInstanciable = null;
        supertype = null;
        numLocalAttrs = -1;
        subtypes = null;
        attrJavaNames = null;
        initPickler();
    }

    public StructDescriptor(SQLName sqlname, OracleTypeADT oracletypeadt, Connection connection)
        throws SQLException
    {
        super(sqlname, oracletypeadt, connection);
        isInstanciable = null;
        supertype = null;
        numLocalAttrs = -1;
        subtypes = null;
        attrJavaNames = null;
    }

    static StructDescriptor createDescriptor(SQLName sqlname, byte abyte0[], int i, byte abyte1[], byte abyte2[], oracle.jdbc.internal.OracleConnection oracleconnection, byte abyte3[])
        throws SQLException
    {
        OracleTypeADT oracletypeadt = new OracleTypeADT(sqlname, abyte0, i, abyte1, abyte2, oracleconnection, abyte3);
        return new StructDescriptor(sqlname, oracletypeadt, oracleconnection);
    }

    private void initPickler()
        throws SQLException
    {
        try
        {
            pickler = new OracleTypeADT(getName(), connection);
            ((OracleTypeADT)pickler).init(connection);
            pickler.setDescriptor(this);
        }
        catch(Exception exception)
        {
            if(exception instanceof SQLException)
                throw (SQLException)exception;
            DatabaseError.throwSqlException(60, "Unable to resolve type \"" + getName() + "\"");
        }
    }

    public StructDescriptor(OracleTypeADT oracletypeadt, Connection connection)
        throws SQLException
    {
        super(oracletypeadt, connection);
        isInstanciable = null;
        supertype = null;
        numLocalAttrs = -1;
        subtypes = null;
        attrJavaNames = null;
    }

    public int getTypeCode()
        throws SQLException
    {
        int i = pickler.getTypeCode();
        return i;
    }

    public int getTypeVersion()
        throws SQLException
    {
        int i = pickler.getTypeVersion();
        return i;
    }

    byte[] toBytes(STRUCT struct, boolean flag)
        throws SQLException
    {
        byte abyte0[] = struct.shareBytes();
        if(abyte0 == null)
        {
            if(struct.datumArray != null)
            {
                abyte0 = pickler.linearize(struct);
                if(!flag)
                    struct.setShareBytes(null);
            } else
            if(struct.objectArray != null)
            {
                struct.datumArray = toOracleArray(struct.objectArray);
                abyte0 = pickler.linearize(struct);
                if(!flag)
                {
                    struct.datumArray = null;
                    struct.setShareBytes(null);
                }
            } else
            {
                DatabaseError.throwSqlException(1);
            }
        } else
        if(struct.imageLength != 0L && (struct.imageOffset != 0L || struct.imageLength != (long)abyte0.length))
        {
            byte abyte1[] = new byte[(int)struct.imageLength];
            System.arraycopy(abyte0, (int)struct.imageOffset, abyte1, 0, (int)struct.imageLength);
            struct.setImage(abyte1, 0L, 0L);
            abyte0 = abyte1;
        }
        return abyte0;
    }

    Datum[] toOracleArray(STRUCT struct, boolean flag)
        throws SQLException
    {
        Datum adatum[] = struct.datumArray;
        Datum adatum1[] = null;
        if(adatum == null)
            if(struct.objectArray != null)
                adatum = toOracleArray(struct.objectArray);
            else
            if(struct.shareBytes() != null)
            {
                if((struct.shareBytes()[0] & 0x80) <= 0 && ((OracleTypeADT)pickler).isEmbeddedADT())
                    pickler = OracleTypeADT.shallowClone((OracleTypeADT)pickler);
                pickler.unlinearize(struct.shareBytes(), struct.imageOffset, struct, 1, null);
                adatum = struct.datumArray;
                if(!flag)
                    struct.datumArray = null;
            } else
            {
                DatabaseError.throwSqlException(1);
            }
        if(flag)
        {
            struct.datumArray = adatum;
            adatum1 = (Datum[])adatum.clone();
        } else
        {
            adatum1 = adatum;
        }
        return adatum1;
    }

    Object[] toArray(STRUCT struct, Map map, boolean flag)
        throws SQLException
    {
        Object aobj[] = null;
        if(struct.objectArray == null)
        {
            if(struct.datumArray != null)
            {
                aobj = new Object[struct.datumArray.length];
                for(int i = 0; i < struct.datumArray.length; i++)
                    if(struct.datumArray[i] != null)
                        if(struct.datumArray[i] instanceof STRUCT)
                            aobj[i] = ((STRUCT)struct.datumArray[i]).toJdbc(map);
                        else
                            aobj[i] = struct.datumArray[i].toJdbc();

            } else
            if(struct.shareBytes() != null)
            {
                if((struct.shareBytes()[0] & 0x80) <= 0 && ((OracleTypeADT)pickler).isEmbeddedADT())
                    pickler = OracleTypeADT.shallowClone((OracleTypeADT)pickler);
                pickler.unlinearize(struct.shareBytes(), struct.imageOffset, struct, 2, map);
                aobj = struct.objectArray;
                struct.objectArray = null;
            } else
            {
                DatabaseError.throwSqlException(1);
            }
        } else
        {
            aobj = (Object[])struct.objectArray.clone();
        }
        return aobj;
    }

    public int getLength()
        throws SQLException
    {
        int i = getFieldTypes().length;
        return i;
    }

    public OracleTypeADT getOracleTypeADT()
    {
        OracleTypeADT oracletypeadt = (OracleTypeADT)pickler;
        return oracletypeadt;
    }

    private OracleType[] getFieldTypes()
        throws SQLException
    {
        OracleType aoracletype[] = ((OracleTypeADT)pickler).getAttrTypes();
        return aoracletype;
    }

    public SQLInput toJdbc2SQLInput(STRUCT struct, Map map)
        throws SQLException
    {
        OracleJdbc2SQLInput oraclejdbc2sqlinput = new OracleJdbc2SQLInput(toOracleArray(struct, false), map, connection);
        return oraclejdbc2sqlinput;
    }

    public SQLOutput toJdbc2SQLOutput()
        throws SQLException
    {
        OracleSQLOutput oraclesqloutput = new OracleSQLOutput(this, connection);
        return oraclesqloutput;
    }

    public Datum[] toOracleArray(Object aobj[])
        throws SQLException
    {
        Datum adatum[] = null;
        if(aobj != null)
        {
            OracleType aoracletype[] = getFieldTypes();
            int i = aoracletype.length;
            if(aobj.length != i)
                DatabaseError.throwSqlException(49, null);
            adatum = new Datum[i];
            oracle.jdbc.internal.OracleConnection oracleconnection = connection;
            for(int j = 0; j < i; j++)
                adatum[j] = aoracletype[j].toDatum(aobj[j], oracleconnection);

        }
        return adatum;
    }

    public Datum[] toOracleArray(Map map)
        throws SQLException
    {
        Datum adatum[] = null;
        int i = 0;
        if(map != null)
        {
            OracleType aoracletype[] = getFieldTypes();
            int j = aoracletype.length;
            int k = map.size();
            adatum = new Datum[j];
            oracle.jdbc.internal.OracleConnection oracleconnection = connection;
            for(int l = 0; l < j; l++)
            {
                Object obj = map.get(((OracleTypeADT)pickler).getAttributeName(l + 1));
                adatum[l] = aoracletype[l].toDatum(obj, oracleconnection);
                if(obj != null || map.containsKey(((OracleTypeADT)pickler).getAttributeName(l + 1)))
                    i++;
            }

            if(i < k)
                DatabaseError.throwSqlException(68, null);
        }
        return adatum;
    }

    public ResultSetMetaData getMetaData()
        throws SQLException
    {
        ResultSetMetaData resultsetmetadata = connection.newStructMetaData(this);
        return resultsetmetadata;
    }

    public boolean isFinalType()
        throws SQLException
    {
        boolean flag = getOracleTypeADT().isFinalType();
        return flag;
    }

    public boolean isSubtype()
        throws SQLException
    {
        boolean flag = getOracleTypeADT().isSubType();
        return flag;
    }

    public boolean isInHierarchyOf(String s)
        throws SQLException
    {
        StructDescriptor structdescriptor = this;
        String s1 = structdescriptor.getName();
        boolean flag = false;
        if(s.equals(s1))
            flag = true;
        else
            do
            {
                String s2 = structdescriptor.getSupertypeName();
                if(s2 == null)
                {
                    flag = false;
                    break;
                }
                if(s.equals(s2))
                {
                    flag = true;
                    break;
                }
                structdescriptor = createDescriptor(s2, connection);
            } while(true);
        return flag;
    }

    public boolean isInstantiable()
        throws SQLException
    {
        if(isInstanciable == null)
            initMetaData1();
        boolean flag = isInstanciable.booleanValue();
        return flag;
    }

    public boolean isJavaObject()
        throws SQLException
    {
        boolean flag = getOracleTypeADT().isJavaObject();
        return flag;
    }

    public String getSupertypeName()
        throws SQLException
    {
        String s = null;
        if(isSubtype())
        {
            if(supertype == null)
                initMetaData1();
            s = supertype;
        }
        return s;
    }

    public int getLocalAttributeCount()
        throws SQLException
    {
        int i;
        if(!isSubtype())
        {
            i = getOracleTypeADT().getAttrTypes().length;
        } else
        {
            if(numLocalAttrs == -1)
                initMetaData1();
            i = numLocalAttrs;
        }
        return i;
    }

    public String[] getSubtypeNames()
        throws SQLException
    {
        if(subtypes == null)
            initMetaData2();
        return subtypes;
    }

    public String getJavaClassName()
        throws SQLException
    {
        String s = null;
        if(isJavaObject())
            s = getJavaObjectClassName(connection, this);
        return s;
    }

    public String getAttributeJavaName(int i)
        throws SQLException
    {
        String s = null;
        if(isJavaObject())
        {
            if(attrJavaNames == null)
                initMetaData3();
            s = attrJavaNames[i];
        }
        return s;
    }

    public String[] getAttributeJavaNames()
        throws SQLException
    {
        String as[] = null;
        if(isJavaObject())
        {
            if(attrJavaNames == null)
                initMetaData3();
            as = attrJavaNames;
        } else
        {
            as = new String[0];
        }
        return as;
    }

    public String getLanguage()
        throws SQLException
    {
        String s = null;
        if(isJavaObject())
            s = "JAVA";
        else
            s = "SQL";
        return s;
    }

    public Class getClass(Map map)
        throws SQLException
    {
        String s = getName();
        Class class1 = (Class)map.get(s);
        String s1 = getSchemaName();
        String s2 = getTypeName();
        if(class1 == null)
            class1 = (Class)map.get(s2);
        if(SQLName.s_parseAllFormat)
        {
            if(class1 == null && connection.getDefaultSchemaNameForNamedTypes().equals(s1))
                class1 = (Class)map.get("\"" + s2 + "\"");
            if(class1 == null)
                class1 = (Class)map.get("\"" + s1 + "\"" + "." + "\"" + s2 + "\"");
            if(class1 == null)
                class1 = (Class)map.get("\"" + s1 + "\"" + "." + s2);
            if(class1 == null)
                class1 = (Class)map.get(s1 + "." + "\"" + s2 + "\"");
        }
        return class1;
    }

    public static String getJavaObjectClassName(Connection connection, StructDescriptor structdescriptor)
        throws SQLException
    {
        String s = getJavaObjectClassName(connection, structdescriptor.getSchemaName(), structdescriptor.getTypeName());
        return s;
    }

    public static String getJavaObjectClassName(Connection connection, String s, String s1)
        throws SQLException
    {
        PreparedStatement preparedstatement = null;
        ResultSet resultset = null;
        String s2 = null;
        try
        {
            preparedstatement = connection.prepareStatement("select external_name from all_sqlj_types where owner = :1 and type_name = :2");
            preparedstatement.setString(1, s);
            preparedstatement.setString(2, s1);
            resultset = preparedstatement.executeQuery();
            if(resultset.next())
                s2 = resultset.getString(1);
            else
                DatabaseError.throwSqlException(100);
        }
        catch(SQLException sqlexception) { }
        finally
        {
            if(resultset != null)
                resultset.close();
            if(preparedstatement != null)
                preparedstatement.close();
        }
        return s2;
    }

    public String descType()
        throws SQLException
    {
        StringBuffer stringbuffer = new StringBuffer();
        return descType(stringbuffer, 0);
    }

    String descType(StringBuffer stringbuffer, int i)
        throws SQLException
    {
        String s = "";
        for(int j = 0; j < i; j++)
            s = s + "  ";

        String s1 = s + "  ";
        stringbuffer.append(s);
        stringbuffer.append(getTypeName());
        stringbuffer.append("\n");
        stringbuffer.append(s);
        stringbuffer.append("Subtype=" + getOracleTypeADT().isSubType());
        stringbuffer.append(" JavaObject=" + getOracleTypeADT().isJavaObject());
        stringbuffer.append(" FinalType=" + getOracleTypeADT().isFinalType());
        stringbuffer.append("\n");
        ResultSetMetaData resultsetmetadata = getMetaData();
        int k = resultsetmetadata.getColumnCount();
        for(int l = 0; l < k; l++)
        {
            int i1 = resultsetmetadata.getColumnType(l + 1);
            if(i1 == 2002 || i1 == 2008)
            {
                StructDescriptor structdescriptor = createDescriptor(resultsetmetadata.getColumnTypeName(l + 1), connection);
                structdescriptor.descType(stringbuffer, i + 1);
                continue;
            }
            if(i1 == 2003)
            {
                ArrayDescriptor arraydescriptor = ArrayDescriptor.createDescriptor(resultsetmetadata.getColumnTypeName(l + 1), connection);
                arraydescriptor.descType(stringbuffer, i + 1);
                continue;
            }
            if(i1 == 2007)
            {
                OpaqueDescriptor opaquedescriptor = OpaqueDescriptor.createDescriptor(resultsetmetadata.getColumnTypeName(l + 1), connection);
                opaquedescriptor.descType(stringbuffer, i + 1);
            } else
            {
                stringbuffer.append(s1);
                stringbuffer.append(resultsetmetadata.getColumnTypeName(l + 1));
                stringbuffer.append("\n");
            }
        }

        String s2 = stringbuffer.substring(0, stringbuffer.length());
        return s2;
    }

    public byte[] toBytes(Object aobj[])
        throws SQLException
    {
        Datum adatum[] = toOracleArray(aobj);
        return toBytes(adatum);
    }

    /**
     * @deprecated Method toBytes is deprecated
     */

    public byte[] toBytes(Datum adatum[])
        throws SQLException
    {
        STRUCT struct = new STRUCT(this, (byte[])null, connection);
        struct.setDatumArray(adatum);
        return pickler.linearize(struct);
    }

    public Datum[] toArray(Object aobj[])
        throws SQLException
    {
        return toOracleArray(aobj);
    }

    public Datum[] toArray(byte abyte0[])
        throws SQLException
    {
        STRUCT struct = new STRUCT(this, abyte0, connection);
        return toOracleArray(struct, false);
    }

    private void initMetaData1()
        throws SQLException
    {
        short word0 = connection.getVersionNumber();
        if(word0 >= 9000)
            initMetaData1_9_0();
        else
            initMetaData1_pre_9_0();
    }

    private void initMetaData1_9_0()
        throws SQLException
    {
        int i = 0;
        synchronized(connection)
        {
            synchronized(this)
            {
                if(numLocalAttrs == -1)
                {
                    PreparedStatement preparedstatement = null;
                    OracleCallableStatement oraclecallablestatement = null;
                    ResultSet resultset = null;
                    int j = -1;
                    try
                    {
                        do
                        {
                            switch(i)
                            {
                            case 0: // '\0'
                                preparedstatement = connection.prepareStatement(initMetaData1_9_0_SQL[i]);
                                preparedstatement.setString(1, getTypeName());
                                preparedstatement.setString(2, getSchemaName());
                                preparedstatement.setFetchSize(1);
                                resultset = preparedstatement.executeQuery();
                                break;

                            case 1: // '\001'
                            case 2: // '\002'
                                try
                                {
                                    oraclecallablestatement = (OracleCallableStatement)connection.prepareCall(initMetaData1_9_0_SQL[i]);
                                    oraclecallablestatement.setString(1, getTypeName());
                                    oraclecallablestatement.registerOutParameter(2, -10);
                                    oraclecallablestatement.execute();
                                    resultset = oraclecallablestatement.getCursor(2);
                                    resultset.setFetchSize(1);
                                }
                                catch(SQLException sqlexception)
                                {
                                    if(sqlexception.getErrorCode() == 1403)
                                    {
                                        if(i == 1)
                                        {
                                            oraclecallablestatement.close();
                                            i++;
                                            continue;
                                        }
                                        DatabaseError.throwSqlException(1, "Inconsistent catalog view");
                                    } else
                                    {
                                        throw sqlexception;
                                    }
                                }
                                break;
                            }
                            if(resultset.next())
                            {
                                isInstanciable = new Boolean(resultset.getString(1).equals("YES"));
                                supertype = resultset.getString(2) + "." + resultset.getString(3);
                                j = resultset.getInt(4);
                                break;
                            }
                            if(i == 2)
                            {
                                DatabaseError.throwSqlException(1, "Inconsistent catalog view");
                            } else
                            {
                                resultset.close();
                                if(oraclecallablestatement != null)
                                    oraclecallablestatement.close();
                                i++;
                            }
                        } while(true);
                    }
                    finally
                    {
                        if(resultset != null)
                            resultset.close();
                        if(preparedstatement != null)
                            preparedstatement.close();
                        if(oraclecallablestatement != null)
                            oraclecallablestatement.close();
                    }
                    numLocalAttrs = j;
                }
            }
        }
    }

    private synchronized void initMetaData1_pre_9_0()
        throws SQLException
    {
        isInstanciable = new Boolean(true);
        supertype = "";
        numLocalAttrs = 0;
    }

    private void initMetaData2()
        throws SQLException
    {
        short word0 = connection.getVersionNumber();
        if(word0 >= 9000)
            initMetaData2_9_0();
        else
            initMetaData2_pre_9_0();
    }

    private void initMetaData2_9_0()
        throws SQLException
    {
        synchronized(connection)
        {
            synchronized(this)
            {
                if(subtypes == null)
                {
                    PreparedStatement preparedstatement = null;
                    ResultSet resultset = null;
                    String as[] = null;
                    try
                    {
                        preparedstatement = connection.prepareStatement("select owner, type_name from all_types where supertype_name = :1 and supertype_owner = :2");
                        preparedstatement.setString(1, getTypeName());
                        preparedstatement.setString(2, getSchemaName());
                        resultset = preparedstatement.executeQuery();
                        Vector vector = new Vector();
                        for(; resultset.next(); vector.addElement(resultset.getString(1) + "." + resultset.getString(2)));
                        as = new String[vector.size()];
                        for(int i = 0; i < as.length; i++)
                            as[i] = (String)vector.elementAt(i);

                        vector.removeAllElements();
                        vector = null;
                    }
                    finally
                    {
                        if(resultset != null)
                            resultset.close();
                        if(preparedstatement != null)
                            preparedstatement.close();
                    }
                    subtypes = as;
                }
            }
        }
    }

    private void initMetaData2_pre_9_0()
        throws SQLException
    {
        subtypes = new String[0];
    }

    private void initMetaData3()
        throws SQLException
    {
        synchronized(connection)
        {
            synchronized(this)
            {
                if(attrJavaNames == null)
                {
                    String as[] = null;
                    PreparedStatement preparedstatement = null;
                    ResultSet resultset = null;
                    try
                    {
                        preparedstatement = connection.prepareStatement("select EXTERNAL_ATTR_NAME from all_sqlj_type_attrs where owner = :1 and type_name = :2");
                        preparedstatement.setString(1, getSchemaName());
                        preparedstatement.setString(2, getTypeName());
                        resultset = preparedstatement.executeQuery();
                        as = new String[getOracleTypeADT().getAttrTypes().length];
                        for(int i = 0; resultset.next(); i++)
                            as[i] = resultset.getString(1);

                    }
                    finally
                    {
                        if(resultset != null)
                            resultset.close();
                        if(preparedstatement != null)
                            preparedstatement.close();
                    }
                    attrJavaNames = as;
                }
            }
        }
    }

    private void writeObject(ObjectOutputStream objectoutputstream)
        throws IOException
    {
    }

    private void readObject(ObjectInputStream objectinputstream)
        throws IOException, ClassNotFoundException
    {
    }

    static final boolean DEBUG = false;
    static final long serialVersionUID = 0xe122c1707c9af97L;
    transient Boolean isInstanciable;
    transient String supertype;
    transient int numLocalAttrs;
    transient String subtypes[];
    transient String attrJavaNames[];
    final int LOCAL_TYPE = 0;
    final int LOOK_FOR_USER_SYNONYM = 1;
    final int LOOK_FOR_PUBLIC_SYNONYM = 2;
    final String initMetaData1_9_0_SQL[] = {
        "SELECT INSTANTIABLE, supertype_owner, supertype_name, LOCAL_ATTRIBUTES FROM all_types WHERE type_name = :1 AND owner = :2 ", "DECLARE \n bind_synonym_name user_synonyms.synonym_name%type := :1; \n the_table_owner  user_synonyms.table_owner%type; \n the_table_name   user_synonyms.table_name%type; \n the_db_link      user_synonyms.db_link%type; \n sql_string       VARCHAR2(1000); \nBEGIN \n   SELECT /*+RULE*/ TABLE_NAME, TABLE_OWNER, DB_LINK INTO  \n         the_table_name, the_table_owner, the_db_link \n         FROM USER_SYNONYMS WHERE \n         SYNONYM_NAME = bind_synonym_name; \n \n   sql_string := 'SELECT /*+RULE*/ INSTANTIABLE, SUPERTYPE_OWNER,      SUPERTYPE_NAME, LOCAL_ATTRIBUTES FROM ALL_TYPES'; \n \n   IF the_db_link IS NOT NULL  \n   THEN \n     sql_string := sql_string || '@' || the_db_link; \n   END IF; \n   sql_string := sql_string       || ' WHERE TYPE_NAME = '''       || the_table_name   || ''' AND OWNER = '''       || the_table_owner  || ''''; \n   OPEN :2 FOR sql_string; \nEND;", "DECLARE \n bind_synonym_name user_synonyms.synonym_name%type := :1; \n the_table_owner  user_synonyms.table_owner%type; \n the_table_name   user_synonyms.table_name%type; \n the_db_link      user_synonyms.db_link%type; \n sql_string       VARCHAR2(1000); \nBEGIN \n   SELECT /*+RULE*/ TABLE_NAME, TABLE_OWNER, DB_LINK INTO  \n         the_table_name, the_table_owner, the_db_link \n         FROM ALL_SYNONYMS WHERE \n         OWNER = 'PUBLIC' AND \n         SYNONYM_NAME = bind_synonym_name; \n \n   sql_string := 'SELECT /*+RULE*/ INSTANTIABLE, SUPERTYPE_OWNER,      SUPERTYPE_NAME, LOCAL_ATTRIBUTES FROM ALL_TYPES'; \n \n   IF the_db_link IS NOT NULL  \n   THEN \n     sql_string := sql_string || '@' || the_db_link; \n   END IF; \n   sql_string := sql_string       || ' WHERE TYPE_NAME = '''       || the_table_name   || ''' AND OWNER = '''       || the_table_owner  || ''''; \n   OPEN :2 FOR sql_string; \nEND;"
    };
    private static final String _Copyright_2004_Oracle_All_Rights_Reserved_ = null;
    public static final boolean TRACE = false;
    public static final boolean PRIVATE_TRACE = false;
    public static final String BUILD_DATE = "Sat_Feb__2_11:39:33_PST_2008";

}
