// Decompiled by Jad v1.5.8g. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.kpdus.com/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   TypeDescriptor.java

package oracle.sql;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.Serializable;
import java.io.StringWriter;
import java.sql.Connection;
import java.sql.SQLException;
import oracle.jdbc.OracleConnection;
import oracle.jdbc.driver.DatabaseError;
import oracle.jdbc.oracore.OracleNamedType;
import oracle.jdbc.oracore.OracleTypeADT;
import oracle.jdbc.oracore.OracleTypeCOLLECTION;
import oracle.jdbc.oracore.OracleTypeOPAQUE;

// Referenced classes of package oracle.sql:
//            SQLName, StructDescriptor, ArrayDescriptor, OpaqueDescriptor

public abstract class TypeDescriptor
    implements Serializable
{

    protected TypeDescriptor()
    {
    }

    protected TypeDescriptor(String s, Connection connection1)
        throws SQLException
    {
        if(s == null || connection1 == null)
            DatabaseError.throwSqlException(60, "Invalid arguments");
        setPhysicalConnectionOf(connection1);
        sqlName = new SQLName(s, getInternalConnection());
    }

    protected TypeDescriptor(SQLName sqlname, Connection connection1)
        throws SQLException
    {
        if(sqlname == null || connection1 == null)
            DatabaseError.throwSqlException(60, "Invalid arguments");
        sqlName = sqlname;
        setPhysicalConnectionOf(connection1);
    }

    protected TypeDescriptor(SQLName sqlname, OracleTypeADT oracletypeadt, Connection connection1)
        throws SQLException
    {
        if(sqlname == null || oracletypeadt == null || connection1 == null)
            DatabaseError.throwSqlException(60, "Invalid arguments");
        sqlName = sqlname;
        setPhysicalConnectionOf(connection1);
        pickler = oracletypeadt;
        pickler.setDescriptor(this);
    }

    protected TypeDescriptor(OracleTypeADT oracletypeadt, Connection connection1)
        throws SQLException
    {
        if(oracletypeadt == null || connection1 == null)
            DatabaseError.throwSqlException(60, "Invalid arguments");
        setPhysicalConnectionOf(connection1);
        sqlName = null;
        pickler = oracletypeadt;
        pickler.setDescriptor(this);
    }

    public synchronized String getName()
        throws SQLException
    {
        if(sqlName == null)
            initSQLName();
        String s = sqlName.getName();
        return s;
    }

    public synchronized SQLName getSQLName()
        throws SQLException
    {
        if(sqlName == null)
            initSQLName();
        return sqlName;
    }

    void initSQLName()
        throws SQLException
    {
        if(pickler == null || getInternalConnection() == null)
            DatabaseError.throwSqlException(1);
        sqlName = new SQLName(pickler.getFullName(), getInternalConnection());
    }

    public String getSchemaName()
        throws SQLException
    {
        String s = getSQLName().getSchema();
        return s;
    }

    public String getTypeName()
        throws SQLException
    {
        String s = getSQLName().getSimpleName();
        return s;
    }

    public OracleNamedType getPickler()
    {
        return pickler;
    }

    public oracle.jdbc.internal.OracleConnection getInternalConnection()
    {
        return connection;
    }

    public void setPhysicalConnectionOf(Connection connection1)
    {
        connection = ((OracleConnection)connection1).physicalConnectionWithin();
    }

    public abstract int getTypeCode()
        throws SQLException;

    public static TypeDescriptor getTypeDescriptor(String s, OracleConnection oracleconnection)
        throws SQLException
    {
        Object obj = null;
        try
        {
            SQLName sqlname = new SQLName(s, oracleconnection);
            String s1 = sqlname.getName();
            obj = (TypeDescriptor)oracleconnection.getDescriptor(s1);
            if(obj == null)
            {
                OracleTypeADT oracletypeadt = new OracleTypeADT(s1, oracleconnection);
                oracle.jdbc.internal.OracleConnection oracleconnection1 = (oracle.jdbc.internal.OracleConnection)oracleconnection;
                oracletypeadt.init(oracleconnection1);
                OracleNamedType oraclenamedtype = oracletypeadt.cleanup();
                switch(oraclenamedtype.getTypeCode())
                {
                case 2002: 
                case 2008: 
                    obj = new StructDescriptor(sqlname, (OracleTypeADT)oraclenamedtype, oracleconnection);
                    break;

                case 2003: 
                    obj = new ArrayDescriptor(sqlname, (OracleTypeCOLLECTION)oraclenamedtype, oracleconnection);
                    break;

                case 2007: 
                    obj = new OpaqueDescriptor(sqlname, (OracleTypeOPAQUE)oraclenamedtype, oracleconnection);
                    break;

                case 2004: 
                case 2005: 
                case 2006: 
                default:
                    DatabaseError.throwSqlException(1);
                    break;
                }
                oracleconnection.putDescriptor(s1, obj);
                oraclenamedtype.setDescriptor(((TypeDescriptor) (obj)));
            }
        }
        catch(Exception exception)
        {
            if(exception instanceof SQLException)
                DatabaseError.throwSqlException((SQLException)exception, 60, "Unable to resolve type \"" + s + "\"");
            else
                DatabaseError.throwSqlException(60, "Unable to resolve type \"" + s + "\"");
        }
        return ((TypeDescriptor) (obj));
    }

    public static TypeDescriptor getTypeDescriptor(String s, OracleConnection oracleconnection, byte abyte0[], long l)
        throws SQLException
    {
        Object obj = null;
        byte abyte1[][] = new byte[1][];
        String s1 = getSubtypeName(oracleconnection, abyte0, l);
        if(s1 == null)
            s1 = s;
        obj = (TypeDescriptor)oracleconnection.getDescriptor(s1);
        if(obj == null)
        {
            SQLName sqlname = new SQLName(s1, oracleconnection);
            OracleTypeADT oracletypeadt = new OracleTypeADT(s1, oracleconnection);
            oracle.jdbc.internal.OracleConnection oracleconnection1 = (oracle.jdbc.internal.OracleConnection)oracleconnection;
            oracletypeadt.init(oracleconnection1);
            OracleNamedType oraclenamedtype = oracletypeadt.cleanup();
            switch(oraclenamedtype.getTypeCode())
            {
            case 2002: 
            case 2008: 
                obj = new StructDescriptor(sqlname, (OracleTypeADT)oraclenamedtype, oracleconnection);
                break;

            case 2003: 
                obj = new ArrayDescriptor(sqlname, (OracleTypeCOLLECTION)oraclenamedtype, oracleconnection);
                break;

            case 2007: 
                obj = new OpaqueDescriptor(sqlname, (OracleTypeOPAQUE)oraclenamedtype, oracleconnection);
                break;

            case 2004: 
            case 2005: 
            case 2006: 
            default:
                DatabaseError.throwSqlException(1);
                break;
            }
            oracleconnection.putDescriptor(s1, obj);
        }
        return ((TypeDescriptor) (obj));
    }

    public boolean isInHierarchyOf(String s)
        throws SQLException
    {
        return false;
    }

    private void writeObject(ObjectOutputStream objectoutputstream)
        throws IOException
    {
        try
        {
            if(sqlName == null)
                initSQLName();
        }
        catch(SQLException sqlexception)
        {
            DatabaseError.SQLToIOException(sqlexception);
        }
        objectoutputstream.writeObject(sqlName);
        objectoutputstream.writeObject(pickler);
    }

    private void readObject(ObjectInputStream objectinputstream)
        throws IOException, ClassNotFoundException
    {
        sqlName = (SQLName)objectinputstream.readObject();
        pickler = (OracleNamedType)objectinputstream.readObject();
    }

    public void setConnection(Connection connection1)
        throws SQLException
    {
        setPhysicalConnectionOf(connection1);
        pickler.setConnection(getInternalConnection());
    }

    public static String getSubtypeName(OracleConnection oracleconnection, byte abyte0[], long l)
        throws SQLException
    {
        if(abyte0 == null || abyte0.length == 0 || oracleconnection == null)
            DatabaseError.throwSqlException(68);
        String s = OracleTypeADT.getSubtypeName(oracleconnection, abyte0, l);
        return s;
    }

    public void initMetadataRecursively()
        throws SQLException
    {
        if(pickler != null)
            pickler.initMetadataRecursively();
    }

    public void initNamesRecursively()
        throws SQLException
    {
        if(pickler != null)
            pickler.initNamesRecursively();
    }

    public void fixupConnection(oracle.jdbc.internal.OracleConnection oracleconnection)
        throws SQLException
    {
        if(connection == null)
            connection = oracleconnection;
        if(pickler != null)
            pickler.fixupConnection(oracleconnection);
    }

    public String toXMLString()
        throws SQLException
    {
        StringWriter stringwriter = new StringWriter();
        PrintWriter printwriter = new PrintWriter(stringwriter);
        printXMLHeader(printwriter);
        printXML(printwriter, 0);
        return stringwriter.getBuffer().substring(0);
    }

    public void printXML(PrintStream printstream)
        throws SQLException
    {
        PrintWriter printwriter = new PrintWriter(printstream, true);
        printXMLHeader(printwriter);
        printXML(printwriter, 0);
    }

    void printXML(PrintWriter printwriter, int i)
        throws SQLException
    {
        String s = getClass().getName();
        int j = hashCode();
        printwriter.println("<" + s + " hashCode=\"" + j + "\" >");
        if(pickler != null)
            pickler.printXML(printwriter, i + 1);
        printwriter.println("</" + s + ">");
    }

    void printXMLHeader(PrintWriter printwriter)
        throws SQLException
    {
        printwriter.println("<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>");
    }

    public static boolean DEBUG_SERIALIZATION = false;
    static final long serialVersionUID = 0x1c11b6d24ed1cf6bL;
    SQLName sqlName;
    OracleNamedType pickler;
    transient oracle.jdbc.internal.OracleConnection connection;
    private static final String _Copyright_2004_Oracle_All_Rights_Reserved_ = null;
    public static final boolean TRACE = false;
    public static final boolean PRIVATE_TRACE = false;
    public static final String BUILD_DATE = "Sat_Feb__2_11:39:33_PST_2008";

}
